window.SupportsTouches = ('createTouch' in document);
window.StartEventType = SupportsTouches ? 'touchstart' : 'mousedown';
window.MoveEventType = SupportsTouches ? 'touchmove' : 'mousemove';
window.EndEventType = SupportsTouches ? 'touchend' : 'mouseup';
window.Hover = SupportsTouches ? undefined : 'mouseover';
window.Leave = SupportsTouches ? undefined : 'mouseleave';

window.comp_color = {
	'weblink' : '#b0c4de'
}





function clearSelection() {
    if ( document.selection ) {
        document.selection.empty();
    } else if ( window.getSelection ) {
        window.getSelection().removeAllRanges();
    }
};

function fireEvent(element,event){
    if (document.createEventObject){
    var evt = document.createEventObject();
    return element.fireEvent('on'+event,evt)
    }
    else{
    var evt = document.createEvent("HTMLEvents");
    evt.initEvent(event, true, true ); 
    return !element.dispatchEvent(evt);
    }
};

var common_event_listnerEx = function(_eventMode, _elementSrc, _elementDst, _move_callback, _resize_callback)
{
	var self = this;
	this.dnPos = {};
	this.upPos = {};
	this.eventMode = _eventMode;
	this.element = _elementSrc;
	this.elementDst = _elementDst;

	this.start_evt = function(event)
	{
		clearSelection();

		if(self.elementDst.mode != undefined)
			return ;
		
		event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

        if(self.element.className.indexOf('logger component') == -1 && last_zIndex != Number(self.elementDst.style.zIndex))
			self.elementDst.style.zIndex = (++last_zIndex);

		if (self.eventMode == 'move') {	
			self.dnPos = {  x: event.pageX - self.elementDst.style.left.replace('px', ''), 
							y: event.pageY - self.elementDst.style.top.replace('px', '') };
		}
		else{
			self.dnPos = {  x: event.pageX, y: event.pageY };

			self._w = Number(self.elementDst.style.width.replace('px', ''));
			self._h = Number(self.elementDst.style.height.replace('px', ''));
			
			console.log(self._w + ',' + self._h);
		}

		self.dnPos['event'] = event;

		self.bsaeCuror = self.element.style.cursor;

		window.addEventListener(MoveEventType, self.move_evt, false);
		window.addEventListener(EndEventType, self.end_evt, false);
	};

	this.move_evt = function(event)
	{
	    event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

        if (self.eventMode == 'move') {
        	if(_move_callback != undefined )
        	{	
        		_move_callback(self);
        		return;
        	}
	        self.elementDst.style.left = event.pageX - self.dnPos.x + 'px';
	        self.elementDst.style.top = event.pageY - self.dnPos.y + 'px';
			self.element.style.cursor = 'move';
        }
        else {
        	if(_resize_callback != undefined )
        	{	
        		_resize_callback(self);
        		return;
        	}
            self.elementDst.style.width = (self._w + (event.pageX - self.dnPos.x)) + 'px';
            self.elementDst.style.height = (self._h + (event.pageY - self.dnPos.y)) + 'px';
        }			
	};

	this.end_evt = function(event)
	{
		event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

		self.upPos = {  x: event.pageX - self.elementDst.style.left.replace('px', ''), 
						y: event.pageY - self.elementDst.style.top.replace('px', '') };

		self.upPos['event'] = event;

		if(self.dnPos.event.pageX  == self.upPos.event.pageX  && self.dnPos.event.pageY == self.upPos.event.pageY)
		{
			console.log('element click');
			if(self.elementDst['mousedown'] != undefined)
			{
				self.elementDst['mousedown'](event);
			}
		}

		self.element.style.cursor = self.bsaeCuror;
		window.removeEventListener(MoveEventType, self.move_evt, false);
		window.removeEventListener(EndEventType, self.end_evt, false);
	};

	this.element.addEventListener(StartEventType, this.start_evt, false);
};

var resize_event_listner = function(_elementSrc, _elementDst, _callback)
{
	var self = this;
	this.dnPos = {};
	this.upPos = {};
	this.element = _elementSrc;
	this.elementDst = _elementDst;

	this.start_evt = function(event)
	{
		self.elementDst.mode = 'resize';

		clearSelection();

		event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

		self.dnPos = {  x: event.pageX, y: event.pageY };

		self._w = Number(self.elementDst.style.width.replace('px', ''));
		self._h = Number(self.elementDst.style.height.replace('px', ''));
		
		self.dnPos['event'] = event;

		self.bodyCursor = document.body.style.cursor;
		document.body.style.cursor = self.element.style.cursor;

		window.addEventListener(MoveEventType, self.move_evt, false);
		window.addEventListener(EndEventType, self.end_evt, false);
	};

	this.move_evt = function(event)
	{
	    event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

    	if(_callback != undefined )
    	{	
    		_callback(self, event);
    		return;
    	}

        self.elementDst.style.width = (self._w + (event.pageX - self.dnPos.x)) + 'px';
        self.elementDst.style.height = (self._h + (event.pageY - self.dnPos.y)) + 'px';
	};

	this.end_evt = function(event)
	{
		self.elementDst.mode = undefined;

		event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

		self.upPos = {  x: event.pageX - self.elementDst.style.left.replace('px', ''), 
						y: event.pageY - self.elementDst.style.top.replace('px', '') };

		self.upPos['event'] = event;

		document.body.style.cursor = self.bodyCursor;

		window.removeEventListener(MoveEventType, self.move_evt, false);
		window.removeEventListener(EndEventType, self.end_evt, false);
	};

	this.element.addEventListener(StartEventType, this.start_evt, false);
};


/*
var common_event_listner = function(_eventMode, _element)
{
	var self = this;
	this.dnPos = {};
	this.upPos = {};
	this.eventMode = _eventMode;
	this.element = _elementSrc;

	this.start_evt = function(event)
	{
		event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

		self.dnPos = {  x: event.pageX - self.element.style.left.replace('px', ''), 
						y: event.pageY - self.element.style.top.replace('px', '') };
		
		self.dnPos['event'] = event;

		if (self.eventMode == 'move') {	
			self._w = self.element.width;
			self._h = self.element.height;
		}

		self.bsaeCuror = self.element.style.cursor;

		window.addEventListener(MoveEventType, self.move_evt, false);
		window.addEventListener(EndEventType, self.end_evt, false);
	};

	this.move_evt = function(event)
	{
	    event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;

        self.element.style.left = event.pageX - self.dnPos.x + 'px';
        self.element.style.top = event.pageY - self.dnPos.y + 'px';

        if (self.eventMode == 'move') {
				self.element.style.cursor = 'move';
        }
        else {
            self.element.width = self._w + (event.pageX - self.dnPos.x);
            self.element.height = self._h + (event.pageY - self.dnPos.y);
        }			
	};

	this.end_evt = function(event)
	{
		event.preventDefault();

		if (SupportsTouches)
    		if (event.touches)
        		event = (event.touches.length > 0) ? event.touches[0] : event;


		self.upPos = {  x: event.pageX - self.element.style.left.replace('px', ''), 
						y: event.pageY - self.element.style.top.replace('px', '') };

		self.upPos['event'] = event;

		if(self.dnPos.event.pageX  == self.upPos.event.pageX  && self.dnPos.event.pageY == self.upPos.event.pageY)
		{
			console.log('element click');
			if(self.element['mousedown'] != undefined)
			{
				self.element['mousedown'](event);
			}
		}

		self.element.style.cursor = self.bsaeCuror;
		window.removeEventListener(MoveEventType, self.move_evt, false);
		window.removeEventListener(EndEventType, self.end_evt, false);
	}

	this.element.addEventListener(StartEventType, this.start_evt, false);
}
*/