var userAgent = navigator.userAgent.toLowerCase();
var ios = (/iPhone/i).test(userAgent) || (/iPod/i).test(userAgent) || (/iPad/i).test(userAgent);
var android = (/(?=.*\bAndroid\b)(?=.*\bMobile\b)/i).test(userAgent) || (/Android/i).test(userAgent);

(function() {
  var proxied = window.alert;
  window.alert = function() {
	// do something here
	return proxied.apply(this, arguments);
  };
})();

window['UTIL'] = {

	color2rgba: function (colorref, alpha) {
		if (alpha == null) {
			return color2rgbaEx(colorref);
		}

		var r = colorref.substr(1, 2);
		var g = colorref.substr(3, 2);
		var b = colorref.substr(5, 2);

		var rgba = "rgba(" + parseInt(r, 16).toString(10) + ", " + parseInt(g, 16).toString(10) + ", " + parseInt(b, 16).toString(10) + ", " + alpha + ")";
		return rgba;
	},

	stringSplit : function (strData, strIndex) { 
		var stringList = new Array(); 

		while(strData.indexOf(strIndex) != -1) {
			stringList[stringList.length] = strData.substring(0, strData.indexOf(strIndex)); 
			strData = strData.substring(strData.indexOf(strIndex)+(strIndex.length), strData.length); 
		} 

		stringList[stringList.length] = strData; 

		return stringList; 
	},

}

window.isViewPort = false;
window.docWidth = undefined; 
window.docHeight = undefined; 

try{
	var content = $('meta[name=viewport][content]').attr('content')
	window.docWidth = UTIL.stringSplit(content, ",")[0]; 
	window.docHeight = UTIL.stringSplit(content, ",")[1]; 
	docWidth = docWidth.substring(docWidth.indexOf('=')+1);
	docHeight = docHeight.substring(docHeight.indexOf('=')+1);

	if (!isNaN(docWidth) && !isNaN(docHeight))
		isViewPort = true;
}
catch(e) { /*console.log(e.toString() + '\n\n [ found not meta viewport ]')*/};

var clientWidth = (isViewPort) ? docWidth : document.documentElement.clientWidth,
	clientHeight = (isViewPort) ? docHeight : document.documentElement.clientHeight;

var isiPad = false;
if (navigator.userAgent.match(/iPad/i) || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/webOS/i)) { 
	isiPad = true; 
}

Array.prototype.push = (function () {
	var original = Array.prototype.push;
	return function() {
		//Do what you want here.
		original.apply(this,arguments);

		return this[this.length -1];
	};
})();

if (window['console'] == undefined) {
	window.console = {};
	window.console.log = function () {}
}

var getAgent = (function(ua) {
	return function(){return(is('MSIE')?(is('MSIE 10.0')?'ie10':is('MSIE 9.0')?'ie9':is('MSIE 8.0')?'ie8':is('MSIE 7.0')?'ie7':'explorer'):is('Firefox')?'firefox':is('Chrome')?'chrome':is('Safari')?'safari':is('Opera')?'opera':(is('rv:')&&is('like Gecko'))?'ie'+ua.substring(ua.indexOf('rv:')+3,ua.indexOf(')')-2):'etc')};function is(str){return ua.indexOf(str)!=-1}
})(navigator.userAgent)();

if(getAgent.toLowerCase() == 'ie7' 
	|| getAgent.toLowerCase() == 'ie8'
	|| getAgent.toLowerCase() == 'ie9' 
	|| getAgent.toLowerCase() == 'ie10')
	window.IsExcept = 0;
else
	window.IsExcept = undefined;

function addFunction (_proto, funcList) {
	for(var func in funcList) {
		_proto[func] = funcList[func];
	}
};

var max_log_count = 10;

function addtext (element, what) {
if (document.createTextNode) {
		var mytext = document.createTextNode(what);
		element.appendChild(mytext);
	}
};

window.log = function () {
	if (!document.createTextNode) {return;}

	log.show_log = function () {
		if(console['table'] != undefined)
		console.table(log.data);
	};

	function save_log (_arguments) {
	if (window.log.data == undefined)
		window.log.data = {};

	var _tag, _log, _background;

	if (_arguments.length == 1) {
		_tag = 'global';
		_log = _arguments[0];
	} else {
		_tag = _arguments[0];
		_log = _arguments[1];
	}

   	if (log.data[_tag] == undefined)
		log.data[_tag] = new Array();

		log.data[_tag].push(_log); 
  	};

  	var logger = document.getElementsByClassName('logger')[0];
 	var loggerBody = document.getElementById('logger_body');

  	if (logger == undefined) {
	 	logger =  div_component();

		logger.className = 'logger component';
		logger.style.width = '300px';
		logger.style.height = '300px';
		logger.style.background = '#000000';
		logger.style.position = 'absolute';
		logger.style.top = '0px';
		//logger.style.left =  (document.documentElement.clientWidth - logger.style.width.replace('px','') )  + 'px' ;
		logger.style.left = '0px';
		logger.style.zIndex = '99999';
		logger.style.direction = 'ltr';
		logger.style.textAlign = 'left';
		logger.style.fontSize = '10pt'
		logger.style.color = 'white';
		logger.style.opacity = '0.4';
		logger.style.lineHeight = '15pt';
		logger.style.padding = '5pt';
		logger.pointerEvents = 'none';
		// 안보이도록 하자
		logger.style.display='none';

		loggerBody = div_component();
		loggerBody.id = 'logger_body';
		loggerBody.style.overflow = 'auto';
		loggerBody.style.padding = '5pt';
		loggerBody.style.width = '100%';
		loggerBody.style.height = '100%';

		logger.appendChild(loggerBody);

		_background = div_component();
		_background.style.display='none';
		_background.style.background = '#000000';
		_background.style.opacity = 0.1;

		document.body.appendChild(logger);
		document.body.appendChild(_background);
	  
	 	loggerBody.addEventListener(StartEventType, function(){_background.style.display='block';}, false);
	 	loggerBody.addEventListener(EndEventType, function(){_background.style.display='none';}, false);

	  	addon2resize(logger);
	  	addon2move(logger, logger);

		/*logger.addEventListener(StartEventType, function () {
			_background.style.display = 'block';
		}, false);

		logger.addEventListener(EndEventType, function () {
			_background.style.display = 'none';
		}, false);*/
	};

	function opentextarea (_logger) {
		var fGroup = div_component();
		fGroup.style.width = (Number(_logger.style.width.replace('px', '')) + 15) + 'px';
		fGroup.style.height = '30px';
		fGroup.style.position = 'absolute';
		fGroup.style.background = '#ff0000';
		fGroup.style.zIndex = '99999';

		var input = document.createElement('textarea');
		input.style.position = 'absolute';
		input.style.width = 'calc(100% - 55px)';
		if (input.style.width == '') {
			input.style.width = '100%';
		}
		input.style.height = '24px';
		input.style.resize = 'none';
		input.style.left = '0px';

		input.addEventListener('keydown', function (e) {
			if (event.which == 13 && input.value.length > 0) {
				eval(input.value);
				input.value = '';
				input.focus();
			}
		});

		var button = document.createElement('button');
		button.style.width = '50px';
		button.style.height = '30px';
		button.style.left = 'calc(100% - 49px)';

		if (button.style.left == '') {
			button.style.left = '100%';
			button.style.marginLeft = '-49px';
		}

		button.style.position = 'absolute';
		button.style.cursor = 'pointer';
		button.innerHTML = 'RUN';

		button.onclick = function () {
			eval(input.value);
			input.value = '';
			input.focus();
		};

		var jquery = document.createElement('button');
		jquery.style.width = '80px';
		jquery.style.height = '30px';
		jquery.style.left = '0px';
		jquery.style.top = '30px';
		jquery.style.position = 'absolute';
		jquery.style.cursor = 'pointer';
		jquery.innerHTML = 'JQuery';

		jquery.onclick = function () {
			var ga = document.createElement('script');
			ga.type = 'text/javascript';
			ga.async = true;
			ga.src = 'http://code.jquery.com/jquery-latest.js';
			ga.charset = 'euc-kr';
			ga.onreadystatechange = ga.onload = function () {
				console.log('callback.done : ' + ga.readyState);
				console.log('loaded script : ' + ga.src);
				if ($ != undefined) console.log('jquery version : ' + jQuery.fn.jquery)
			};
			document.head.appendChild(ga)
		};

		fGroup.appendChild(input);
		fGroup.appendChild(button);
		fGroup.appendChild(jquery);
		document.body.appendChild(fGroup);

		function setpos() {
			fGroup.style.width = (Number(_logger.style.width.replace('px', '')) + 15) + 'px';
			fGroup.style.left = _logger.style.left;
			fGroup.style.top = (Number(_logger.style.top.replace('px', '')) + Number(_logger.style.height.replace('px', '')) + Number(fGroup.style.height.replace('px', '')) - 10) + 'px';
		};

		_logger.addEventListener(MoveEventType, function () {
			if (_background.style.display == 'block') {
				setpos();
			}
		}, false);

		setpos();
	};

	//opentextarea(logger);

	var line_number;
	var preves = logger.getElementsByTagName('prev');
	line_number = ((preves[0] == undefined) ? 0 : preves.length) + 1;

	if (window['console'] != undefined)
		//console.log('max_log_count : ' + line_number + ' / ' + max_log_count);

	var content = document.createElement('prev');
	content.style.display = 'inline';
	content.style.background = 'black';
	content.style.fontSize = '11px';
	content.style.margin = '0';

	if (arguments.length == 1)
		addtext(content, line_number + '] ' + arguments[0]);
	else
		addtext(content, line_number + '] ' + arguments[0] + ' : ' + arguments[1]);

	save_log(arguments);

	loggerBody.insertBefore(document.createElement('br'), loggerBody.firstChild);
	loggerBody.insertBefore(content, loggerBody.firstChild);
};

window.clear_component = function () {
	console.log('clear component : ' + document.getElementsByClassName('component').length);

	var component_list = document.getElementsByClassName('component');

	while (component_list.length != 0)
		component_list[component_list.length-1].parentNode.removeChild(component_list[component_list.length-1]);

	console.log('remain component : ' + document.getElementsByClassName('component').length);
}

var common_func = {
	setEvent: function (_action) {
		if (_action.indexOf('move') != -1) {
			this.element._event = new common_event_listnerEx('move', this.elementChild, this.element); 
		}

		if (_action.indexOf('resize') != -1) {

		}

		if (_action == "move") {
			
		} else if (_action == "resize") {

		}
	},
	setEdit : function (_mode) {
		if (_mode.indexOf('move') != -1) {

		}

		if (_mode.indexOf('resize') != -1) {

		}
	},
	show : function () {
		this.element.style.display = 'block';
	},
	hide : function () {
		this.element.style.display = 'none';
	},
	getStyle : function () {
		return this.element.style;    	
	},
	setWidth : function (_width) {
		this.element.style.width = _width + 'px';
	},
	getWidth : function () {
		return this.element.style.width.replace('px','');
	},
	setHeight : function (_height) {
		this.element.style.height = _height + 'px';
	},
	getHeight : function () {
		return this.element.style.height.replace('px','');
	},
	setLeft : function (_left) {
		this.element.style.left = _left + 'px';
	},
	getLeft : function () {
		return this.element.style.left.replace('px', '');
	},
	setTop : function (_top) {
		this.element.style.top = _top + 'px';
	},    
	getTop : function (_top) {
		return this.element.style.top.replace('px', '');
	},    
	setPos : function (_left, _top) {
		this.setLeft(_left);
		this.setTop(_top);
	},
	getPos : function () {
		return {left:this.getLeft(), top:this.getTop()};
	},
	setSize : function (_width, _height) {
		this.setWidth(_width);
		this.setHeight(_height);
	},
	getSize : function () {
		return {width:this.getWidth(), height:this.getHeight()};
	},
	centerPos : function (_always) {
		var self = this;
		var center = function () {
			var left = clientWidth/2 - self.element.style.width.replace('px','')/2;
			var top = clientHeight/2 - self.element.style.height.replace('px','')/2;

			self.element.style.left = left + 'px';
			self.element.style.top = top + 'px';
		}

		if (_always != undefined) {
			window.addEventListener('resize', function() {
				center();
			});
		}

		center();
	},
	setToggleByID : function (_action, _id) {
		var self = this;
		this.element.style.cursor = 'pointer';
		var element = document.getElementById(_id);
		this.element[_action] = function () {
			element.style.display = (element.style.display == 'none') ? 'block' : 'none';
		};

		self.element.addEventListener(StartEventType, function () {
			if(self.element['_event'] == undefined) {
				self.element[_action]();
			}
		});
	},
	setToggleByClassName : function (_action, _classname) {
		var self = this;
		this.element.style.cursor = 'pointer';
		var elements = document.getElementsByClassName(_classname);
		this.element[_action] = function () {
			self.toggle(elements);
		};

		self.element.addEventListener(StartEventType, function () {
			if (self.element['_event'] == undefined) {
				self.element[_action]();
			}
		});
	},
	setToggleByTagName : function (_action, _tagname) {
		var self = this;
		this.element.style.cursor = 'pointer';
		var elements = document.getElementsByTagName(_tagname);

		if (_action == 'mousedown' || _action == 'mouseup' ) {
			this.element[_action] = function() {
				self.toggle(elements);
			};

			self.element.addEventListener(StartEventType, function() {
				if (self.element['_event'] == undefined) {
					self.element[_action]();
				}
			});
		} else {
			this.element.addEventListener(_action, function() {
				self.toggle(elements);
			});
		}
	}, 
	toggle : function(_elements) {
		var self = this;
		for(var i = 0 ; i < _elements.length; i ++){
			if(self.element == _elements[i] || self.elementChild == _elements[i])
				continue;

		  _elements[i].style.display = (_elements[i].style.display == 'none') ? 'block' : 'none';
		}
	},
	setPopupImage : function(_image_src, _width, _height) {
		if(_width <= 0 )
			_width = undefined;

		if(_height <= 0 )
			_height = undefined;

		var self = this;
		self.element.style.cursor = 'pointer';
		self.element['mousedown'] = function() {
			self.hide();
			self.popup.show();
		};

		self.popup = new popup_image(pathConverter(_image_src),
			 _width, _height, undefined, undefined, function() {
			self.show();
		 });

		self.popup.hide();

		self.element.addEventListener(StartEventType, function() {
			if(self.element['_event'] == undefined) {
				self.element['mousedown']();
			}
		});
	},
	release : function () {
		window._component.push(this);
		this.element.id = this.constructor() + window._component.length;
		this.element.className = 'component';
		return this;
	}
}

var set_popup_image = function (_target_id, _popup_image_url, _width, _height, _border_css, _call_opened, _call_closed) {
	var element = document.getElementById(_target_id);

	if (element == null) {
		console.log('not found element : ' + _target_id);
		return null;
	}

	element.style.cursor = 'pointer';
	element.style.border = _border_css;
	element._popup01 = new popup_image(pathConverter(_popup_image_url), _width, _height, function () {
		element.addEventListener('click', function() {

			if(element._popup01.isVisible()) {
				element._popup01.hide();
			} else {
				element._popup01.show();
			}
		});
	}, _call_opened, _call_closed);

	return element._popup01;
}

var set_popup_audio_internal = function (_target_id, _popup_audio_url, _width, _height, _border_css, _call_opened, _call_closed) {
	var element = document.getElementById(_target_id);

	if(element == null) {
		console.log('not found element : ' + _target_id);
		return null;
	}

	element.style.cursor = 'pointer';

	if(_border_css != null)
		element.style.border = _border_css;

	element._popup01 = new popup_audio(_target_id, _popup_audio_url, _width, _height, function () {
		element.addEventListener('click', function() {

			if(element._popup01.isVisible()) {
				element._popup01.hide();
			} else {
				element._popup01.show();
				element._popup01.sub_object.centerPos(true);
			}
		});
	}, _call_opened, _call_closed);

	return element._popup01;
}

var set_popup_audio = function (_target_id, _popup_audio_url, _play, _loop) {
	var _call_opened = function (_this) {
		if (ios && setMinHeight != null && setMinHeight != undefined) {
			_this.sub_object._audio.style.minHeight = setMinHeight + 'px';
		}
		if(_play) _this.play();
		if(_loop) _this.sub_object._audio.setAttribute('loop', 'loop');
	};

	var ret = set_popup_audio_internal(_target_id, pathConverter(_popup_audio_url), 0, 0, null, _call_opened);
	return ret;
}

var set_popup_video = function (_target_id, _popup_video_url, _width, _height, _border_css, _call_opened, _call_closed) {
	var element = document.getElementById(_target_id);

	if (element === null) {
		console.log('not found element : ' + _target_id);
		return null;
	}

	element.style.cursor = 'pointer';
	element.style.border = _border_css;
	element._popup01 = new popup_video(pathConverter(_popup_video_url), _width, _height, function () {
		element.addEventListener('click', function(){
			try{
				if (element._popup01.isVisible()) {
					element._popup01.hide();
				} else {
					element._popup01.show();
					element._popup01.sub_object.centerPos(true);
					//element._popup01.centerPos(true);
				}
			} catch(e) {
				alert(e.toString());
			}
		});
	}, _call_opened, _call_closed);

	return element._popup01;
}

var addon2resize = function(_element, _subelement) {
	if (IsExcept != undefined) {
		if (_subelement == undefined) {
			if (_element.getElementsByTagName('video').length > 0)
				_subelement = _element.getElementsByTagName('video')[0]
		}
		if (_subelement != undefined) {
			_subelement['resize'] = function(_elem) {
				this.style.width = _elem.style.width;
				this.style.height = _elem.style.height;
			};
		}
	}

	var width = 10, height = 10;
	var width_limit = 50, height_limit = 50;
	_element.pointers = new Array();
	var makePointElement = function() {
		var point = div_component();
		point.id = 'pointer' + _element.pointers.length;
		point.className = '_pointer';
		point.style.background  = '#000000'
		point.style.opacity = 0.5;
		point.style.width = width + 'px';
		point.style.height = height + 'px';

		if (IsExcept != undefined) {
			var img = document.createElement('img');
			img.style.position = 'absolute';
			img.style.background = '#ff0000';
			img.style.border = 'solid 1px #ff0000';
			img.style.width = '100%';
			img.style.height = '100%';
			point.appendChild(img);
		}

		return point;
	}

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'nw-resize';
	point.style.left = (-width/2) + 'px';
	point.style.top = (-height/2) + 'px';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 11-HOUR */
		var distanceX = _this.dnPos.x - _event.pageX;
		if((_this._w + distanceX) >= width_limit) {
			_this.elementDst.style.left = ( _this.dnPos.x - (distanceX)) + 'px';
			_this.elementDst.style.width = (_this._w + (distanceX)) + 'px';
		}

		var distanceY = _this.dnPos.y - _event.pageY;
		if((_this._h + distanceY) >= height_limit) {
			_this.elementDst.style.top = ( _this.dnPos.y - (distanceY)) + 'px';
			_this.elementDst.style.height = (_this._h + (distanceY)) + 'px';
		}

		if(_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'n-resize';
	point.style.left = '50%';
	point.style.top = (-height/2) + 'px';
	point.style.marginLeft = (-width/2) + 'px';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 12-HOUR */
		var distanceY = _this.dnPos.y - _event.pageY;

		if((_this._h + distanceY) >= height_limit) {
			_this.elementDst.style.top = ( _this.dnPos.y - (distanceY)) + 'px';
			_this.elementDst.style.height = (_this._h + (distanceY)) + 'px';
		}

		if(_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'sw-resize';
	point.style.left = '100%';
	point.style.marginLeft = (-width/2) + 'px';
	point.style.top = (- height/2) + 'px';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 1-HOUR */
		var distanceY = _this.dnPos.y - _event.pageY;
		if ((_this._h + distanceY) >= height_limit) {
			_this.elementDst.style.top = ( _this.dnPos.y - (distanceY)) + 'px';
			_this.elementDst.style.height = (_this._h + (distanceY)) + 'px';
		}

		var distanceX = _event.pageX - _this.dnPos.x;
		if ((_this._w + distanceX) >= width_limit) {
			_this.elementDst.style.width = (_this._w + (distanceX)) + 'px';
		}

		if (_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'w-resize';
	point.style.left = (-width/2) + 'px';
	point.style.top = '50%';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 9-HOUR */
		var distanceX = _this.dnPos.x - _event.pageX;
		if ((_this._w + distanceX) >= width_limit) {
			_this.elementDst.style.left = ( _this.dnPos.x - (distanceX)) + 'px';
			_this.elementDst.style.width = (_this._w + (distanceX)) + 'px';
		}

		if (_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'w-resize';
	point.style.left = '100%';
	point.style.marginLeft = (-width/2) + 'px';
	point.style.top = '50%';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 3-HOUR */
		var distanceX = _event.pageX - _this.dnPos.x;
		if ((_this._w + distanceX) >= width_limit) {
			_this.elementDst.style.width = (_this._w + (distanceX)) + 'px';
		}

		if (_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'sw-resize';
	point.style.left = (- width/2) + 'px';
	point.style.top = '100%';
	point.style.marginTop = (- height/2) + 'px';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 7-HOUR */
		var distanceX = _this.dnPos.x - _event.pageX;
		var distanceY = _event.pageY - _this.dnPos.y;

		if ((_this._w + distanceX) >= width_limit) {
			_this.elementDst.style.left = ( _this.dnPos.x - (distanceX)) + 'px';
			_this.elementDst.style.width = (_this._w + (distanceX)) + 'px';
		}

		if ((_this._h + distanceY) >= height_limit) {
			_this.elementDst.style.height = (_this._h + (distanceY)) + 'px';
		}

		if (_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 's-resize';
	point.style.left = '50%';
	point.style.top = '100%';
	point.style.marginTop = (- height/2) + 'px';
	point.style.marginLeft = (-width/2) + 'px';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 6-HOUR */
		if((_this._h + _event.pageY - _this.dnPos.y) >= height_limit)
			_this.elementDst.style.height = (_this._h + (_event.pageY - _this.dnPos.y)) + 'px';

		if(_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	var point = _element.pointers.push(makePointElement());
	point.style.cursor = 'se-resize';
	point.style.left = '100%';
	point.style.marginLeft = (-width/2) + 'px';
	point.style.top = '100%';
	point.style.marginTop = (- height/2) + 'px';
	point._event = new resize_event_listner(point, _element, function(_this, _event) {
		/* 5-HOUR */
		if((_this._w +_event.pageX - _this.dnPos.x) >= width_limit)
			_this.elementDst.style.width = (_this._w + (_event.pageX - _this.dnPos.x)) + 'px';

		if((_this._h + _event.pageY - _this.dnPos.y) >= height_limit)
			_this.elementDst.style.height = (_this._h + (_event.pageY - _this.dnPos.y)) + 'px';

		if(_subelement != undefined) _subelement['resize'](_this.elementDst);
	});

	for(var i = 0 ; i < _element.pointers.length; i ++)
		_element.appendChild(_element.pointers[i]);

}

var addon2toggle = function (params, _src_id) {
	if (arguments.length < 3) {
		return alert('not enough parameters');
	}

	if (params == null)
		params = {};

	if (params['action'] == undefined)
		params['action'] = StartEventType;

	var element = document.getElementById(_src_id);
	element.style.cursor = 'pointer';

	if (params['border'] != undefined)
		element.style.border = params['border'];

	element['dest'] = new Array();

	for (var i = 2; i < arguments.length; i++)
		element['dest'].push(document.getElementById(arguments[i]));

	element[params['action']] = function() {
		for (var i = 0; i <element['dest'].length; i++) {
			try {
				if (window.getComputedStyle(element['dest'][i], null).getPropertyValue('visibility') == 'visible')
					 element['dest'][i].style.visibility='hidden';
				else
					element['dest'][i].style.visibility='visible'

				if (element['dest'][i].tagName == 'video' || element['dest'][i].tagName == 'audio') {
					element['dest'][i].pause();
					element['dest'][i].currentTime = 0;
				}

			} catch(e) {
				element['dest'][i].style.display = (element['dest'][i].style.display == 'none') ? 'block' : 'none';
			}
		}

		if (params['callback'] != undefined)
			params['callback'](_src_id);
	};

	element.addEventListener(params['action'], function() {
	   element[params['action']]();
	});    
}

var addon2move = function (_element) {
	_element._event = new common_event_listnerEx('move', _element, _element); 
}

var set_icon_popup = function (_target_id, _popup_image_url, _width, _height, _border_css, _call_opened, _call_closed) {
	var ret = set_popup_image(_target_id, _popup_image_url, _width, _height, _border_css, _call_opened, _call_closed);
	return ret;
}

var setPageMoveFunc = function (_parent, _func_name) {
	window.pageMoveFunc = _func_name;
}

var setLinkStyle = function (_element, _options) {
	var colorHover = undefined;
	var defaultColor = undefined; 
	var defOpacity = 0.5;

	if (_options != undefined) {
		if(_options['hover'] != undefined)
			colorHover = _options['hover'];

		if(_options['default'] != undefined) {
			defaultColor = _options['default'];
		}
	}

	if (_options == undefined)
		return;

	if (_options['border'] != undefined)
		_element.style.border = _options['border'];

	if (_options['underline'] != undefined && _options['underline'])
		_element.style.textDecoration = 'underline';


	if (defaultColor == undefined)
		defaultColor = _element.style.background;
	else
		_element.style.background = UTIL.color2rgba(defaultColor, defOpacity);

	if (colorHover != undefined) {
		_element.addEventListener(Hover, function () {
			_element.style.background = UTIL.color2rgba(colorHover, defOpacity);
		}); 

		_element.addEventListener(Leave, function () {
			_element.style.background = UTIL.color2rgba(defaultColor, defOpacity);;
		}); 
	}
}

var set_action_weblink = function (_target_id, _url, _options) {
	var _isSelf = false;

	if (_options['isSelf'] !== undefined )
		_isSelf = _options['isSelf'];

	var element = document.getElementById(_target_id);

	var anchor = document.createElement('a');
	anchor.title = _url;
	anchor.href = _url;
	anchor.id = element.id;
	anchor.className = element.className;
	anchor.target = android ? "_parent" : "_blank";
	anchor.style.textDecoration = 'none';

	// 이미지 링크가 들어오면 백그라운드로 변환해줌
	if (element.firstChild != undefined && element.firstChild.tagName.toLowerCase() == "img") {
		var ef = element.firstChild;
		anchor.style.background = 'url("' + ef.getAttribute('src') + '") no-repeat';
	}

	element.parentNode.appendChild(anchor);

	// 기존 태그 삭제
	var delElement = document.getElementById(_target_id);
	document.body.removeChild(delElement);
};

var set_action_urllink = function(_target_id, _url, _linkcolor, _rolloverclolr, _opacity) {
	var ret = set_action_weblink(_target_id, _url, { 'isSelf' : false, 'default': _linkcolor, 'hover' : _rolloverclolr, 'opacity':_opacity});
}

var set_action_pagemove = function(_target_id, _page_number, _options) {
	//alert(_target_id + " : " + _page_number+ " : " + _options);
	var anchor = document.createElement('a');
	anchor.title = 'Go to Page ' + _page_number;
	// anchor.href = 'dtext://action.moveto.page/' + _page_number;
	
	anchor.href = "javascript:localPageLoaing(" + _page_number + ")";
	
	var element = document.getElementById(_target_id);
	
	anchor.id = element.id;
	anchor.className = element.className;
	anchor.style.textDecoration = 'none';

	element.parentNode.appendChild(anchor);

	// 기존 태그 삭제
	var delElement = document.getElementById(_target_id);
	document.body.removeChild(delElement);
	
	setLinkStyle(anchor, _options);

	return element;
};

var set_toggle_audio = function (_target_id, _src, _options) {
	var IDs = UTIL.stringSplit(_target_id, ',');

	if(IDs.length == 0) 
		return;

	var elements = new Array();
	
	for(var i = 0; i < IDs.length; i++) {
		var element = document.getElementById(IDs[i]);
		
		if (element == null) 
			continue;

		element.style.cursor = 'pointer';
		setLinkStyle(element,  _options);
		elements.push(element);
	}

	var instance = new audio_component(_target_id, pathConverter(_src), '100px', '100px', function(_this) {
		document.body.appendChild(_this._audio);
		_this.hide();
 
		for(var i = 0; i < elements.length; i++) {
			elements[i].addEventListener(StartEventType, function () {
				if(_this.isPlayed())
					_this.stop();
				else
					_this.play();
			}, false);
		}
	});

	return element;
};