//======================================================================= 전역 변수 설정
var CONTROL = {
    syncTime : '0',
    browser : null,
    page : null,
    link : null,
    memo : null,
    draw : null,
    responsiveUI : null
};
//======================================================================= 전역 함수

//======================================================================= 싱크
var getSyncData, prevTime;

// 데이터 싱크 호출
function sync_data(loadtype) {
    // 시간 받아오기
    var bookdata = {
        ebookId : String(ViewerManager.GetData.EPUB.ID),
        userId : String(ViewerManager.userInfo.loginKey)
    };
    $.ajax({
        async : false,
        type :'post',
        url : API.syncTime(),
        data : bookdata,
        error : function (jqXHR, textStatus, errorThrown) {
            console.log('error : function (jqXHR, textStatus, errorThrown)')
        },
        success : function (data) {
            var jsonData = $.xml2json(data);
            if (jsonData.RESULT == 'SUCCESS') {
                // 싱크 시간 체크
                console.log('sync_data', loadtype, jsonData.message);
                CONTROL.syncTime = jsonData.message;
                if (loadtype == 'down') {prevTime = CONTROL.syncTime;}
                if (loadtype == 'complete') {
                    prevTime = CONTROL.syncTime;
                    return;
                }

                var syncBool = true;
                if (CONTROL.syncTime == '0' || CONTROL.syncTime == '') {
                    syncBool = false;
                }

                updateSync(loadtype, syncBool);
            }
        }
    });
}

function updateSync(loadtype, bool) {
    console.log('updateSync', loadtype, bool);
    var syncData = {};
    var bookmarkKeys = [];
    var cameraKeys = [];
    var drawKeys = [];
    var linkKeys = [];
    var memoKeys = [];
    var recordKeys = [];
    var loadError = false;

    console.log('function updateSync(loadtype, bool)');

    if (bool) {
        // 파일이 있는 경우
        $.ajax({
            async : false,
            url : '/Sviewer/user_logdata/' + String(ViewerManager.GetData.EPUB.ID) + '/' + String(ViewerManager.userInfo.loginKey) + '/mycontents.json',
            success : function (data) {

            },
            error : function (jqXHR, textStatus, errorThrown) {
                console.log('error', jqXHR, textStatus, errorThrown);
                loadError = true;
                CONTROL.syncTime = '';
            },
            complete : function (data) {
                if (loadError == true) {
                    updateSync(loadtype, false);
                    return;
                }
                //console.log(data.responseText)
                getSyncData = data.responseText;
                if (String(location.href).match('titanbooks.co.kr')) {
                    getSyncData = JSON.parse(getSyncData);

                    mix_data(loadtype, 'bookmark');
                    mix_data(loadtype, 'memo');
                    mix_data(loadtype, 'link');
                    mix_data(loadtype, 'draw');
                } else {

                }
            }
        })
    } else {
        // 파일이 없는 경우
        getSyncData = '';
        mix_data(loadtype, 'bookmark');
        mix_data(loadtype, 'memo');
        mix_data(loadtype, 'link');
        mix_data(loadtype, 'draw');
    }
}

//var parseData;
var uploadCount = 0;
function mix_data(loadtype, gettype) {
    console.log('function mix_data(loadtype, gettype)');
    var i,j,k;
    var thisData = CONTROL.save_target(gettype);
    var parseData = JSON.parse(thisData);

    if (loadtype == 'down') {
        // 내 데이터 먼저 받고
        var myData = parseData[gettype];
        var getData = getSyncData[gettype];
        // 책갈피 경우
        if (gettype == 'bookmark') {
            if ((getData == null || getData == undefined) && (myData == null || myData == undefined)) {
                return;
            }

            var bookmark_max = parseInt(ViewerManager.PAGE_TOTAL_NUMBER);
            var bookmark_get = [], bookmark_my = [], bookmark_final = [], bookmark_new_object;

            // 가져온 데이터 정리
            if (getData != undefined && getData.length > 0) {
                for (i = 1; i <= bookmark_max; i++) {
                    var thisPageno = i;
                    if (getData[i - 1] != undefined) {
                        thisPageno = parseInt(getData[i - 1].pageno);
                    }

                    if (getData[i - 1] != undefined) {
                        bookmark_get[thisPageno] = getData[i - 1];
                    }
                }
            }
            // 내 데이터 정리
            var myLastDate = 0;
            if (myData != undefined && myData.length > 0) {
                for (i = 1; i <= bookmark_max; i++) {
                    var thisPageno = i;
                    if (myData[i - 1] != undefined) {
                        thisPageno = parseInt(myData[i - 1].pageno);
                        if (myLastDate < parseInt(myData[i - 1].lastdate)) {
                            myLastDate = parseInt(myData[i - 1].lastdate);
                        }
                    }

                    if (myData[i - 1] != undefined) {
                        bookmark_my[thisPageno] = myData[i - 1];
                    }
                }
            }
            // 두 데이터 비교
            for (i = 1; i <= bookmark_max; i++) {
                if (bookmark_get[i] == undefined && bookmark_my[i] == undefined) {
                    continue;
                } else {
                    if (bookmark_get[i] != undefined && bookmark_my[i] == undefined) {
                        // 나만 없는 경우
                        if (myLastDate <= parseInt(CONTROL.syncTime)) {
                            // 있는 걸로
                            bookmark_get[i].bookId = ViewerManager.GetData.EPUB.ID;
                            bookmark_final.push(bookmark_get[i]);
                        }
                    } else if (bookmark_get[i] == undefined && bookmark_my[i] != undefined) {
                        // 나만 가진 경우
                        if (myLastDate >= parseInt(CONTROL.syncTime)) {
                            // 있는 걸로
                            bookmark_final.push(bookmark_my[i]);
                        }
                    } else if (bookmark_get[i] != undefined && bookmark_my[i] != undefined) {
                        // 둘다 있는 경우, 최종 타임인걸로
                        if (myLastDate < parseInt(CONTROL.syncTime)) {
                            bookmark_get[i].bookId = ViewerManager.GetData.EPUB.ID;
                            bookmark_final.push(bookmark_get[i]);
                        } else {
                            bookmark_final.push(bookmark_my[i]);
                        }
                    }
                }
            }

            var bookmarkDatas = JSON.parse(CONTROL.save_target("bookmark"));
            bookmarkDatas.bookmark = bookmark_final;
            CONTROL.save_target("bookmark", JSON.stringify(bookmarkDatas));
        }
        // 메모 경우
        if (gettype == 'memo') {
            if ((getData == null || getData == undefined) && (myData == null || myData == undefined)) {
                return;
            }

            var makeMemos = [];

            // 가져온 데이터 정리
            if (getData != null && getData != undefined && getData.length > 0) {
                for (i = 0; i < getData.length; i++) {
                    // 가져온 데이터와 내 데이터 중 생성일이 같은 내용을 찾음
                    var find = false;
                    var checkObject;

                    if (myData != null && myData != undefined && myData.length > 0) {
                        for (j = 0; j < myData.length; j++) {
                            if (getData[i].createdate == myData[j].createdate) {
                                find = true;
                                checkObject = myData[j];
                                break;
                            } else {
                                find = false;
                            }
                        }

                        if (find == true) {
                            // 찾은 경우에는 최종 날짜의 내용으로 수정
                            if (parseInt(getData[i].lastdate) <= parseInt(checkObject.lastdate)) {
                                checkObject.bookId = ViewerManager.GetData.EPUB.ID;
                                makeMemos.push(checkObject);
                            } else {
                                getData[i].bookId = ViewerManager.GetData.EPUB.ID;
                                makeMemos.push(getData[i]);
                            }
                        } else {
                            // 같은 내용이 없으면 계속 붙여주기
                            getData[i].bookId = ViewerManager.GetData.EPUB.ID;
                            makeMemos.push(getData[i]);
                        }
                    } else {
                        if (getData[i] != undefined) {
                            getData[i].bookId = ViewerManager.GetData.EPUB.ID;
                            makeMemos.push(getData[i]);
                        }
                    }
                }
            }
            // 내 데이터 정리
            if (myData.length > 0) {
                for (i = 0; i < myData.length; i++) {
                    if (parseInt(myData[i].createdate) > parseInt(CONTROL.syncTime)) {
                        // 최신에 작업된 내용 추가
                        makeMemos.push(myData[i]);
                    }
                }
            }

            var memoDatas = JSON.parse(CONTROL.save_target("memo"));
            memoDatas.memo = makeMemos;
            CONTROL.save_target("memo", JSON.stringify(memoDatas));
        }
        // 링크 경우
        if (gettype == 'link') {
            if ((getData == null || getData == undefined) && (myData == null || myData == undefined)) {
                return;
            }

            var makeLinks = [];

            // 가져온 데이터 정리
            if (getData != null && getData != undefined && getData.length > 0) {
                for (i = 0; i < getData.length; i++) {
                    // 가져온 데이터와 내 데이터 중 생성일이 같은 내용을 찾음
                    var find = false;
                    var checkObject;

                    if (myData != null && myData != undefined && myData.length > 0) {
                        for (j = 0; j < myData.length; j++) {
                            if (getData[i] != undefined && getData[i].createdate == myData[j].createdate) {
                                find = true;
                                checkObject = myData[j];
                                break;
                            } else {
                                find = false;
                            }
                        }

                        if (find == true) {
                            // 찾은 경우에는 최종 날짜의 내용으로 수정
                            if (parseInt(getData[i].lastdate) <= parseInt(checkObject.lastdate)) {
                                checkObject.bookId = ViewerManager.GetData.EPUB.ID;
                                makeLinks.push(checkObject);
                            } else {
                                getData[i].bookId = ViewerManager.GetData.EPUB.ID;
                                makeLinks.push(getData[i]);
                            }
                        } else {
                            // 같은 내용이 없으면 계속 붙여주기
                            if (getData[i] != undefined) {
                                getData[i].bookId = ViewerManager.GetData.EPUB.ID;
                                makeLinks.push(getData[i]);
                            }
                        }
                    } else {
                        if (getData[i] != undefined) {
                            getData[i].bookId = ViewerManager.GetData.EPUB.ID;
                            makeLinks.push(getData[i]);
                        }
                    }
                }
            }

            // 내 데이터 정리
            if (myData.length > 0) {
                for (i = 0; i < myData.length; i++) {
                    if (parseInt(myData[i].createdate) > parseInt(CONTROL.syncTime)) {
                        // 최신에 작업된 내용 추가
                        makeLinks.push(myData[i]);
                    }
                }
            }

            var linkDatas = JSON.parse(CONTROL.save_target("link"));
            linkDatas.link = makeLinks;
            CONTROL.save_target("link", JSON.stringify(linkDatas));
        }
        // 판서 경우
        if (gettype == 'draw') {
            // getData svg 는 다운받아서 사용해야함, parsing 이 필요함
            if ((getData == null || getData == undefined) && (myData == null || myData == undefined)) {
                return;
            }

            var makeDraws = [], finalDraws = [];
            //console.log('both data', getData, myData);
            if (getData != null && getData != undefined && myData != undefined) {
                //console.log('both data');
                // 둘다 있는 경우
                // 불러온 데이터와 가지고있는 데이터의 lastdate 비교
                // lastdate 가 높은쪽 데이터를 사용
                if (getData.length > 0) {
                    for (i = 0; i < getData.length; i++) {
                        var getReData = {
                            pageno : getData[i].pageno,
                            lastdate : getData[i].lastdate,
                            drawurl : getData[i].drawurl,
                            svg : ''
                        }, loadError = false;
                        var svgUrl = '/Sviewer/user_logdata/' + String(ViewerManager.GetData.EPUB.ID) + '/' + String(ViewerManager.userInfo.loginKey) + '/' + getData[i].drawurl;
                        $.ajax({
                            async : true,
                            url : svgUrl,
                            dataType : 'xml',
                            error : function (jqXHR, textStatus, errorThrown) {
                                console.log('svg load error');
                                loadError = true;
                            },
                            success : function (data) {
                                // 앱에서 웹으로 변환
                                // 불러온 xml을 웹형식에 맞춰서 변환
                                if (loadError == false) {
                                    var _childNodes = data.childNodes[0].children == undefined ? data.childNodes[0].childNodes : data.childNodes[0].children;
                                    var reHTML = CONTROL.draw.convertAppToWeb(_childNodes);
                                    getReData.svg = reHTML;
                                    makeDraws.push(getReData);

                                    if (i == getData.length - 1) {
                                        // 불러온 데이터와 가지고있는 데이터를 비교
                                        for (j = 0; j < makeDraws.length; j++) {
                                            if (myData.length > 0) {
                                                for (k = 0; k < myData.length; k++) {
                                                    if (makeDraws[j].pageno == myData[k].pageno) {
                                                        if (parseInt(makeDraws[j].lastdate) > parseInt(myData[k].lastdate)) {
                                                            finalDraws.push(makeDraws[j]);
                                                        } else if (parseInt(makeDraws[j].lastdate) < parseInt(myData[k].lastdate)) {
                                                            finalDraws.push(myData[k]);
                                                        } else {
                                                            finalDraws.push(myData[k]);
                                                        }
                                                    }
                                                }
                                            } else {
                                                finalDraws.push(makeDraws[j]);
                                            }
                                        }

                                        // 통합된 데이터에 중복없이 갱신된 데이터를 넣어줌
                                        for (j = 0; j < finalDraws.length; j++) {
                                            for (k = 0; k < myData.length; k++) {
                                                if (finalDraws[j].pageno != myData[k].pageno) {
                                                    if (parseInt(myData[k].lastdate) > parseInt(CONTROL.syncTime)) {
                                                        finalDraws.push(myData[k]);
                                                    }
                                                }
                                            }
                                        }

                                        var drawDatas = JSON.parse(CONTROL.save_target("draw"));
                                        drawDatas.draw = finalDraws;
                                        CONTROL.save_target("draw", JSON.stringify(drawDatas));

                                        // 싱크가 완료된 시점에서 판서를 다시 그려줘야함
                                        CONTROL.draw._refresh();
                                    }
                                }
                            }
                        });
                    }
                }
            } else {
                // 둘중 하나만 있는 경우
                if ((myData != null || myData != undefined) && (getData == null && getData == undefined)) {
                    console.log('only web');
                    // 가져온 데이터가 없는 경우 내 데이터만 넣어줌
                    if (myData.length > 0) {
                        for (i = 0; i < myData.length; i++) {
                            makeDraws.push(myData[i]);
                        }
                    }
                } else if (getData != undefined && myData == undefined) {
                    console.log('only app');
                    // 내 데이터가 없는 경우 가져온 데이터만 넣어줌
                    if (getData.length > 0) {
                        for (i = 0; i < getData.length; i++) {
                            var getReData = {
                                pageno : getData[i].pageno,
                                lastdate : getData[i].lastdate,
                                drawurl : getData[i].drawurl,
                                svg : ''
                            }, loadError = false;
                            var svgUrl = '/Sviewer/user_logdata/' + String(ViewerManager.GetData.EPUB.ID) + '/' + String(ViewerManager.userInfo.loginKey) + '/' + getData[i].drawurl;
                            $.ajax({
                                async : false,
                                url : svgUrl,
                                dataType : 'xml',
                                error : function (jqXHR, textStatus, errorThrown) {
                                    console.log('svg load error');
                                    loadError = true;
                                },
                                success : function (data) {
                                    // 앱에서 웹으로 변환
                                    // 불러온 xml을 웹형식에 맞춰서 변환
                                    if (loadError == false) {
                                        var reHTML = CONTROL.draw.convertAppToWeb(data.childNodes[0].children);
                                        getReData.svg = reHTML;
                                        makeDraws.push(getReData);

                                        if (i == getData.length - 1) {
                                            var drawDatas = JSON.parse(CONTROL.save_target("draw"));
                                            drawDatas.draw = makeDraws;
                                            //console.log('drawDatas', JSON.stringify(drawDatas));
                                            CONTROL.save_target("draw", JSON.stringify(drawDatas));

                                            // 싱크가 완료되 시점에서 판서를 다시 그려줘야함
                                            CONTROL.draw._refresh();
                                        }
                                    }
                                }
                            });
                        }
                    }
                }
            }
        }
    } else if (loadtype == 'up') {
        // 업로드는 한번만 하도록
        // 시간 다시 받아오기
        if (uploadCount < 4) {
            uploadCount++;

            if (uploadCount == 4) {
                var bookdata = {
                    ebookId : String(ViewerManager.GetData.EPUB.ID),
                    userId : String(ViewerManager.userInfo.loginKey)
                }
                $.ajax({
                    async : false,
                    type :'post',
                    url : API.syncTime(),
                    data : bookdata,
                    error : function (jqXHR, textStatus, errorThrown) {
                        console.log('sync up error');
                    },
                    success : function (data) {
                        var jsonData = $.xml2json(data);
                        //console.log('jsonData', jsonData);
                        if (jsonData.RESULT == 'SUCCESS') {
                            CONTROL.syncTime = jsonData.message;
                            console.log('SUCCESS', prevTime, CONTROL.syncTime);

                            if (prevTime >= CONTROL.syncTime) {
                                console.log('just up');
                                var thisGettype = ['bookmark', 'memo', 'link', 'draw'];

                                if (getSyncData == '') {
                                    getSyncData = {};
                                }

                                for (i = 0; i < thisGettype.length; i++) {
                                    thisData = CONTROL.save_target(thisGettype[i]);
                                    parseData = JSON.parse(thisData);

                                    //console.log(thisGettype[i], thisData, parseData[thisGettype[i]].length);

                                    getSyncData[thisGettype[i]] = [];

                                    if (parseData[thisGettype[i]].length == 0) {
                                        getSyncData[thisGettype[i]] = [];
                                    } else if (parseData[thisGettype[i]].length > 0) {
                                        for (j = 0; j < parseData[thisGettype[i]].length; j++) {
                                            getSyncData[thisGettype[i]].push(makeObject(thisGettype[i], parseData[thisGettype[i]][j]));
                                        }
                                    }
                                }
                                //console.log(getSyncData);
                                // 파일 저장
                                CONTROL.save_data("mycontents", JSON.stringify(getSyncData));

                                uploadCount = 0;
                                // 시간 생성에 텀이 필요한가?
                                setTimeout(function (){
                                    // 생성단계에서 svg 를 만들어줘야함
                                    CONTROL.save_svg_each();
                                    sync_data('complete');
                                }, 100);
                            } else {
                                console.log('remix');
                                // 다시 데이터 비교해서 만들어주고 시간은 갱신해야함
                                mix_data('down', 'bookmark');
                                mix_data('down', 'memo');
                                mix_data('down', 'link');
                                mix_data('down', 'draw');

                                uploadCount = 0;
                                // 시간 생성에 텀이 필요한가?
                                /*setTimeout(function (){
                                    // 생성단계에서 svg 를 만들어줘야함
                                    CONTROL.save_svg_each();
                                    sync_data('complete');
                                }, 100);*/
                            }
                        }
                    }
                });
            }
        }
    }
}

// 교환 오브젝트 생성
function makeObject(gettype, getdata) {
    var returnObject = new Object();

    switch (gettype) {
        case 'bookmark' : {
            returnObject.pageno = getdata.pageno;
            returnObject.lastdate = getdata.lastdate;

            break;
        }
        case 'memo' : {
            returnObject.pageno = getdata.pageno;
            returnObject.createdate = getdata.createdate;
            returnObject.lastdate = getdata.lastdate;
            returnObject.title = getdata.title;
            returnObject.memo = getdata.memo;
            returnObject.locx = getdata.locx;
            returnObject.locy = getdata.locy;

            break;
        }
        case 'link' : {
            returnObject.pageno = getdata.pageno;
            returnObject.createdate = getdata.createdate;
            returnObject.lastdate = getdata.lastdate;
            returnObject.linkname = getdata.linkname;
            returnObject.linkurl = getdata.linkurl;
            returnObject.locx = getdata.locx;
            returnObject.locy = getdata.locy;

            break;
        }
        case 'draw' : {
            returnObject.pageno = getdata.pageno;
            returnObject.lastdate = getdata.lastdate;
            returnObject.drawurl = getdata.drawurl;

            break;
        }
    }

    return returnObject;
}
//======================================================================= 저장소
CONTROL.serverdata = {};
// json 데이터를 저장하거나, 저장 객체를 반환
// VIEWER_TYPE 에 따라서, 저장 객체는 로컬 또는 세션으로 할당
// 세션으로 할당 받는 경우, 서버에 저장 함
CONTROL.save_target = function (gettype, setdata) {
    //console.log('CONTROL.save_target', gettype);
    var return_target;

    if (ViewerManager.VIEWER_TYPE == "TITAN") {
        // 세션 스토리지 할당
        if (window.sessionStorage.getItem(gettype) == null) {
            window.sessionStorage.setItem(gettype, switch_type(gettype));
        }

        // 기본 데이터가 없는 초기 호출
        if (CONTROL.serverdata[gettype] == undefined) {
            if (ViewerManager.VIEWER_TYPE == "TITAN" && (gettype == "draw" || gettype == "bookmark" || gettype == "memo" || gettype == "link")) {
                // 파일이 있는지 먼저 체크할 필요가 있다.
                // file check
                var subpath = String(ViewerManager.GetData.EPUB.ID) + '/' + String(ViewerManager.userInfo.loginKey);
                var postdata = {
                    'filetype' : String(gettype),
                    'cntid' : String(ViewerManager.GetData.EPUB.ID),
                    'usrid' : String(ViewerManager.userInfo.loginKey)
                };

                $.ajax({
                    async : false,
                    type :'post',
                    url : API.fileCheck(),
                    data : postdata,
                    dataType : 'text',
                    error : function (jqXHR, textStatus, errorThrown) {
                        console.log('error', jqXHR, textStatus, errorThrown);
                    },
                    success : function (data) {
                        if (parseInt(data) == 1) {
                            // 파일이 있는 경우, 서버 파일 내용 불러오기
                            var subpath = String(ViewerManager.GetData.EPUB.ID) + '/' + String(ViewerManager.userInfo.loginKey);
                            $.ajax({
                                async : false,
                                type : 'post',
                                url : '/Sviewer/user_logdata/' + subpath + '/' + gettype + '.json',
                                error : function (jqXHR, textStatus, errorThrown) {
                                    console.log('error', jqXHR, textStatus, errorThrown);
                                },
                                success : function (data) {
                                    //console.log('SUCCESS : file found.', gettype + '.json');
                                    if (data.length == undefined) {
                                        CONTROL.serverdata[gettype] = JSON.stringify(JSON.parse('{"' + gettype + '" : []}'));
                                        CONTROL.save_data(gettype, CONTROL.serverdata[gettype]);
                                        window.sessionStorage.setItem(gettype, JSON.stringify(JSON.parse('{"' + gettype + '" : []}')));
                                    } else {
                                        //console.log('data', CONTROL.serverdata[gettype], JSON.stringify(JSON.parse(data)));
                                        if (CONTROL.serverdata[gettype] != JSON.stringify(JSON.parse(data))) {
                                            CONTROL.serverdata[gettype] = JSON.stringify(JSON.parse(data));
                                            window.sessionStorage.setItem(gettype, JSON.stringify(JSON.parse(data)));
                                        }
                                    }
                                }
                            });
                        }
                        else {
                            //console.log('FAIl : file not found.', gettype + '.json >> make file...');
                            // 파일이 없는 경우, 기본데이터 설정, 파일까지 생성
                            if (CONTROL.serverdata[gettype] != JSON.stringify(JSON.parse('{"' + gettype + '" : []}'))) {
                                CONTROL.serverdata[gettype] = JSON.stringify(JSON.parse('{"' + gettype + '" : []}'));
                                CONTROL.save_data(gettype, CONTROL.serverdata[gettype]);
                            }
                            if (window.sessionStorage.getItem(gettype) != JSON.stringify(JSON.parse('{"' + gettype + '" : []}'))) {
                                window.sessionStorage.setItem(gettype, JSON.stringify(JSON.parse('{"' + gettype + '" : []}')));
                            }
                        }
                    }
                })
            }
        }

        // 기본 데이터가 있는 상태
        if (setdata == undefined) {
            // 저장 구간이 아니면 바로 리턴
            return_target = window.sessionStorage.getItem(gettype);
            return return_target;
        }
        else
        {
            //console.log(setdata != CONTROL.serverdata[gettype], setdata.length, CONTROL.serverdata[gettype].length);
            if (setdata != CONTROL.serverdata[gettype]) {
                // 내용이 다른 경우 세션에 저장함
                CONTROL.serverdata[gettype] = setdata;
                window.sessionStorage.setItem(gettype, setdata);
                // 서버에도 저장
                if (String(location.href).match('titanbooks.co.kr') && String(ViewerManager.userInfo.loginKey).length > 0) {
                    CONTROL.save_data(gettype, setdata);
                    //if (gettype == 'draw') {CONTROL.save_svg(setdata);}
                }
            }

            return;
        }
    } else {
        var storage = window.localStorage;
        //var storage = window.sessionStorage;

        if (storage.getItem(gettype) == null) {
            storage.setItem(gettype, switch_type(gettype));
        };

        if (setdata != undefined) {
            CONTROL.serverdata[gettype] = setdata;
            storage.setItem(gettype, setdata);

            return;
        } else {
            return_target = storage.getItem(gettype);

            return return_target;
        }
    }

    function switch_type (gettype) {
        var return_value;
        switch (gettype) {
            case 'draw' : {
                return_value = JSON.stringify({draw : []});
                break;
            }
            case 'bookmark' : {
                return_value = JSON.stringify({bookmark : []});
                break;
            }
            case 'link' : {
                return_value = JSON.stringify({link : []});
                break;
            }
            case 'memo' : {
                return_value = JSON.stringify({memo : []});
                break;
            }
            case 'palette' : {
                return_value = JSON.stringify({palette : []});
                break;
            }
        }

        return return_value;
    }
}

//======================================================================= 개별 삭제 기능
CONTROL.deleteContents = function (gettype, pagenumber, lastdate) {
    // 삭제하시겠습니까?
    $("#dataDeleteTemplet").css('left', (window.innerWidth / 2 - 150) + 'px');
    $("#dataDeleteTemplet").fadeIn("fast", function () {
      $(this).find("#dataDeletePopupNoBtn").on("click", function () {
        $("#dataDeleteTemplet").fadeOut("fast");
      });
      $(this).find("#dataDeletePopupYesBtn").on("click", function () {
        //$("#drawDeleteTemplet").fadeOut("fast");
        // 네 선택하면 삭제하도록 수정
        var thisData = JSON.parse(CONTROL.save_target(gettype));
        // 찾기(lastdate 기준)
        if (thisData[gettype].length > 0) {
            for (var i = 0; i < thisData[gettype].length; i++) {
                if (thisData[gettype][i].lastdate == String(lastdate)) {
                    console.log(CONTROL.serverdata[i], thisData[gettype][i]);
                    thisData[gettype].splice(i, 1);
                    CONTROL.save_target(gettype, JSON.stringify(thisData));
                    ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER);
                    break;
                }
            }
            $("#dataDeleteTemplet").fadeOut("fast");
        }
      });
    });
}

//======================================================================= 데이터 저장
CONTROL.save_data = function (gettype, getdata, filetype) {
    if (ViewerManager.VIEWER_TYPE == 'TITAN') {
        var _filetype = filetype == undefined ? '.json' : filetype;
        // file save
        var subpath = String(ViewerManager.GetData.EPUB.ID) + '/' + String(ViewerManager.userInfo.loginKey)
        var postdata = {
            'gettype' : String(gettype),
            'filetype' : String(_filetype),
            'cntid' : String(ViewerManager.GetData.EPUB.ID),
            'usrid' : String(ViewerManager.userInfo.loginKey),
            'filedata' : getdata
        };

        $.ajax({
            type :'post',
            url : API.fileSave(),
            data : postdata,
            error : function (jqXHR, textStatus, errorThrown) {
                console.log('error', jqXHR, textStatus, errorThrown);
            },
            success : function (data) {
                //console.log('success', data);
            }
        })

        return CONTROL.serverdata;
    }
}

//======================================================================= SVG 저장
CONTROL.save_svg = function (svgdata) {
    //if (svgdata == undefined) {return;}
    console.log('CONTROL.save_svg');

    var i, j, k, d, imgdata;
    var SVG_JSON = JSON.parse(svgdata);

    // 이미지 데이터의 페이지 번호 를 체크해야 함
    var dataPage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;

    // 실 데이터는 양면을 기준으로 저장하므로 1을 제외한 모든 페이지는 짝수 페이지의 데이터를 가져다가 저장
    // 양면의 데이터를 모두 가지고 있는가가 중요함
    for (i = 0; i < SVG_JSON['draw'].length; i++) {
        var pageNo = SVG_JSON['draw'][i].pageNo == undefined ? parseInt(SVG_JSON['draw'][i].pageNum) : parseInt(SVG_JSON['draw'][i].pageNo);
        pageNo = SVG_JSON['draw'][i].pageno == undefined ? pageNo : parseInt(SVG_JSON['draw'][i].pageno);

        if (pageNo == dataPage) {
            // 웹에서 앱으로 변환
            imgData = CONTROL.draw.convertWebToApp(SVG_JSON['draw'][i].svg);
            CONTROL.makeSVG(imgData, 'svg');

            break;
        }
    }
}

CONTROL.save_svg_each = function () {
    // 이전 데이터를 저장하기 위해서 생성
    console.log('CONTROL.save_svg_each');

    var drawDatas = JSON.parse(CONTROL.save_target("draw"));

    // 이미지 데이터의 페이지 번호 를 체크해야 함
    var dataPage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;

    if (drawDatas.draw.length > 0) {
        for (var i = 0; i < drawDatas.draw.length; i++) {
            // 웹에서 앱으로 변환
            var imgData = CONTROL.draw.convertWebToApp(drawDatas.draw[i].svg);
            var savePage = drawDatas.draw[i].drawurl;
            CONTROL.makeSVG(imgData, 'svg', savePage);
            /*drawDatas.draw[i] = {
                bookId : _bookID,
                pageno : _pageNo,
                lastdate : _lastDate,
                svg : _svg,
                drawurl : savePage,
                show : 'true'
            }*/
            if (drawDatas.draw[i].pageno == dataPage) {
                var svg = document.getElementById('drawingSVG');
                svg.innerHTML = drawDatas.draw[i].svg;
            }
        }
    }
}

CONTROL.makeSVG = function(_imgdata, _stat, _savePage) {
    //console.log('CONTROL.makeSVG');
    var drawData, svgtest = false;

    if (ViewerManager.VIEWER_TYPE == "TITAN" || svgtest == true) {
        // file control
        var insideSVG = '', totalSVG = '', postdata;

        var savePage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
        if (savePage < 10) {
            savePage = '000' + String(savePage);
        } else if (savePage >= 10 && savePage < 100) {
            savePage = '00' + String(savePage);
        } else if (savePage >= 100 && savePage < 1000) {
            savePage = '0' + String(savePage);
        } else if (savePage >= 1000 && savePage <= 10000) {
            savePage = String(savePage);
        }

        if (_savePage != undefined) {savePage = _savePage;}
        savePage = savePage.replace('.svg', '');
        if (_stat == 'delete') {
            // svg 파일을 삭제함
            postdata = {
                'gettype' : String(savePage),
                'filetype' : '.svg',
                'cntid' : String(ViewerManager.GetData.EPUB.ID),
                'usrid' : String(ViewerManager.userInfo.loginKey)
            };

            $.ajax({
                type :'post',
                url : API.fileRemove(),
                data : postdata,
                error : function (jqXHR, textStatus, errorThrown) {
                    //console.log('error', jqXHR, textStatus, errorThrown);
                },
                success : function (data) {
                    console.log('success delete');
                }
            });
        } else if (_stat == 'svg') {
            totalSVG = '<svg version="1.1" id="Layer_1" x="0px" y="0px" width="' + (ViewerManager.iframeContentsWidth * 2) + 'px" height="' + ViewerManager.iframeContentsHeight + 'px" xmlns="http://www.w3.org/2000/svg">';
            totalSVG = totalSVG + _imgdata;
            totalSVG = totalSVG + '</svg>';

            postdata = {
                'gettype' : String(savePage),
                'filetype' : '.svg',
                'cntid' : String(ViewerManager.GetData.EPUB.ID),
                'usrid' : String(ViewerManager.userInfo.loginKey),
                'filedata' : totalSVG
            };

            $.ajax({
                async : false,
                type :'post',
                url : API.fileSave(),
                data : postdata,
                error : function (jqXHR, textStatus, errorThrown) {
                    console.log('error', jqXHR, textStatus, errorThrown);
                },
                success : function (data) {
                    console.log(savePage + '.svg make success');
                }
            });
        }
    }
}

CONTROL.convertSVG = function (_type, _data) {
    var i, d, returnData;
    switch (_type) {
        case 'path': {
            for (i = 0; i < _data['d'].length; i++) {
                var newtext;
                if (i == 0) {
                    newtext = 'M' + String(_data['d'][i][0]);
                    newtext = newtext + ',' + String(_data['d'][i][1]);
                } else if (i == 1) {
                    newtext = newtext + ' Q' + String(_data['d'][i][0]);
                    newtext = newtext + ',' + String(_data['d'][i][1]);
                } else {
                    newtext = newtext + ' ' + String(_data['d'][i][0]);
                    newtext = newtext + ',' + String(_data['d'][i][1]);
                }
                d = newtext;
            }
            returnData = '<path opacity="' + _data['opacity'] + '" fill="' + _data['fill'] + '" stroke="' + _data['stroke'] + '" stroke-width="' + _data['stroke-width'] + '" stroke-linecap="' + _data['stroke-linecap'] + '" stroke-linejoin="' + _data['stroke-linejoin'] + '" d="' + d + '" />\n'
            break;
        }
        case 'rect': {
            returnData = '<rect opacity="' + _data['opacity'] + '" fill="' + _data['fill'] + '" stroke="' + _data['stroke'] + '" x="' + _data['x'] + '" y="' + _data['y'] + '" width="' + _data['width'] + '" height="' + _data['height'] + '" />\n'
            break;
        }
    }

    return returnData;
}

$('#btn_sync').on('click', function (e) {
    sync_data('up');
})
//======================================================================= 전역 컨트롤
// UI 초기 설정
CONTROL.init = function () {
    // SVGinnerHTML 설정
    setInnerHTML();
    CONTROL.draw._init();
    CONTROL.memo._init();
}
// 페이지 호출 시점
CONTROL.loadStart = function () {
    // UI 초기화
    CONTROL.draw._loadStart();
    CONTROL.memo._loadStart();
    CONTROL.responsiveUI._loadStart();
}
// 페이지 호출 완료
CONTROL.loadComplete = function () {
    // UI 그려줌
    CONTROL.draw._loadComplete();
    CONTROL.memo._loadComplete();
}
// 페이지 데이터 저장
CONTROL.save = function () {
    CONTROL.draw._save();
    CONTROL.memo._save();
}
// 페이지 리사이즈
CONTROL.resize = function () {
    CONTROL.draw._resize();
    CONTROL.memo._resize();
    CONTROL.responsiveUI._resize();
}
// 페이지 리프레쉬
CONTROL.refresh = function () {
    CONTROL.draw._refresh();
    CONTROL.memo._refresh();
}
//======================================================================= 개별 Util 닫기
CONTROL.closeUtils = function (gettype) {
    switch (gettype) {
        case 'memo': {
            CONTROL.link.linkIndex();
            break;
        }
        case 'link': {
            CONTROL.memo.memoIndex();
            break;
        }
    }
}
//======================================================================= 광고 재호출
CONTROL.refreshAD = function() {
    var clone;
    if (String(location.href).match('titanbooks.co.kr') && !String(location.href).match('.html'))
    {
        if (document.getElementById('div-ad-left'))
        {
            clone = $('#div-ad-left')[0].innerHTML;
            $('#div-ad-left')[0].innerHTML = '';
            $('#div-ad-left')[0].innerHTML = clone;

            $('#img-adclose-left')
            .css('display', 'inline-block')
            .on('click', function (e){
                $('#div-ad-left').remove();
            });
        }

        if (document.getElementById('div-ad-right'))
        {
            clone = $('#div-ad-right')[0].innerHTML;
            $('#div-ad-right')[0].innerHTML = '';
            $('#div-ad-right')[0].innerHTML = clone;

            $('#img-adclose-right')
            .css('display', 'inline-block')
            .on('click', function (e){
                $('#div-ad-right').remove();
            });
        }
    }
}
//======================================================================= 프로토 타입 체인
String.prototype.getStringLength = function (byteLength) {
    var contents = this,
        str_character,
        int_char_count,
        int_contents_length,
        returnValue = "";

    int_char_count = 0;
    int_contents_length = contents.length;

    for (var k = 0; k < int_contents_length; k++) {
        str_character = contents.charAt(k);

        int_char_count++;

        if ( int_char_count > byteLength - 1 ) {
            break;
        }
        returnValue += str_character;
    }

    if (int_contents_length > returnValue.length) {
        returnValue = returnValue + "...";
    }

    return returnValue;
};

String.prototype.replaceAt = function (index, character) {
  return this.substr(0, index) + character + this.substr(index + character.length);
};

// data format seting : YYMMDD type
Date.prototype.yyyymmddhh24miss = function () {
    var yyyy = this.getFullYear().toString(),
        mm = (this.getMonth() + 1).toString(),
        dd = this.getDate().toString(),
        hh24 = this.getHours().toString(),
        mi = this.getMinutes().toString(),
        ss = this.getSeconds().toString();

    return yyyy + (mm[1] ? mm : '0' + mm[0]) + (dd[1] ? dd : '0' + dd[0]) + (hh24[1] ? hh24 : '0' + hh24[0]) + (mi[1] ? mi : '0' + mi[0]) + (ss[1] ? ss : '0' + ss[0]);
};

Number.prototype.setPoint = function (_point) {
    var newPow = Math.pow(10, _point);
    var newPoint = this * newPow;
    newPoint = Math.floor(newPoint) / newPow;

    return newPoint;
}

// Important: You must serve your pages as XHTML for this shim to work,
// otherwise namespaced attributes and elements will get messed up.
function setInnerHTML() {
    // ie, safari
	 console.log(  SVGElement.prototype.innerHTML ); 
    //if (!CONTROL.browser.chrome && !CONTROL.browser.firefox && !CONTROL.browser.edge && SVGElement.prototype.innerHTML == undefined) {
    if ((!CONTROL.browser.chrome && !CONTROL.browser.firefox && SVGElement.prototype.innerHTML == undefined) || CONTROL.browser.edge) {
        Object.defineProperty(SVGElement.prototype, 'innerHTML', {
            get: function() {
                var $child, $node, $temp, _i, _len, _ref;
                $temp = document.createElement('div');
                $node = this.cloneNode(true);
                _ref = $node.childNodes;

                for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                    if (_ref[_i].nodeType == '1') {
                        $child = _ref[_i].cloneNode(true);
                        $temp.appendChild($child);
                    }
                }

                return $temp.innerHTML;
            },
            set: function(markup) {
                var $div, $element, $svg, _i, _len, _ref, _results;
                while (this.firstChild) {
                    this.firstChild.parentNode.removeChild(this.firstChild);
                }
                markup = "<svg id='wrapper' xmlns='http://www.w3.org/2000/svg'>" + markup + "</svg>";
                $div = document.createElement('div');
                $div.innerHTML = markup;
                $svg = $div.querySelector('svg#wrapper');
                _ref = $svg.childNodes;
                _results = [];
                for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                    if (_ref[_i].nodeType == '1') {
                        $element = _ref[_i].cloneNode(true);
                        _results.push(this.appendChild($element));
                    }
                }
                return _results;
            },
            enumerable: false,
            configurable: true
        });
    }
}
//======================================================================= 목차 편집 호출
function new_category_open(){
    var userwidth = (screen.width / 2);
    var userheight = (screen.height - 80);
    var new_category = window.open(API.treeEdit() + "?epubNum=" + ViewerManager.GetData.EPUB.ID,"new_category",'scrollbars=yes,toolbar=no,location=no,status=no,menubar=no,resizable=yes,width='+userwidth+',height='+userheight+',left=0,top=0');
    new_category.focus();
    return false
}
//=======================================================================
