define(['jquery', 'log', 'browser', 'params', 'epub', 'templet'], function ($, log, browser, params, epub, templet){
    'use strict';
    //console.log('selectviewer.js starting');
    if (params.Params.paramIns == 'none')
    {
        params.paramsInit();
    }

    var w_location = window.location.hostname + window.location.pathname;
    var view_center = function(target, stat)
    {
        var return_position = "0px";        var w_width = $(window).innerWidth();
        var w_height = $(window).innerHeight();
        if (w_height == 0) {w_height = $(document).height();}

        var t_width = $(target).width();
        var t_height = $(target).height();

        if (stat =='top')
        {
            if ((w_height / 2) - (t_height / 2) > 0)
            {
                return_position = (w_height / 2) - (t_height / 2) + "px";
            }
        }
        else if (stat == 'left')
        {
            if ((w_width / 2) - (t_width / 2) > 0)
            {
                return_position = (w_width / 2) - (t_width / 2) + "px";
            }
        }

        return return_position;
    },
    androidView = function()
    {
        //console.log('w_location',w_location);
        var id = ViewerManager.GetData.EPUB.ID; // 이북 ID
        var title = ViewerManager.GetData.EPUB.TITLE; // 이북 제목
        var epubPath = ViewerManager.GetData.EPUB.path; // 이북 경로 예) /data/contents/f28e0aa7-a9d9-f82a1afdbf04
        var thum = ViewerManager.GetData.EPUB.thumnail; // 이북 썸네일 경로 /data/contents/f28e0aa7-a9d9-f82a1afdbf04/10_thum.jpg
        var purchase = ViewerManager.Params.purchase; // 구매여부
        var prePageNo = ViewerManager.Params.prePageNo; // 미리보기 페이지 번호
        var SCHEME = ViewerManager.GetData.AND.SCHEME; // 고객사 구분 스키마
        var appId = ViewerManager.GetData.AND.appId; // 앱 아이디
        var share = ViewerManager.GetData.USE.share; // 공유하기 사용 여부
        var isDown = ViewerManager.GetData.DOWNLOAD.is; // 다운로드 체크
        var downURL = ViewerManager.GetData.DOWNLOAD.url; // 다운로드 경로
        var maxDate = ViewerManager.GetData.maxDate; // 최종 구독 가능 시간
        var author = ViewerManager.GetData.EPUB.AUTHOR; // 이북 저자

        isDown = isDown == "true" ? 1 : 0;

        if (String(ViewerManager.GetData.EPUB.absPath).length > 0) {epubPath = ViewerManager.GetData.EPUB.absPath;}
        // 구분자를 위해서 상세페이지는 가장 뒤에 붙여주도록 한다
        var detailURL = downURL;// 임시 다운로드 경로
        //var detailURL = ViewerManager.GetData.detailURL;// 상세페이지 주소

        var appUrl = "intent://" + SCHEME + "/?id=" + id + "&title=" + title + "&epubPath=" + epubPath + "&thum="+ thum+"&purchase="+ purchase + "&prePageNo=" + prePageNo + "&share=" + share + "&isDown=" + isDown + "&maxDate=" + maxDate + "&author=" + author + "&detailURL=" + detailURL + "#Intent;scheme=" + SCHEME + ";package=" + appId + ";end";
        //var appUrl = "intent://" + SCHEME + "/?id=" + id + "&title=" + title + "&epubPath=" + epubPath + "&thum="+ thum+"&purchase="+ purchase + "&prePageNo=" + prePageNo + "&share=" + share + "&detailURL=" + detailURL + "#Intent;scheme=" + SCHEME + ";package=" + appId + ";end";
        var marketUrl = "market://details?id=" + appId;
        if (params.Params.appType == 'sviewer')
        {
            location.href = appUrl;
        }
        else
        {
            // 앱이 실행되었는지 체크
            var openAt = new Date();

            setTimeout(function()
            {
                if (new Date() - openAt < 3500)
                {
                    location.href = marketUrl;
                }
            }, 4000);

            location.href = appUrl;
        }

        //$('body').html("");
        //$('body').html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>Waiting APP...</p></span></div>");
        //ViewerManager = null;
    },
    iOSView = function()
    {
        //console.log('w_location',w_location);
        var id = ViewerManager.GetData.EPUB.ID; // 이북 ID
        var title = ViewerManager.GetData.EPUB.TITLE; // 이북 제목
        var epubPath = ViewerManager.GetData.EPUB.path; // 이북 경로 예) /data/contents/f28e0aa7-a9d9-f82a1afdbf04
        var thum = ViewerManager.GetData.EPUB.thumnail; // 이북 썸네일 경로 /data/contents/f28e0aa7-a9d9f82a1afdbf04/10_thum.jpg
        var purchase = ViewerManager.Params.purchase; // 구매여부
        var prePageNo = ViewerManager.Params.prePageNo; // 미리보기 페이지 번호
        var SCHEME = ViewerManager.GetData.IOS.SCHEME; // 고객사 구분 스키마
        var appId = ViewerManager.GetData.IOS.appId; // 앱 아이디
        var share = ViewerManager.GetData.USE.share; // 공유하기 사용 여부
        var isDown = ViewerManager.GetData.DOWNLOAD.is; // 다운로드 체크
        var downURL = ViewerManager.GetData.DOWNLOAD.url; // 다운로드 경로
        var maxDate = ViewerManager.GetData.maxDate; // 최종 구독 가능 시간
        var author = ViewerManager.GetData.EPUB.AUTHOR; // 이북 저자

        isDown = isDown == "true" ? 1 : 0;

        if (String(ViewerManager.GetData.EPUB.absPath).length > 0) {epubPath = ViewerManager.GetData.EPUB.absPath;}
        // 구분자를 위해서 상세페이지는 가장 뒤에 붙여주도록 한다
        var detailURL = downURL;// 임시 다운로드 경로
        //var detailURL = ViewerManager.GetData.detailURL;// 상세페이지 주소

        var appUrl = SCHEME +"://?id=" + id + "&title=" + title + "&epubPath=" + epubPath + "&thum=" + thum + "&purchase=" + purchase + "&prePageNo=" + prePageNo + "&share=" + share + "&isDown=" + isDown + "&maxDate=" + maxDate + "&author=" + author + "&detailURL=" + detailURL;
        //var appUrl = SCHEME +"://?id=" + id + "&title=" + title + "&epubPath=" + epubPath + "&thum=" + thum + "&purchase=" + purchase + "&prePageNo=" + prePageNo + "&share=" + share + "&detailURL=" + detailURL;
        var marketUrl = "https://itunes.apple.com/app/" + appId;
        //var marketUrl = "https://itunes.apple.com/app/s-viewer/" + appId + "?ls=1&mt=8";

        var thisURL = "";
        //thisURL = "http://titanbooks.co.kr";//location.href;

        if (params.Params.appType == 'sviewer')
        {
            location.href = appUrl;
        }
        else
        {
            // 앱이 실행되었는지 체크
            var openAt = new Date();

            setTimeout(function()
            {
                location.href = marketUrl;
            }, 1000);

            location.href = appUrl;
        }

        //$('body').html("");
        //$('body').html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>Waiting APP...</p></span></div>");
        //ViewerManager = null;
    },
    WINView = function(osVer)
    {
        var id = ViewerManager.GetData.EPUB.ID; // 이북 ID
        var title = ViewerManager.GetData.EPUB.TITLE; // 이북 제목
        var epubPath = ViewerManager.GetData.EPUB.path; // 이북 경로 예) /data/contents/f28e0aa7-a9d9-f82a1afdbf04
        var thum = ViewerManager.GetData.EPUB.thumnail; // 이북 썸네일 경로 /data/contents/f28e0aa7-a9d9f82a1afdbf04/10_thum.jpg
        var purchase = ViewerManager.Params.purchase; // 구매여부
        var prePageNo = ViewerManager.Params.prePageNo; // 미리보기 페이지 번호
        var SCHEME = ViewerManager.GetData.WIN.SCHEME; // 고객사 구분 스키마
        var appId = ViewerManager.GetData.WIN.appId; // 앱 아이디
        var share = ViewerManager.GetData.USE.share; // 공유하기 사용 여부
        var isDown = ViewerManager.GetData.DOWNLOAD.is; // 다운로드 체크
        var downURL = ViewerManager.GetData.DOWNLOAD.url; // 다운로드 경로

        // 구분자를 위해서 상세페이지는 가장 뒤에 붙여주도록 한다
        var detailURL = ViewerManager.GetData.detailURL;// 상세페이지 주소

        //var appUrl = "sviewer-" + SCHEME +":id=" + id + "&title=" + title + "&epubPath=" + epubPath + "&thum=" + thum + "&purchase=" + purchase + "&prePageNo=" + prePageNo + "&share=" + share + "&isDown=" + isDown + "&downURL=" + downURL;
        var appUrl = "sviewer-" + SCHEME +":id=" + id + "&title=" + title + "&epubPath=" + epubPath + "&thum=" + thum + "&purchase=" + purchase + "&prePageNo=" + prePageNo + "&detailURL=" + detailURL;
        var marketUrl = "https://www.microsoft.com/store/apps/9nblggh1mln7";

        if (osVer == 8)
        {
            marketUrl = "http://apps.microsoft.com/windows/app/" + appId.split('@')[0];
        }
        else if (osVer == 10)
        {
            marketUrl = "https://www.microsoft.com/store/apps/" +  appId.split('@')[1];
        }

        // 앱이 실행되었는지 체크
        var openAt = new Date();

        setTimeout(function()
        {
            if (new Date() - openAt < 4000)
            {
                location.href = marketUrl;
            }
        }, 4000);

        location.href = appUrl;

        //$('body').html("");
        //$('body').html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>Waiting APP...</p></span></div>");
        //ViewerManager = null;
    };

    if (browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
        ViewerManager.VIEWER_DEVICE = "ANDROID";
    } else if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
        ViewerManager.VIEWER_DEVICE = "IOS";
    } else {
        ViewerManager.VIEWER_DEVICE = "PC";
    }

    // 각 환경 분기 처리
    if ((ViewerManager.GetData.USE.and == 'true') && (browser.isMobile.androidPhone || browser.isMobile.androidTablet))
    {
        params.paramRetake();

        // 안드로이드 디바이스에서 안드로이드 앱이 있는 경우
        if (ViewerManager.CustomizeType == 'MAINAGE')
        {
            //console.log("Runtiim environment : android / android app - CustomizeType : mainage");
            connectView();
        }
        else
        {
            if (window.localStorage.getItem('isVIEWER') != null && window.localStorage.getItem('isVIEWER') == 'true')
            {
                //console.log("Runtiim environment : android / android app - localStorage : IsViewer");
                connectView();
            }
            else if (params.Params.appType == 'sviewer')
            {
                //console.log("Runtiim environment : android / android app - add type : IsViewer");
                connectView();
            }
            else
            {
                //console.log("Runtiim environment : android / open select view");
                // 선택창 열기
                openSelect();
            }
        }
    }
    else if ((ViewerManager.GetData.USE.ios == 'true') && (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad))
    {
        params.paramRetake();

        // 애플 디바이스에서 애플 앱이 있는 경우
        if (ViewerManager.CustomizeType == 'MAINAGE')
        {
            //console.log("Runtiim environment :  ios / ios app -  CustomizeType : mainage");
            connectView();
        }
        else
        {
            if (window.localStorage.getItem('isVIEWER') != null && window.localStorage.getItem('isVIEWER') == 'true')
            {
                //console.log("Runtiim environment :  ios / ios app -  localstorage : isViewer");
                connectView();
            }
            else if (params.Params.appType == 'sviewer')
            {
                //console.log("Runtiim environment :  ios / ios app -  addtype : sviewer");
                connectView();
            }
            else
            {
                // 선택창 열기
                //console.log("Runtiim environment :  ios / ios app -  open select view");
                openSelect();
            }
        }
    }

    /*
    else if ((ViewerManager.GetData.USE.win == 'true') && (browser.windowOS == 8 || browser.windowOS == 10))
    {
        params.paramRetake();
        // 윈도우 앱을 사용 하는 경우
        // 선택창 열기
        //openSelect();
        $('#select_viewer').remove();
        $('#container').css('display', 'block');
    }
    */

    else
    {
        params.paramRetake();
        //console.log("ViewerManager.ePub.ops_name", ViewerManager.ePub.ops_name);
        // 웹뷰만 사용하는 경우
        // 자바스크립트 호출 전, 브라우져 체크
        browser.ie7 = false;
        if (browser.ie6 || browser.ie7)
        {
            alert("서비스가 지원되지 않는 IE 버젼입니다. \n IE 8 이상에서 사용해 주세요.");
            //ViewerManager = null;
            $('body').html("");
            window.close();
        }

        else if (browser.ie8 && ViewerManager.imageUse == 'true')
        {
            //console.log("Runtiim environment :  PC ie8 , ViewerManager.imageUse = true");
            $('#select_viewer').remove();
            $('body').html("");

            ViewerManager.image_check = true;
            ViewerManager.main_check = false;
        }

        else
        {
            if (browser.ie8)
            {
                alert("서비스가 지원되지 않는 IE 버젼입니다. \n IE 8 에서 Epubmaker Image 모드를 사용해 주세요.");
                //ViewerManager = null;
                $('body').html("");
                window.close();

                return;
            }
            if (ViewerManager.GetData.DOWNLOAD.is == "true")
            {
                $('body').children().remove();

                var domain = window.location.origin ? window.location.origin : window.location.protocol + "//" + window.location.hostname + ( window.location.port ? ':'+window.location.port : '' );

                var downloadWindow = window.open("Epub Download...");
                downloadWindow.location.href = domain + '/download.php?dwld_file_name=' + ViewerManager.GetData.EPUB.ID + '.epub&dwld_file_path=_good&filename_org=' + ViewerManager.GetData.EPUB.TITLE + '.epub';

                window.close();
            }
            else
            {
                //console.log("Select Viewer  removed ");
                $('#select_viewer').remove();
                $('#container').css('display', 'block');

                ViewerManager.image_check = false;
                ViewerManager.main_check = true;
            }
        }
    }

    function openSelect()
    {
        //console.log(browser.safari, browser.safari3);
        $('body').css('background', '#404040');
        $('#select_viewer').css({'display' : 'block', 'top': view_center($('#select_viewer'), 'top'), 'left' : view_center($('#select_viewer'), 'left')});
        document.getElementById('select_viewer').innerHTML = templet.selectViewer;

        $(window).on('resize', function (){$('#select_viewer').css({'top': view_center($('#select_viewer'), 'top'), 'left' : view_center($('#select_viewer'), 'left')});});
        $('#APP_VIEW').on('click', function (){
            connectView();

            // 뷰어 설정 저장
            if (window.localStorage.getItem('isVIEWER') == null)
            {
                //window.localStorage.setItem('isVIEWER', 'false');
                window.localStorage.setItem('isVIEWER', 'true');// 고정할 때
            }
        });

        $('#WEB_VIEW').on('click', function (){
            ViewerManager.WebApp = true;
            $('#select_viewer').remove();

            $('#container').css('display', 'block');

            /*$('#way_popup').css('display', 'block');

            var hideTime = setTimeout(function(){
                $('#way_popup').animate({opacity : 0}, 500);
                setTimeout(function (){$('#way_popup').css('display', 'none')}, 500);
            }, 1200);*/

            if (index_init == true)
            {
                ViewerManager.main_check = true;
                change_require('main');
            }
            else
            {
                ViewerManager.main_check = true;
            }
        });
        //문체부일경우 바로 웹뷰로 연결
        //$('#WEB_VIEW').trigger('click');
    }

    function connectView ()
    {
        $('body').html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>Waiting APP...</p></span></div>");
        ViewerManager.WebApp = false;

        if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad)
        {
            iOSView();
        }
        else if (browser.isMobile.androidPhone || browser.isMobile.androidTablet)
        {
            androidView();
        }
        else if (browser.windowOS == 8 || browser.windowOS == 10)
        {
            WINView(browser.windowOS);
        }
    }

    function inside_connectView ()
    {
        if (confirm("SViewer 앱으로 이동합니다."))
        {
            params.paramRetake();
            connectView();
        }
    }

    var selectViewer = {inside_connectView : inside_connectView};

    return selectViewer;
});
