define(['jquery', 'log', 'browser', 'xml2json', 'params'], function ($, log, browser, xml2json, params) {
	'use strict';

	log("\n @ import epub.js ... \n");

	// use Titan Server only
	// ViewerManager.Path.cntsFilePath = page.getURLParameter('DOC_URL');
	//if (ViewerManager.VIEWER_TYPE === "WEB_MULTI_TITAN") ViewerManager.Path.cntsFilePath = page.getURLParameter('epub') + "/1/";
	//if (ViewerManager.VIEWER_TYPE === "WEB_MULTI") ViewerManager.Path.cntsFilePath = page.getURLParameter("epub") + "/";

	if (params.Params.paramIns == 'none')
    {
        params.paramsInit();
    }
   // 모바일 이면서 ViewerManager.WebApp == false 이면 return, 즉 모바일이면서 웹엡을 사용하지 않겠는 사용자 선택이 있을 경우
   // selectViewer 를 진행하지 않는다. ---> native app 사용
    if ((browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) && ViewerManager.WebApp == false) {return;}

	log("@ ViewerManager.Path.cntsFilePath= " + ViewerManager.Path.cntsFilePath);

	var epubDirPath = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath;

	ViewerManager.ePub.container_xml2json_data_Array = [];
	ViewerManager.ePub.opf_xml2json_data_Array = [];
	ViewerManager.ePub.opf_xml2json_total_len = []; // epub total 파일 개수
	ViewerManager.ePub.ops_name = [];
	ViewerManager.thumbnails = [];

	// 파일 유무확인을 먼저 하자
	/*var req = new XMLHttpRequest();
    req.open('post', epubDirPath + 'META-INF/container.xml', false);
    req.send(null);
    var headers = req.status;

    if (headers == 404) {
    	$('body').html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>container.xml file not found!</p><p style='font-size: 25px;'>check the ePub content root path.</p></span></div>");
    	ViewerManager.openError = true;
    	return;
    }*/

	// META-INF/container.xml
	$.ajax({
		url: (epubDirPath + 'META-INF/container.xml'),
		dataType: 'xml',
		async: false,
		success: function (xml) {
			var container_xml2json = $.xml2json(xml);
			log("@ " + container_xml2json['rootfiles']['rootfile']['full_path']);
			// opf 경로 값
			ViewerManager.ePub.container_xml2json_data_Array.push(container_xml2json['rootfiles']['rootfile']['full_path']);
		},
		error: function (xhr, status, error) {
			log("@ container_xml2json error : " + error);
			ViewerManager.openError = true;
			$('body').html("<div style='width : 100%; text-align: center; margin-top: 200px;' ><span style='font-size: 50px; color:#333333;'><p>container.xml file not found!</p><p style='font-size: 25px;'>check the ePub content root path.</p></span><br><p>" + (epubDirPath + 'META-INF/container.xml') + "</p></div>");
		},
		complete: function () {
			log("@ META-INF/container.xml complete");

			if (ViewerManager.openError == true) {return;}

			// ops 이름 (ops/OEBPS)
			ViewerManager.ePub.ops_name = ViewerManager.ePub.container_xml2json_data_Array[0].split('/');

			// OEBPS/toc.xhtml
			log("@ toc.xhtml path : " + epubDirPath + ViewerManager.ePub.ops_name[0] + '/toc.xhtml');
			$.ajax({
				url: (epubDirPath + ViewerManager.ePub.ops_name[0] + '/toc.xhtml'),
				dataType: 'xml',
				async: false,
				success: function (data) {
				/*	var contentIndex = $.xml2json(data);
					if (contentIndex.body.section.nav) {
						// ViewerManager.ePub.contentIndex = contentIndex.body.section.nav.ol.li;
						ViewerManager.ePub.contentIndex = contentIndex.body.section.nav;
					} else {
						log("@ toc data not saved...");
						ViewerManager.ePub.contentIndex = null;
					}*/
					ViewerManager.ePub.toc = data;
				},
				error: function (xhr, status, error) {
					log("@ OEBPS/toc.xhtml error : " + error);
					$('#pages').empty().append("<div style='width : " + ViewerManager.bookContainerWidth + "px; text-align: center;' ><br><br><br><br><br><span style='font-size: 50px; color:#333333;'><p>" + error + "</p><p style='font-size: 25px;'>check the toc.xhtml file.</p></span></div>");
				},
				complete: function () {
					log("@ OEBPS/toc.xhtml complete");
				}
			}); // end JSON	ajax

			// var xmlhttp = new XMLHttpRequest();
			/*var xmlhttp;
			(function () {
				if(window.ActiveXObject) {
					xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
				} else if(window.XMLHttpRequest) {
					xmlhttp = new XMLHttpRequest();
				}
			})();
			xmlhttp.open("GET", (epubDirPath + ViewerManager.ePub.ops_name[0] + '/toc.xhtml'), false);
			xmlhttp.send();

			ViewerManager.ePub.toc = xmlhttp.responseXML;*/

			// contents path
			$.ajax({
				// opf 경로 위치 조합
				url: (epubDirPath + ViewerManager.ePub.container_xml2json_data_Array),
				dataType: 'xml',
				async: false,
				success: function(xml) {
					var opf_xml2json = $.xml2json(xml);
					ViewerManager.ePub.opf_xml2json_total_len = opf_xml2json.spine.itemref.length; // total html length
					var opf_xml2json_item_len = opf_xml2json.manifest.item.length; // item length

//console.log("opf_xml2json.metadata.use_image", (epubDirPath + ViewerManager.ePub.container_xml2json_data_Array), opf_xml2json.metadata, opf_xml2json.metadata['use_image']);
					if (opf_xml2json.metadata['use_image'])
					{
						// 이미지 사용
						ViewerManager.imageUse = "true";
						ViewerManager.imageFile = opf_xml2json.metadata['use_image'];
					}
					//컨텐트의 width
					if (opf_xml2json.metadata['pagewidth']) ViewerManager.iframeContentsWidth = opf_xml2json.metadata['pagewidth'];
					//컨텐트의 height
					if (opf_xml2json.metadata['pageheight']) ViewerManager.iframeContentsWidth = opf_xml2json.metadata['pagewidth'];

					ViewerManager.GetData.EPUB.startPageIndex = parseInt(opf_xml2json.metadata['startpage_index'] ?   opf_xml2json.metadata['startpage_index'] : 1);

					ViewerManager.Local.cntsTitle = opf_xml2json.metadata.title;
					// 이펍으로부터 책이름을 받은 경우
					if (ViewerManager.GetData.EPUB.TITLE.length > 0) {ViewerManager.Local.cntsTitle = ViewerManager.GetData.EPUB.TITLE;};
					// 지정된 타이틀이 존재하는 경우, 교체
					if (ViewerManager.GetData.EPUB.absTitle.length > 0) {ViewerManager.Local.cntsTitle = ViewerManager.GetData.EPUB.absTitle;};
					ViewerManager.Local.eBookType = opf_xml2json.metadata.ebooktype;

					// 1개만 있을 경우 length 가 undefined 나타남
					if (ViewerManager.ePub.opf_xml2json_total_len === undefined) {
						log("@ undefined process");
						ViewerManager.ePub.opf_xml2json_total_len = 1;

						for (var y = 0; y <= opf_xml2json_item_len - 1 ; y++) {
							if (opf_xml2json.spine.itemref.idref === opf_xml2json.manifest.item[y].id) {
								log("@ 1 " + opf_xml2json.manifest.item[y].id + "=" + opf_xml2json.manifest.item[y].href);
								ViewerManager.ePub.opf_xml2json_data_Array.push(opf_xml2json.manifest.item[y].href);
							}
						}
					} else {
						// 총 html 개수 에서 연결할 html 을 구함
						for (var x = 0; x <= ViewerManager.ePub.opf_xml2json_total_len - 1 ; x++) {
							for (var y = 0; y <= opf_xml2json_item_len - 1 ; y++) {
								if (opf_xml2json.spine.itemref[x].idref === opf_xml2json.manifest.item[y].id) {
									log("@ 2 " + opf_xml2json.manifest.item[x].id + "=" + opf_xml2json.manifest.item[y].href);
									ViewerManager.ePub.opf_xml2json_data_Array.push(opf_xml2json.manifest.item[y].href);
								}
							}
						}
					}

					// 썸네일 경로 지정
					for (var i = 0; i < ViewerManager.ePub.opf_xml2json_data_Array.length; i++) {
						// 'content/page00002.xhtml' 에서 아래 구문대로 뽑아냄  -> 최종 Thumbnail name => 'page00002 의 형태임
						var thum = findThumbnail(ViewerManager.ePub.opf_xml2json_data_Array[i].split('/')[1].split('.')[0]);
						ViewerManager.thumbnails.push(thum);
					}

					function findThumbnail (_pageHref) {
						var returnThum = '';
						for (var t = 0; t < opf_xml2json.manifest.item.length; t++) {
							if (opf_xml2json.manifest.item[t].href.indexOf('thumbnail') == -1) {
								continue;
							} else {
								if (opf_xml2json.manifest.item[t].href.indexOf(String(_pageHref)) == -1) {
									continue;
								} else {
									returnThum = opf_xml2json.manifest.item[t].href;

									break;
								}
							}
						}

						return returnThum;
					}

					if (ViewerManager.GetData.PROGRESS.progressRateType == "OutOfOrder") {
						for (var p = 0; p < parseInt(ViewerManager.ePub.opf_xml2json_total_len); p++) {
							ViewerManager.GetData.PROGRESS.progressRateArray[p] = "N";
							if (ViewerManager.GetData.PROGRESS.progressRateData.substr(p, 1) == "Y") {
								ViewerManager.GetData.PROGRESS.progressRateArray[p] = "Y";
							}
						}
					} else if (ViewerManager.GetData.PROGRESS.progressRateType == "Order") {
						for (var p = 0; p < parseInt(ViewerManager.ePub.opf_xml2json_total_len); p++) {
							ViewerManager.GetData.PROGRESS.progressRateArray[p] = "N";
							if (p <= parseInt(ViewerManager.urlPage) - 1) {
								ViewerManager.GetData.PROGRESS.progressRateArray[p] = "Y";
							}
						}
					}
				},
				error: function(xhr, status, error) {
					log("@ opf_xml2json error : " + error);
					$('#pages').empty().append("<div style='width : " + ViewerManager.bookContainerWidth + "px; text-align: center;' ><br><br><br><br><br><span style='font-size: 50px; color:#333333;'><p>" + error + "</p><p style='font-size: 25px;'>check the opf file path.</p></span></div>");
				},
				complete: function() {
					// log("complete");
					ViewerManager.ePub.opf_xml2json_total_len = ViewerManager.ePub.opf_xml2json_total_len; // 총갯수
					ViewerManager.ePub.opf_xml2json_data_Array = ViewerManager.ePub.opf_xml2json_data_Array; // html 경로

					log("@ ViewerManager.ePub.opf_xml2json_total_len : " +  ViewerManager.ePub.opf_xml2json_total_len);
					log("@ ViewerManager.ePub.opf_xml2json_data_Array : " +  ViewerManager.ePub.opf_xml2json_data_Array);

					if (browser.ie8) {return;}

					// 1페이지의 크기를 기억하기 (ViewerManager.iframeContentsWidth, ViewerManager.iframeContentsHeight)
					$.ajax({
						url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] + "/" + ViewerManager.ePub.opf_xml2json_data_Array[0],
						dataType: 'html',
						async: false,
						success: function (data) {
							var container_xml2json = $.xml2json(data);
							for (var i = 0; i < container_xml2json['head']['meta'].length; i++) {
								if (container_xml2json['head']['meta'][i]['name'] && container_xml2json['head']['meta'][i]['name'] == 'viewport') {
									var attr = container_xml2json['head']['meta'][i]['content'].split(',');
									if (attr[0].indexOf('width') != -1) {
										ViewerManager.iframeContentsWidth = attr[0].split('=')[1];
										ViewerManager.iframeContentsHeight = attr[1].split('=')[1];
									}
									else if (attr[0].indexOf('height') != -1) {
										ViewerManager.iframeContentsWidth = attr[1].split('=')[1];
										ViewerManager.iframeContentsHeight = attr[0].split('=')[1];
									}
								}
							}
						}
					});
				}
			});
		}
	});
});
