define(['jquery', 'log', 'xml2json'], function ($, log, xml2json) {
	'use strict';

	log("\n @ import epubImages.js ... \n");

	// use Titan Server only
	// ViewerManager.Path.cntsFilePath = page.getURLParameter('DOC_URL');

	log("@ ViewerManager.Path.cntsFilePath= " + ViewerManager.Path.cntsFilePath);

	var epubDirPath = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath;

	ViewerManager.ePub.container_xml2json_data_Array = [];
	ViewerManager.ePub.opf_xml2json_data_Array = [];
	ViewerManager.ePub.opf_xml2json_total_len = []; // epub total 파일 개수
	ViewerManager.ePub.ops_name = [];
	ViewerManager.thumbnails = [];

	function fillzero(obj, len) {
		obj= "000" + obj;
		return obj.substring(obj.length-len);
	}

	// META-INF/container.xml
	$.ajax({
		url: (epubDirPath + 'META-INF/container.xml'),
		dataType: 'xml',
		async: false,
		success: function (xml) {
			var container_xml2json = $.xml2json(xml);
			log("@ " + container_xml2json['rootfiles']['rootfile']['full_path']);
			// opf 경로 값
			ViewerManager.ePub.container_xml2json_data_Array.push(container_xml2json['rootfiles']['rootfile']['full_path']);
		},
		error: function (xhr, status, error) {
			log("@ container_xml2json error : " + error);
		},
		complete: function () {
			log("@ META-INF/container.xml complete");

			// 총 갯수로 페이지 명 가져옴

			// ops 이름 (ops/OEBPS)
			$("body").css({"border":"0", "padding":"0", "margin":"0", "overflow":"auto"});
			$("body").html("");
			ViewerManager.ePub.ops_name = ViewerManager.ePub.container_xml2json_data_Array[0].split('/');

			// contents path
			$.ajax({
				// opf 경로 위치 조합
				url: (epubDirPath + ViewerManager.ePub.container_xml2json_data_Array),
				dataType: 'xml',
				async: false,
				success: function(xml) {
					var opf_xml2json = $.xml2json(xml);
					var contentMax = ViewerManager.ePub.opf_xml2json_total_len = opf_xml2json.spine.itemref.length; // total html length

					for(var i = 1; i <= contentMax ; i++ ) {
						$("body").append("<div class='imageView'align=center><img src = " + epubDirPath + ViewerManager.ePub.ops_name[0] + "/content/images/page" + fillzero(i,3) + "/" + ViewerManager.imageFile + "  align=center style='width:100%;'></div>");
					}

				},
				error: function(xhr, status, error) {
					log("@ opf_xml2json error : " + error);
				},
				complete: function() {
					 log("complete");
				}
			});
		}
	});
});
