define(['jquery', 'log'], function ($, log) {
	'use strict';

	log("\n @ import language.js ...\n");

	var languageFileName = "language/" + ViewerManager.language + "_language.json";

	log("@ language : " + languageFileName);

	$.ajax({
		url: languageFileName,
		dataType: 'json',
		async: false,
		success: function (data) {
			ViewerManager.Local.exitPopContents = data.exit_lang.exitPopContents; // 팝업 내용
			ViewerManager.Local.eraserPopContents = data.eraser_lang.eraserPopContents; // 팝업 내용
			ViewerManager.Local.dataDeletePopContents = data.dataDelete_lang.dataDeletePopContents;

			ViewerManager.Local.memoContents = data.memo_lang.memoContents; // 메모 내용
			ViewerManager.Local.memoPopTitle = data.memo_lang.memoPopTitle; // 팝업 제목
			ViewerManager.Local.memoPopContents = data.memo_lang.memoPopContents; // 팝업 내용
			ViewerManager.Local.memoPopEmptyContents = data.memo_lang.memoPopEmptyContents; // 메모 팝업 저장 클릭시 내용없음
			ViewerManager.Local.memoTitle = data.memo_lang.memoTitle;

			ViewerManager.Local.linkTitle = data.link_lang.linkTitle;
			ViewerManager.Local.linkContents = data.link_lang.linkContents;
			ViewerManager.Local.linkDeleteText = data.link_lang.linkDeleteText;

			ViewerManager.Local.modeTitle = data.drawMode_lang.modeTitle;
			ViewerManager.Local.modeNoticeText = data.drawMode_lang.modeNoticeText;

			ViewerManager.Local.linkUrlError = data.toolTip_lang.linkUrlError;
			ViewerManager.Local.emptyHistory = data.toolTip_lang.emptyHistory;
			ViewerManager.Local.connectionError = data.toolTip_lang.connectionError;
			ViewerManager.Local.noticeZoomRate = data.toolTip_lang.noticeZoomRate;

			ViewerManager.Local.linkPopupTitle = data.popupLayer_lang.linkPopupTitle;
			ViewerManager.Local.linkPopupButton = data.popupLayer_lang.linkPopupButton;
			ViewerManager.Local.indexListPopupTitle = data.popupLayer_lang.indexListPopupTitle;
			ViewerManager.Local.defaultSearchText = data.popupLayer_lang.defaultSearchText;

			ViewerManager.Local.indexListMenu1 = data.popupLayer_lang.indexListMenu1;
			ViewerManager.Local.indexListMenu2 = data.popupLayer_lang.indexListMenu2;
			ViewerManager.Local.indexListMenu3 = data.popupLayer_lang.indexListMenu3;

			ViewerManager.Local.indexListButtonSearch = data.popupLayer_lang.indexListButtonSearch;
			ViewerManager.Local.indexListButtonNaverSearch = data.popupLayer_lang.indexListButtonNaverSearch;
			ViewerManager.Local.indexListButtonIndex = data.popupLayer_lang.indexListButtonIndex;
			ViewerManager.Local.indexListButtonBookmark = data.popupLayer_lang.indexListButtonBookmark;
			ViewerManager.Local.indexListButtonDraw = data.popupLayer_lang.indexListButtonDraw;
			ViewerManager.Local.indexListButtonMemo = data.popupLayer_lang.indexListButtonMemo;
			ViewerManager.Local.indexListButtonLink = data.popupLayer_lang.indexListButtonLink;
			ViewerManager.Local.indexListEmptySearch = data.popupLayer_lang.indexListEmptySearch;
			ViewerManager.Local.indexListPage = data.popupLayer_lang.indexListPage;
			ViewerManager.Local.indexListEmptyBookmark = data.popupLayer_lang.indexListEmptyBookmark;
			ViewerManager.Local.indexListEmptyDraw = data.popupLayer_lang.indexListEmptyDraw;
			ViewerManager.Local.indexListEmptyMemo = data.popupLayer_lang.indexListEmptyMemo;
			ViewerManager.Local.indexListEmptyLink = data.popupLayer_lang.indexListEmptyLink;
			ViewerManager.Local.indexListLinkAlert = data.popupLayer_lang.indexListLinkAlert;
			ViewerManager.Local.searchByNaverInfo = data.popupLayer_lang.searchByNaverInfo;
			ViewerManager.Local.searchButtonText = data.popupLayer_lang.searchButtonText;
			ViewerManager.Local.continueSearchButtonText = data.popupLayer_lang.continueSearchButtonText;
			ViewerManager.Local.endSearchButtonText = data.popupLayer_lang.endSearchButtonText;
			ViewerManager.Local.morePopupTitle = data.popupLayer_lang.morePopupTitle;


		},
		error: function (xhr, status, error) {
			log("@ error = " + error);
		},
		complete: function () {
			log("@ complete");
		}
	});
});
