define(['jquery', 'log'], function ($, log) {
	'use strict';

	log("@ import params.js");

	var s_href = window.location.href;
	var app_type = s_href.split('app=')[1];

	var Params = {
		paramIns : 'none',
		absPath : '', absTitle : '', cntsDirPath : '', cntsFilePath : '',
		purchase : '0', prePageNo : 'none', viewPageNo : '0', bgType : 'color', bgColor : 'e8e8ea', bgUrl : 'images/bg/bg_pattern.gif', menuSpeed : '300', CustomizeType : '6MENU1', uiHold : '0',logoURL : 'fdesk', graWidth : '50', maxDate : '', zoomRate: '', useComment : 'false',
		epubID : '', epubTitle : '', epubPath : '', epubThumnail : '', epubAuthor : '',
		andKey : '', iosKey : '', winKey : '', detailURL : '',
		useSync : '', useBookContents : '', useAND : '', useIOS : '', useWIN : '', useSHARE : '', useLogin : '0',
		imageUse : '', imageFile : '',
		isDownload : '', downloadURL : '',
		appType : '',
		progressRate : 'false', progressRateType : 'Order', progressRateData : '',
		owner : '', loginKey : '', userIp : '', fileDownloadURL : '', returnURL : ''
	},
	paramsInit = function(){
		if (Params.paramIns == 'none')
		{
			Params.paramIns = 'made';
		}

		// 기본 정보
		Params.cntsDirPath = $('#DIRFS').attr('value');// 컨텐츠 경로
		Params.cntsFilePath = $('#EPUBN').attr('value');
		Params.purchase = $('#ORDER').attr('value');// 구매 확인
		Params.prePageNo = $('#FPAGE').attr('value');// 미리보기 페이지
		Params.viewPageNo = $('#VPAGE').attr('value');// 최초 페이지

		// 세팅 정보
		Params.bgType = $('#BGTYPE').attr('value');// 배경타입
		Params.bgColor = $('#BGCOLOR').attr('value');// 배경색상
		Params.bgUrl = $('#BGURL').attr('value');// 배경 이미지경로
		Params.menuSpeed = $('#MENUSPEED').attr('value');// 메뉴 이동 속도
		Params.CustomizeType = $('#UITYPE').attr('value');// 커스터마이징 타입
		Params.uiHold = $('#UI_HOLD').attr('value');// UI 고정
		Params.logoURL = $('#LOGOURL').attr('value');// 로고 경로
		Params.graWidth = $('#GRAWIDTH').attr('value');// 그라데이션 넓이
		Params.zoomRate = String($('#ZOOM_RATE').attr('value')).split('_|@|_');// 줌 비율
		Params.useComment = $('#USE_COMMENT').attr('value');// 댓글 게시판 사용 여부

		// 이펍 아이디
		Params.maxDate = $('#MAXDATE').attr('value');// 최종 구독 가능 시간
		Params.epubID = $('#BOOK_ID').attr('value');// 컨텐츠 경로
		Params.epubTitle = $('#BOOK_NAME').attr('value');// 이펍 제목

		Params.epubPath = Params.cntsDirPath + Params.cntsFilePath;// 이펍 경로
		Params.epubThumnail = $('#BOOK_COVER').attr('value');// 이펍 썸네일
		Params.epubAuthor = $('#BOOK_AUTHOR').attr('value');// 이펍 저자

		// 디바이스 정보
		Params.andKey = String($('#AND_KEY').attr('value')).split('_|@|_');// 안드로이드 정보
		Params.iosKey = String($('#IOS_KEY').attr('value')).split('_|@|_');// 애플 정보
		Params.winKey = String($('#WIN_KEY').attr('value')).split('_|@|_');// 윈도우 정보

		// 상세페이지 주소
		Params.detailURL = $('#BOOKVIEW_URL').attr('value');// 상세페이지 주소

		// 데이터 싱크 사용 여부
		Params.useSync = $('#USE_SYNC').attr('value');// 데이터 싱크 사용 여부
		// 북 컨텐츠 사용 여부
		Params.useBookContents = $('#USE_BOOKCONTENTS').attr('value');// 북 컨텐츠 사용 여부
		// 어플리케이션 사용 여부
		Params.useAND = $('#USE_AND').attr('value');// 안드로이드 앱 사용 여부
		Params.useIOS = $('#USE_IOS').attr('value');// 애플 앱 사용 여부
		Params.useWIN = $('#USE_WIN').attr('value');// 윈도우 앱 사용 여부
		Params.useSHARE = $('#USE_SHARE').attr('value');// 공유하기 사용 여부
		// 로그인 사용 여부
		Params.useLogin = $('#USE_LOGIN').attr('value');// 로그인 사용 여부

		// 다운로드 체크 및 경로
		Params.isDownload = $('#IS_DOWNLOAD').attr('value');// 다운로드 체크
		Params.downloadURL = String($('#BOOKDOWNLOAD_URL').attr('value'));// 다운로드 경로

		// 앱으로 보내줄 절대경로
		Params.absPath = $('#ABSPATH').attr('value');
		// 웹에서 사용될 지정 타이틀 설정 >> 없으면 opf 내용의 타이틀 명으로 설정
		Params.absTitle = $('#ABSTITLE').attr('value');

		// 앱으로부터 정보를 받는 경우
		Params.appType = app_type;

		// 진도율 정보
		Params.progressRate = $('#PROGRESS_RATE').attr('value');
		Params.progressRateType = $('#PROGRESS_RATE_TYPE').attr('value');
		Params.progressRateData = $('#PROGRESS_RATE_DATA').attr('value');

		// 유저 정보
		Params.owner = $('#OWNER').attr('value');
		Params.loginKey = $('#USER_LOGIN_KEY').attr('value');
		//Params.userIp = $('#USER_IP').attr('value');

		// 파일 다운로드 링크
		Params.fileDownloadURL = $('#FILE_DOWNLOAD_URL').attr('value');

		// SSG 닫기 버튼 링크
		Params.returnURL = $('#RETURN_URL').attr('value');

		ViewerManager.userInfo.owner = Params.owner == undefined ? "0" : Params.owner;
		ViewerManager.userInfo.loginKey = Params.loginKey == undefined ? "" : Params.loginKey;
		if (String(ViewerManager.userInfo.loginKey).length > 0) {ViewerManager.VIEWER_TYPE = "TITAN";}
		//ViewerManager.userInfo.userIp = Params.userIp;

		ViewerManager.Params.purchase = Params.purchase;
		ViewerManager.Params.prePageNo = Params.prePageNo;
		ViewerManager.urlPage = Params.viewPageNo;

		ViewerManager.Settings.bgType = Params.bgType;
		ViewerManager.Settings.bgColor = Params.bgColor;
		ViewerManager.Settings.bgUrl = Params.bgUrl;
		ViewerManager.Settings.menuSpeed = parseInt(Params.menuSpeed);
		ViewerManager.Settings.uiHold = Params.uiHold;
		ViewerManager.Settings.logoURL = Params.logoURL;

		if (parseInt(Params.graWidth) < 0 || parseInt(Params.graWidth) > 100 || isNaN(parseInt(Params.graWidth)))
		{
			ViewerManager.Settings.graWidth = 50;
		}
		else
		{
			ViewerManager.Settings.graWidth = parseInt(Params.graWidth);
		}

		ViewerManager.Settings.zoomRate1 = parseInt(Params.zoomRate[0]) < 100 ? "100" : Params.zoomRate[0];
		ViewerManager.Settings.zoomRate2 = parseInt(Params.zoomRate[1]) < parseInt(Params.zoomRate[0]) ? Params.zoomRate[0] : Params.zoomRate[1];

		ViewerManager.Settings.useComment = Params.useComment;

		ViewerManager.CustomizeType = (Params.CustomizeType.length == 0) ? ViewerManager.CustomizeType : Params.CustomizeType;

		// 저장
		setData();

		// ePubMaker 설정
		if (window.location.port === "15779") ViewerManager.VIEWER_TYPE = "LOCAL";
		if (ViewerManager.isPREVIEWMODE) {
			ViewerManager.Path.cntsDirPath = "work/";
			ViewerManager.Path.cntsFilePath = "";
		}
	},
	paramRetake = function()
	{
		if ($('#getForm').html() == undefined)
		{
			return;
		}

		// 이펍 아이디
		Params.maxDate = $('#MAXDATE').attr('value');// 최종 구독 가능 시간
		Params.epubID = $('#BOOK_ID').attr('value');// 컨텐츠 경로
		Params.epubTitle = $('#BOOK_NAME').attr('value');// 이펍 제목
		Params.epubPath = Params.cntsDirPath + Params.cntsFilePath;// 이펍 경로
		Params.epubThumnail = $('#BOOK_COVER').attr('value');// 이펍 썸네일

		// 디바이스 정보
		Params.andKey = String($('#AND_KEY').attr('value')).split('_|@|_');// 안드로이드 정보
		Params.iosKey = String($('#IOS_KEY').attr('value')).split('_|@|_');// 애플 정보
		Params.winKey = String($('#WIN_KEY').attr('value')).split('_|@|_');// 윈도우 정보

		// 상세페이지 주소
		Params.detailURL = $('#BOOKVIEW_URL').attr('value');// 상세페이지 주소

		// 데이터 싱크 사용 여부
		Params.useSync = $('#USE_SYNC').attr('value');// 데이터 싱크 사용 여부
		// 북 컨텐츠 사용 여부
		Params.useBookContents = $('#USE_BOOKCONTENTS').attr('value');// 북 컨텐츠 사용 여부
		// 어플리케이션 사용 여부
		Params.useAND = $('#USE_AND').attr('value');// 안드로이드 앱 사용 여부
		Params.useIOS = $('#USE_IOS').attr('value');// 애플 앱 사용 여부
		Params.useWIN = $('#USE_WIN').attr('value');// 윈도우 앱 사용 여부
		Params.useSHARE = $('#USE_SHARE').attr('value');// 공유하기 사용 여부
		// 로그인 사용 여부
		Params.useLogin = $('#USE_LOGIN').attr('value');// 로그인 사용 여부

		// 다운로드 체크 및 경로
		Params.isDownload = $('#IS_DOWNLOAD').attr('value');// 다운로드 체크
		Params.downloadURL = String($('#BOOKDOWNLOAD_URL').attr('value'));// 다운로드 경로

		// 앱으로 보내줄 절대경로
		Params.absPath = $('#ABSPATH').attr('value');
		// 웹에서 사용될 지정 타이틀 설정 >> 없으면 opf 내용의 타이틀 명으로 설정
		Params.absTitle = $('#ABSTITLE').attr('value');

		// 앱으로부터 정보를 받는 경우
		Params.appType = app_type;

		// 저장
		setData();

		// 파라미터 설정 후, 폼 삭제
		$('#getForm').remove();
	}

	function setData() {
		ViewerManager.userInfo.cntsId = Params.epubID;

		if (Params.cntsDirPath.length > 0)
		{
			ViewerManager.Path.cntsDirPath = Params.cntsDirPath;
		}
		else
		{
			Params.cntsDirPath = ViewerManager.Path.cntsDirPath;
		}

		if (Params.cntsFilePath.length > 0)
		{
			ViewerManager.Path.cntsFilePath = Params.cntsFilePath;
		}
		else
		{
			Params.cntsFilePath = ViewerManager.Path.cntsFilePath;
		}

		if (Params.downloadURL.length == 0)
		{
			var domain;
			if (window.location.origin)
			{
				domain = window.location.origin;
			}
			else
			{
				domain = window.location.protocol + "//" + window.location.hostname + ( window.location.port ? ':'+window.location.port : '' );
			}

			Params.downloadURL = Params.epubPath.substring(0, Params.epubPath.length - 1) + ".epub";
		}

		ViewerManager.GetData.maxDate = Params.maxDate;
		ViewerManager.GetData.EPUB.ID = Params.epubID;
		ViewerManager.GetData.EPUB.TITLE = Params.epubTitle;
		ViewerManager.GetData.EPUB.AUTHOR = Params.epubAuthor;
		ViewerManager.GetData.EPUB.path = Params.epubPath;
		ViewerManager.GetData.EPUB.thumnail = Params.epubThumnail;
		ViewerManager.GetData.EPUB.absPath = Params.absPath;
		ViewerManager.GetData.EPUB.absTitle = Params.absTitle;

		ViewerManager.GetData.AND.SCHEME = Params.andKey[0];
		ViewerManager.GetData.AND.appId = Params.andKey[1];

		ViewerManager.GetData.IOS.SCHEME = Params.iosKey[0];
		ViewerManager.GetData.IOS.appId = Params.iosKey[1];

		ViewerManager.GetData.WIN.SCHEME = Params.winKey[0];
		ViewerManager.GetData.WIN.appId = Params.winKey[1];

		ViewerManager.GetData.detailURL = Params.detailURL;

		ViewerManager.GetData.USE.sync = Params.useSync;

		ViewerManager.GetData.USE.useBookContents = Params.useBookContents;

		ViewerManager.GetData.USE.and = Params.useAND;
		ViewerManager.GetData.USE.ios = Params.useIOS;
		ViewerManager.GetData.USE.win = Params.useWIN;
		ViewerManager.GetData.USE.share = Params.useSHARE;
		ViewerManager.GetData.USE.login = Params.useLogin == undefined ? "0" : Params.useLogin;

		ViewerManager.GetData.DOWNLOAD.is = Params.isDownload;
		ViewerManager.GetData.DOWNLOAD.url = Params.downloadURL;

		ViewerManager.GetData.PROGRESS.progressRate = Params.progressRate;
		ViewerManager.GetData.PROGRESS.progressRateType = Params.progressRateType;
		ViewerManager.GetData.PROGRESS.progressRateData = Params.progressRateData;

		ViewerManager.userInfo.cntsId = Params.epubID;

		ViewerManager.fileDownloadURL = Params.fileDownloadURL == undefined ? "" : Params.fileDownloadURL;

		ViewerManager.SSG.returnURL = Params.returnURL == undefined ? "" : Params.returnURL;
	}

	var exportParams = {
		Params : Params,
		paramsInit : paramsInit,
		paramRetake : paramRetake
	};

	return exportParams;
});
