﻿define(['jquery',  'browser', 'params', 'version', 'selectViewer', 'responsiveUI', 'zoom', 'page', 'loading', 'indexList', 'search', 'thumbnail', 'draw', 'memo', 'link', 'print', 'log', 'templet'],
	function ($, browser, params, version, selectViewer, responsiveUI, zoom, page, loading, indexList, search, thumbnail, draw, memo, link, print, log, templet) {
	'use strict';

	log("\n @ import userInterface.js ... \n");

	if (params.Params.paramIns == 'none')
	{
		params.paramsInit();
	}

	if (browser.ie8 || ViewerManager.openError == true)
	{
		return;
	}
	/*var testIP = "122.47.123.174";
	var getIP;

	var testID = "581";

	$.ajax({
		async : false,
		url : 'http://titanbooks.co.kr/Sviewer/ip.php',
		dataType : 'text',
		error : function (jqXHR, status, error) {

		},
		success : function (data) {
			getIP = data;
		}
	});*/

	// bottom menu
	//document.getElementById("bottomMenuTableTr").innerHTML = templet.bottomMenu;
	$("#bottomMenuTableTr").html(templet.bottomMenu);
	$("#bottomMenuTableTr_layer_1").html(templet.bottomMenu_layer_1);
	$('#bottom_logo').attr('src','images/titan_bottomMenu/bottom_logo_m.png');
	//접속 경로가 www.titanbooks.co.kr 일 경우 와 문체부 설정 이 아닐 경우 brand logo 제거
	//if (/titanbooks.co.kr/.test(location.href) || ViewerManager.CustomizeType != "DEFAULT")  {
		if ($('#brand_logo_url')) $('#brand_logo_url').remove();
	//}

	var defaultPaletteColor = false;
	var setPalette = function (_paletteType, _element, _img, _imgOver, _color, _linewidth, _pen) {

		var sliderID;
		if (_paletteType === "draw") {
			sliderID = "#slider_drawing";

		} else {
			sliderID = "#slider_eraser";
		}

		// slider seting
		$(sliderID).slider({
			min: 1,
			max: 40,
			range: "min",
			value: _linewidth,
			slide: function(event, ui) {
				log('@ drawing slider : ' +  ui.value);
				ViewerManager.LINEWIDTH = ui.value;

				switch (_pen) {
					case "pen":
						draw.insertDrawPaletteInfo("lineWidth", "pen", ui.value);
						break;
					case "highlighter":
						draw.insertDrawPaletteInfo("lineWidth", "highlighter", ui.value);
						break;
				}
			}
		});

		if (_pen === "pen") {
			log("@ pen mode!");
			ViewerManager.GLOBALCOMPOSITEOPERATION = "source-over"; //default
			ViewerManager.GLOBALALPHA = 1;
		} else if (_pen === "highlighter") {
			log("@ highlight mode!");
			ViewerManager.GLOBALCOMPOSITEOPERATION = "lighter";
			ViewerManager.GLOBALALPHA = 0.5;
		} else {
			log("@ select eraser mode!");
			ViewerManager.GLOBALCOMPOSITEOPERATION = "destination-out";
			ViewerManager.GLOBALALPHA = 1;
		}

		if (_color.indexOf('Black') != -1) {
			_color = "#000000";
		} else if (_color.indexOf('Purple') != -1) {
			_color = "#6F00FF";
		} else if (_color.indexOf('Red') != -1) {
			_color = "#FF0000";
		} else if (_color.indexOf('Yellow') != -1) {
			_color = "#FFFF00";
		} else if (_color.indexOf('Green') != -1) {
			_color = "#00FF00";
		} else if (_color.indexOf('Blue') != -1) {
			_color = "#0000FF";
		}

		ViewerManager.LINEWIDTH = parseInt(_linewidth);
		ViewerManager.LINECOLOR = _color;

		log("@ select color : " + _color);
		$(sliderID + " .ui-widget-header").css("background", _color);

		if (_pen === "pen") {
			for (var i = 0; i < $("#palette_pen").find("IMG").length; i++) {
				$("#palette_pen").find("IMG")[i].setAttribute("src", "images/drawing/palette_" + $("#palette_pen").find("IMG")[i].id + ".png");
			}
		} else if (_pen === "highlighter") {
			for (var i = 0; i < $("#palette_highlighter").find("IMG").length; i++) {
				$("#palette_highlighter").find("IMG")[i].setAttribute("src", "images/drawing/palette_" + $("#palette_highlighter").find("IMG")[i].id + ".png");
			}
		}

		if (_paletteType === "eraser") {
			$("#eraserSelect1").attr("src", "images/eraser/eraser_selectEraser1_01.png");
			$("#eraserSelect2").attr("src", "images/eraser/eraser_selectEraser2_01.png");
			$("#eraserSelect3").attr("src", "images/eraser/eraser_selectEraser3_01.png");
		}

		_element.attr("src", _imgOver);
	},

	eventBindDetailMenuButton = function (_buttonName) {
		log("@ event binding " + _buttonName);
		$(_buttonName).on("click", function () {
			log("@ click " + _buttonName + " button");
			var selector = {};
			if (_buttonName === "#btn_draw") {
				selector = {selectOther : "#btn_eraser", slider : "#draw_detail", selectDefault : "#colorBlack"};
				if (ViewerManager.zoomScore > 1) {
					zoom.clearZoom();
				}

				if ($('#draw_detail').css('display') == 'none') {
					$('#draw_detail').css('display', 'block');

					draw.attachCanvasEvent();
					// default color select
					if (!defaultPaletteColor) {
						defaultPaletteColor = true;
						$("#selectPen").trigger("click");
					}

					$("#components").css("pointer-events", "auto");
					// 그리는 동안 페이지 이동을 막아둠
					ViewerManager.UInormal('hide');

					//if (ViewerManager.Settings.uiHold == "0") {
						$('#btnSlideRight').css({"display": "none"});
						$('#btnSlideLeft').css({"display": "none"});
					//}

					$('#header_menu_detail').css({"display": "block"});
				}

				if ($("#palette_eraser").css("display") == "block") {
					$("#eraserSlider").css("display", "table-cell");
				}

				$('#close_draw').click(function (){
					if ($('#draw_detail').css('display') == 'none') {return;}
					$('#draw_detail').css('display', 'none');

					$('#header_menu_detail').css({"display": "none"});

					// stop drawing (detach event & LINEWIDTH set "0")
					draw.detachCanvasEvent();
					// save drawing data

					draw.saveCanvasData(ViewerManager.PAGE_CURRENT_NUMBER);

					$("#btn_draw").attr("src", "images/titan_topMenu/topMenu_draw_btn_01.png");

					$("#components").css("pointer-events", "auto");
					// 그리지않는 동안 페이지 이동을 열어둠
					//$('#header_toggle').css({"display": "block"});
					ViewerManager.UInormal('show');

					var right_view = ViewerManager.pageMode == "SINGLE" ? (ViewerManager.PAGE_CURRENT_NUMBER == ViewerManager.PAGE_TOTAL_NUMBER ? "none" : "block") : (ViewerManager.PAGE_CURRENT_NUMBER == ViewerManager.PAGE_TOTAL_NUMBER + 1 ? "none" : "block");

					//if (ViewerManager.Settings.uiHold == "0") {
						$('#btnSlideRight').css({"display": right_view});
						$('#btnSlideLeft').css({"display": ViewerManager.PAGE_CURRENT_NUMBER == 1 ? "none" : "block"});
					//}

					CONTROL.responsiveUI.setHeader();
				});

				closeOtherPopup("btn_draw");
			}
		});
	};

	// mode check [VIEW or EDIT]
/*	if (ViewerManager.READER_MODE == "EDIT") {
		$("#btn_draw").css({
			"display": "inline-block"
		});
		// draw, eraser detail menu append
		document.getElementById("draw_detail").innerHTML = templet.drawDetailMenu;
	}
*/
	// for responsive UI
	responsiveUI.setResponsiveMobileUI();

	//------------------- Popup Layer setting -------------------------------------------------------------------------------------------------

	ViewerManager.currentLayerPopup = "";

	var closeOtherPopup = function (curentMenu) {

		if (curentMenu !== "btn_more") if ($("#morePopupTemplet").css("display") === "block") $("#morePopupTemplet").fadeOut("fast");

		if (curentMenu !== "indexList") {
			if ($("#indexListTemplet").css("display") === "block") {
				$("#indexListTemplet").fadeOut("fast");
				$(".indexList").attr("src", "images/titan_topMenu/topMenu_indexList_btn_01.png");
			}
		}

		if (curentMenu !== "searchList") {
			if ($("#searchListTemplet").css("display") === "block") {
				$("#searchListTemplet").fadeOut("fast");
				$(".searchList").attr("src", "images/titan_topMenu/topMenu_search_btn_01.png");
			}
		}

		if (curentMenu !== "btn_draw") if ($("#draw_detail").css("display") === "block") $("#btn_draw").trigger("click");

	};

	// memo delete popup
	document.getElementById("memoDeleteTemplet").innerHTML = templet.memoDeleteTemplet;
	// link delete popup
	document.getElementById("linkDeleteTemplet").innerHTML = templet.linkDeleteTemplet;
	// draw delete popup
	document.getElementById("drawDeleteTemplet").innerHTML = templet.drawDeleteTemplet;
	// data delete popup
	document.getElementById("dataDeleteTemplet").innerHTML = templet.dataDeleteTemplet;
	// connection Error popup
	document.getElementById("connectionErrorTemplet").innerHTML = templet.connectionErrorTemplet;

	document.getElementById("morePopupTemplet").innerHTML =	templet.morePopupTemplet;

	CONTROL.responsiveUI._set_morelayout();
	// thumbnail popup init
	$("#callThumbnail").addClass("thumbnailPopup");


	$("#callThumbnail").on("click", function () {
		log("@ click Thumbnail button!");
		$("#thumb_container").fadeIn("fast");
		thumbnail.thumbnailList();

		closeOtherPopup();
	});

	$("#thumbnail_close").on("click", function () {

		$("#thumb_container").fadeOut("fast", function () {
			$('#thumbnail').empty();
		});
	});

	// indexList popup init
	var useTemplete = ViewerManager.GetData.USE.useBookContents == "false" ? templet.indexListPopupTemplet : templet.indexListPopupTemplet_3;
	//var useTemplete = getIP == testIP ? templet.indexListPopupTemplet_3 : templet.indexListPopupTemplet;
	document.getElementById("indexListTemplet").innerHTML = useTemplete;
	if (ViewerManager.userInfo.owner == "1") {
		var treeTarget = document.getElementById("indexListMenu1");
		var prevHTML1 = treeTarget.innerHTML;
		var langText1 = ViewerManager.language == "ko" ? "[편집]" : "[edit]";
		treeTarget.innerHTML = prevHTML1 + '<a id="tree_edit" onClick="new_category_open()">' + langText1 + '</a>';
	}

	if (ViewerManager.GetData.USE.useBookContents == "true") {
		var bookContentTarget = document.getElementById("indexListMenu2");
		var prevHTML3 = bookContentTarget.innerHTML;
		var langText3 = ViewerManager.language == "ko" ? "[편집]" : "[edit]";
		//bookContentTarget.innerHTML = prevHTML3 + '<a id="sync_data" onClick="sync_data(&quot;up&quot;)">' + langText3 + '</a>';
		//bookContentTarget.innerHTML = prevHTML3 + '<a id="content_edit">' + langText3 + '</a>';

		//if (ViewerManager.userInfo.owner == "1") {
		//if (ViewerManager.userInfo.loginKey == testID && CONTROL.browser.pc == 'PC') {
		if (ViewerManager.userInfo.owner == "1" && CONTROL.browser.pc == 'PC') {
			// 책 주인인 경우
			bookContentTarget.innerHTML = prevHTML3 + '<a id="content_edit" onClick="bookcontents_open()">' + langText3 + '</a>';
		} else {
			bookContentTarget.innerHTML = prevHTML3;
		}

		$.ajax({
			async : false,
			url : API.bookContentsXML() + '?ebookId=' + ViewerManager.GetData.EPUB.ID,
			dataType : 'xml',
			error : function (jqXHR, textStatus, errorThrown) {
				//console.log('fail load bookcontents', jqXHR, textStatus, errorThrown);
			},
			success : function (data) {
				//console.log('success load bookcontents', data);
				var bookcontents = $.xml2json(data);
				ViewerManager.bookcontents = bookcontents;
			}
		});
	}

	if (ViewerManager.GetData.USE.sync == "true" && ViewerManager.userInfo.loginKey.length > 0) {
		var myContentTarget = document.getElementById("indexListMenu3");
		var prevHTML2 = myContentTarget.innerHTML;
		var langText2 = ViewerManager.language == "ko" ? "[동기화]" : "[sync]";
		myContentTarget.innerHTML = prevHTML2 + '<a id="sync_data" onClick="sync_data(&quot;up&quot;)">' + langText2 + '</a>';
	}

	/* append Sviiewer version*/
	/*
	if (ver == 'titanbooks') {
		$('#indexListTemplet').append('<div id="sviewer_ver"><p>' + String(version.version) + '</p></div>');
	}
	else
	{
		if (ver == version.version)
		{
			//$('#indexListTemplet').append('<div id="sviewer_ver"><p>' + String(version.version) + '</p></div>');
		}
		else
		{
			$('#indexListTemplet').append('<div id="sviewer_ver"><p>' + String(version.version) + '<img src="images/common/icon_new.gif" style="vertical-align:top; margin-left:5px;" /></p></div>');
		}
	}
	*/

	//$('#indexListTemplet').append('<div id="sviewer_ver"><p>' + String(version.version) + '</p></div>')

	$(".indexList").on("click", function () {
		if (ViewerManager.CustomizeType == "DEFAULT") {
			if ($("#indexListMenu2").length > 0)  {
				$("#indexListMenu2").hide();
				$("#indexListMenu1").css('width','159px');
				$("#indexListMenu3").css('width','159px');
				$("#indexListMenu3").css('left','159px');
			}
		}
		indexList_click();
	});

	var indexList_click = function (stat)
	{
		log("@ click indexList button!");
		//$("#indexListMenu3").trigger("click");
		$("#indexListMenu1").trigger("click");
		if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad ) {
			$("#indexListMenu1, #indexListMenu2").css({
				"position": "absolute",
				"top" : "0px"
			});
		}

		if (stat =='showmove')
		{
			if ($("#indexListTemplet").css("display") != "none") {
				$("#indexListTemplet").fadeIn("fast", function () {
					$("#indexListTemplet").css("display", "none");
				});
				ViewerManager.currentLayerPopup = "";

				closeOtherPopup("indexList");
			}
		}
		else
		{
			if ($("#indexListTemplet").css("display") === "none") {
				$("#indexListTemplet").fadeIn("fast", function () {
					$("#indexListTemplet").css({
						"display" : "block",
						"height" : (ViewerManager.bookContainerHeight - 143) + "px"
					});
					ViewerManager.currentLayerPopup = "indexListTemplet";
				});
			} else {
				$("#indexListTemplet").fadeIn("fast", function () {
					$("#indexListTemplet").css("display", "none");
				});
				ViewerManager.currentLayerPopup = "";
			}
			closeOtherPopup("indexList");
		}
	}

	// searchList popup init
	// searchList
	if (browser.ie9 || browser.ie10 || browser.ie11) {
		document.getElementById("searchListTemplet").innerHTML = templet.searchListPopupTempletForIE;
		$("#searchWord").css("width", "80%");
		$(".searchField img").css("background", "none");
	} else {
		document.getElementById("searchListTemplet").innerHTML = templet.searchListPopupTemplet;
	}

	$(".searchList").on("click", function () {
		log("@ click searchList button!");
		$("#searchWord").val("");
		search.excuteSearch("");
		if (ViewerManager.zoomScore > 1) {
			zoom.clearZoom();
		}

		//if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad ) {
			//$("#searchListMenu1, #searchListMenu2").css({
				//"position": "absolute",
				//"top" : "0px"
			//});
		//}

		if ($("#searchListTemplet").css("display") === "none") {
			$("#searchListTemplet").fadeIn("fast", function () {
				$("#searchListTemplet").css({
					"display" : "block",
					"height" : (ViewerManager.bookContainerHeight - 105) + "px"
				});
				ViewerManager.currentLayerPopup = "searchListTemplet";
			});
		} else {
			$("#searchListTemplet").fadeIn("fast", function () {
				$("#searchListTemplet").css("display", "none");
			});
			ViewerManager.currentLayerPopup = "";
		}


		$("#searchButton").text(ViewerManager.Local.searchButtonText).css("background-color", "#017afd");
		closeOtherPopup("searchList");
	});

	var switchSearchAction = function (searchWord) {
		if (browser.isMobile.iPhone || browser.isMobile.iPod) {}
			else {
				loading.initLoading("MINI");
			}
			search.excuteSearch(searchWord);
			//$("#searchContents").hide().fadeIn();
		/*
		몬문 검색만 제공하기 때문에 아래의 본문 검색과 네이버 검색 분기 루틴을 제거
		if ($("#searchListMenu1").css("color").indexOf("153") === -1) {

			if (browser.isMobile.iPhone || browser.isMobile.iPod) {
			} else {
				loading.initLoading("MINI");
			}
			search.excuteSearch(searchWord);
			$("#searchContents").hide().fadeIn();
		} else {
			var naverSearchWindow = window.open("//search.naver.com/search.naver?where=nexearch&ie=utf8&query=" + encodeURI(searchWord), "print", "width=" + ViewerManager.bookContainerWidth + ", height=" + ViewerManager.bookContainerHeight + ", location=no, menubar=no, resizable=no, scrollbars=no, status=no, titlebar=no");
		}
		*/
	};

	// if (browser.chrome) {
		$("#searchWord").on("keyup", function (e) {
			log("@ keypress search word!");
			if (e.keyCode === 13) {
				switchSearchAction(this.value);
			}
		});
	// }

	$("#searchFieldReset").on("click", function () {
		$("#searchWord").val("");
		search.excuteSearch("");
		$("#searchContents").hide().fadeIn();
	});

	$("#searchButton").on("click", function () {
		switchSearchAction(document.getElementById('searchWord').value);
	});

	//-----------------------------------------------------------------------------------------------------------------------------------------

	// 초기에 메뉴바 숨기기
	//page.menuBarHide(100);

	//------------------- click event binding --------------------------------------------------------------------------------------------------

	// menu button
	$("#btn_menu").on("click", function () {
		$(".info_close").trigger("click");
		$(".help_close").trigger("click");
		log("@ click menu button!");
		$("#searchListTemplet").fadeOut(ViewerManager.Settings.menuSpeed);
		$("#indexListTemplet").fadeOut(ViewerManager.Settings.menuSpeed);

		$('#header, #footer_container').slideToggle(ViewerManager.Settings.menuSpeed, function () {
			if ($("#header").css("display") === "none") {
				document.querySelector('#btn_menu').setAttribute('src', 'images/topArrowDown_btn_01.png');
				ViewerManager.swipeStatus('on');
				//draw.saveCanvasData(ViewerManager.currentPageNumber);
				//draw.offDrawMode();
				//draw.hideDrawMenu();
			} else {
				document.querySelector('#btn_menu').setAttribute('src', 'images/topArrowUp_btn_01.png');
				ViewerManager.swipeStatus('off');
				//draw.saveCanvasData(ViewerManager.currentPageNumber);
				//draw.offDrawMode();
				//draw.hideDrawMenu();
			}

			if ($('#header').css('display') == 'block')  CONTROL.responsiveUI.setHeader();
		});

		$('#header_menu_detail').slideToggle(ViewerManager.Settings.menuSpeed, function () {
			if ($("#currentModeNotice").css("bottom") === "47px") {
				$("#currentModeNotice").animate({"bottom": "-=47px"}, 50);
			} else {
				$("#currentModeNotice").animate({"bottom": "+=47px"}, 50);
			}
		});

		if ($("#morePopupTemplet").css("display") === "block") $("#morePopupTemplet").fadeOut("fast");

	});

	// PC 에서 좌우 버튼 보이기
	//if (!(browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet)) {
		//$(".ISleft").css('display', 'none');
		document.getElementById('ISleft').innerHTML = templet.isLeft;
		//$(".ISright").css('display', 'none');
		document.getElementById('ISright').innerHTML = templet.isRight;
	//}
	$('body').append( templet.expandSelect);
	// 모바일에서 이미지 교체
	if ((browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad || browser.isMobile.androidPhone || browser.isMobile.androidTablet)) {
		$('#btnSlideRight').attr('src', 'images/mobile_arrow_right.png');
		$('#btnSlideLeft').attr('src', 'images/mobile_arrow_left.png');
	}

	// left button
	$("img#btnSlideLeft").on("click", function () {
		log("@ Left button click!");
		page.previousPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
	});

	// left button
	$("img.btnBtmLeft").on("click", function () {
		log("@ Left button click!");
		page.previousPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
	});


	// left end button
	$("img#btnSlideLeftFirst").on("click", function () {
		log("@ Left button click!");
		page.previousPage(2, ViewerManager.PAGE_TOTAL_NUMBER);
	});




	// right button
	$("img#btnSlideRight").on("click", function () {
		log("@ Right button click!");
		//if (isMiniLoad)
				page.nextPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
				//isMiniLoad = false;
	});

	// right button
	$("img.btnBtmRight").on("click", function () {
//		alert('test')
		log("@ Left button click!");
		//if (isMiniLoad)
				page.nextPage(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
				//isMiniLoad = false;
	});

	// right end button
	$("img#btnSlideRightLast").on("click", function () {
		log("@ Right button click!");
		page.nextPage(ViewerManager.PAGE_TOTAL_NUMBER - 2, ViewerManager.PAGE_TOTAL_NUMBER);
	});




	eventBindDetailMenuButton("#btn_draw");

	// memo button
	$("#btn_memo").on("click", function () {
		log("@ click memo button!");
		if (ViewerManager.zoomScore > 1) {
			zoom.clearZoom();
		}

		closeOtherPopup();

		new memo.Memo();
	});

	// palette pen color click event binding
	for (var i = 0; i < $("#palette_pen").find("IMG").length; i++) {
			$("#" + $("#palette_pen").find("IMG")[i].id).on("click", function () {
				log("@ select palette color : " + $(this).attr("id"));
				setPalette("draw", $(this), "images/drawing/palette_" + $(this).attr("id") + ".png", "images/drawing/palette_" + $(this).attr("id") + "_over.png", $(this).attr("id").substring(5), "6", "pen");
				draw.insertDrawPaletteInfo("color", "pen", "#" + $(this).attr("id"));
			});
		$("#palette_pen").find("IMG")[i].setAttribute("style", "cursor : pointer");
	}

	// palette highlighter color click event binding
	for (var i = 0; i < $("#palette_highlighter").find("IMG").length; i++) {
			$("#" + $("#palette_highlighter").find("IMG")[i].id).on("click", function () {
				log("@ select palette color : " + $(this).attr("id"));
				setPalette("draw", $(this), "images/drawing/palette_" + $(this).attr("id") + ".png", "images/drawing/palette_" + $(this).attr("id") + "_over.png", $(this).attr("id"), "10", "highlighter");
				draw.insertDrawPaletteInfo("color", "highlighter", "#" + $(this).attr("id"));
			});
		$("#palette_highlighter").find("IMG")[i].setAttribute("style", "cursor : pointer");
	}

	// palette eraser click event binding
	$("#eraserSelect1").on("click", function () {
		log("@ eraserSelect1 button click!");
		setPalette("eraser", $(this), "images/eraser/eraser_selectEraser1_01.png", "images/eraser/eraser_selectEraser1_02.png", "#660099", "10");
	});

	$("#eraserSelect2").on("click", function () {
		log("@ eraserSelect2 button click!");
		setPalette("eraser", $(this), "images/eraser/eraser_selectEraser2_01.png", "images/eraser/eraser_selectEraser2_02.png", "#660099", "20");
	});

	$("#eraserSelect3").on("click", function () {
		log("@ eraserSelect3 button click!");
		setPalette("eraser", $(this), "images/eraser/eraser_selectEraser3_01.png", "images/eraser/eraser_selectEraser3_02.png", "#660099", "30");
	});

	$("#eraserAll").on("click", function () {
		log("@ eraserAll");
		$("#drawDeleteTemplet").css('left', (window.innerWidth / 2 - 150) + 'px');
		$("#drawDeleteTemplet").fadeIn("fast", function () {
			$(this).find("#drawDeletePopupNoBtn").on("click", function () {
				$("#drawDeleteTemplet").fadeOut("fast");
			});
		});
	});

	// 판서 지우기 버튼
	$("#drawDeletePopupYesBtn").on("click", function () {
		$("#drawDeleteTemplet").fadeOut("fast");
		draw.clearCanvas(true);
	});

	$("#btn_link").on("click", function () {
		log("@ click link button!");
		if (ViewerManager.zoomScore > 1) {
			zoom.clearZoom();
		}

		if ($("#draw_detail").css("display") === "block") $("#btn_draw").trigger("click");

		new link.Link();

		closeOtherPopup();
	});

	$("#history").on("click", function () {
		log("@ click history button!");

		if (ViewerManager.pageHistory.length > 1) {
			log(ViewerManager.pageHistory[ViewerManager.pageHistory.length - 2]);
			ViewerManager.pageLoading(ViewerManager.pageHistory[ViewerManager.pageHistory.length - 2], ViewerManager.PAGE_TOTAL_NUMBER);
		} else {
			$("#currentModeNotice").text(ViewerManager.Local.emptyHistory).fadeIn(300, function () {
				var noticeTimer = setTimeout(function () {
					$("#currentModeNotice").fadeOut(500);
					clearTimeout(noticeTimer);
				}, 1000);
			});
		}
	});


	$(".btn_duclass").on("click", function () {
			window.open("http://www.douclass.com", "두클래스", "width=1280, height=960, toolbar=no, menubar=yes, scrollbars=yes, resizable=yes" );
		});

	/*pdf 파일 연결 소스
	$(".btn_duclass").on("click", function (event) {
		//ck.170609.
		window.location ="pds/help/사용설명서_고등국어.pdf";
		/*
		event.preventDefault();
		event.stopPropagation();
		//location.href= "popupopen://http://www.hnedu.co.kr/";
		location.href = "popupopen://http://www.hnedu.co.kr/";
		*/
//	});

$(".btn_teacher_dataroom").on("click", function () {
		//window.open("./pds/down_01.html", "선생님자료실", "width=800, height=700, toolbar=no, menubar=yes, scrollbars=yes, resizable=yes" );
		location.href = "Execute://HtmlViewer/pds/down_01.html";
	})

	//웹버전  시작
//	$(".btn_teacher_dataroom").on("click", function (event) {
//		window.open("pds/down01.html", "_blank","선생님 자료실", "width=1920, height=1050, toolbar=no, menubar=yes, scrollbars=yes, resizable=yes" );
		//window.location = "pds/down01.html";
		/*event.preventDefault();
		event.stopPropagation();
		location.href = "Execute://HtmlViewer/pds/down_01.html";*/
//	});
//웹버전 끝


	$(".btn_home").on("click", function (event) {
		//window.open("pds/index.html", "홈", "width=1920, height=1050, toolbar=no, menubar=yes, scrollbars=yes, resizable=yes" );
		window.location = "pds/index.html";
		/*event.preventDefault();
		event.stopPropagation();
		location.href = "Execute://HtmlViewer/pds/down_01.html";*/
	});


	// fullScreen button event binding
	$("#btn_fullScreen").on("click", function (event) {
		log("@ click fullScreen button!");
		event.preventDefault();
		event.stopPropagation();
		if (!document.fullscreenElement && !document.mozFullScreenElement && !document.webkitFullscreenElement && !document.msFullscreenElement ) {

			if (document.documentElement.requestFullscreen) document.documentElement.requestFullscreen();
			else if (document.documentElement.msRequestFullscreen) document.body.msRequestFullscreen();
			else if (document.documentElement.mozRequestFullScreen) document.documentElement.mozRequestFullScreen();
			else if (document.documentElement.webkitRequestFullscreen) document.documentElement.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);

			// 작은화면으로.
			$("#btn_fullScreen").attr("src", "images/titan_topMenu/topMenu_FullScreen_btn_01.png");
			//window.location = "application://normalscreen";
		} else {

			if (document.exitFullscreen) document.exitFullscreen();
			else if (document.msExitFullscreen) document.msExitFullscreen();
			else if (document.mozCancelFullScreen) document.mozCancelFullScreen();
			else if (document.webkitExitFullscreen) document.webkitExitFullscreen();

			// 큰화면으로.
			$("#btn_fullScreen").attr("src", "images/titan_topMenu/topMenu_windowScreen_btn_01.png");
			//window.location = "application://fullscreen";
		}
		closeOtherPopup();
	});

	// pageMode button event binding
	var vertPixe = false;
	$("#btn_pageMode").on("click", function () {
		log("@ click pageMode button!");
		
		switch (ViewerManager.pageMODE) {
			case "DOUBLE":
				if(vertPixe)
				{
					ViewerManager.pageMODE = "DOUBLE";
					ViewerManager.pixeWidth = false;
					vertPixe = false;
					$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png");
					if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER);
					else ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;

					if (ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER)) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;

					ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;
					ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
				}
				else
				{
					ViewerManager.pageMODE = "SINGLE";
					$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Double2_01.png");
					ViewerManager.PAGE_CURRENT_NUMBER =  parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
					ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;
					ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);
				}
				break;
			case "SINGLE":
				ViewerManager.pageMODE = "DOUBLE";
				/*
				vertPixe = true;
				ViewerManager.pixeWidth = true;
				*/
				//$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png");
				$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png");
				if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) === 1) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER);
				else ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;

				if (ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER)) ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;

				ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;
				ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);

				break;

		}
		closeOtherPopup();
	});

	$("#selectPen").on("click", function () {
		log("@ select Pen Button!");
		$("#palette_pen").css("display", "table-cell");
		$("#multipleSlider").css("display", "table-cell");
		$("#eraserSlider").css("display", "none");
		$("#palette_highlighter").css("display", "none");
		$("#palette_eraser").css("display", "none");
		$(this).attr("src", "images/drawing/draw_penButton_02.png");
		$("#selectHighlighter").attr("src", "images/drawing/draw_highlightButton_01.png");
		$("#selectEraser").attr("src", "images/drawing/draw_eraserButton_01.png");

		draw.setDrawPaletteInfo(0);
	});

	$("#selectHighlighter").on("click", function () {
		log("@ select highlighter Button!");
		$("#palette_highlighter").css("display", "table-cell");
		$("#multipleSlider").css("display", "table-cell");
		$("#eraserSlider").css("display", "none");
		$("#palette_pen").css("display", "none");
		$("#palette_eraser").css("display", "none");
		$(this).attr("src", "images/drawing/draw_highlightButton_02.png");
		$("#selectPen").attr("src", "images/drawing/draw_penButton_01.png");
		$("#selectEraser").attr("src", "images/drawing/draw_eraserButton_01.png");

		draw.setDrawPaletteInfo(1);
	});

	$("#selectEraser").on("click", function () {
		log("@ select Eraser Button!");
		$("#palette_eraser").css("display", "table-cell");
		$("#eraserSlider").css("display", "table-cell");
		$("#palette_pen").css("display", "none");
		$("#multipleSlider").css("display", "none");
		$("#palette_highlighter").css("display", "none");
		$(this).attr("src", "images/drawing/draw_eraserButton_02.png");
		$("#selectPen").attr("src", "images/drawing/draw_penButton_01.png");
		$("#selectHighlighter").attr("src", "images/drawing/draw_highlightButton_01.png");
		$("#eraserSelect1").trigger("click");
	});

	var ILM1 = $('#indexListMenu1');
	var ILM1_a = $('#indexListMenu1 a');
	var ILM2 = $('#indexListMenu2');
	var ILM2_a = $('#indexListMenu2 a');
	var ILM3 = $('#indexListMenu3');
	var ILM3_a = $('#indexListMenu3 a');

	//목차 클릭
	ILM1.on('click', function () {
		indexListChange('indexListMenu1');
	});
	//자료실 클릭
	ILM2.on('click', function () {
		indexListChange('indexListMenu2');
	});
	//작업 기록 클릭
	ILM3.on('click', function () {
		indexListChange('indexListMenu3');
	});

	ILM1.hide();
	ILM2.hide();
	ILM3.hide();

	function indexListChange (_type) {
		ILM1.removeClass('on');
		ILM1_a.removeClass('on');
		ILM2.removeClass('on');
		ILM2_a.removeClass('on');
		ILM3.removeClass('on');
		ILM3_a.removeClass('on');

		switch (_type) {
			case 'indexListMenu1': {
				log('@ indexListMenu1...');
				indexList.loadBookIndex();
				ILM1.addClass('on');
				ILM1_a.addClass('on');
				break;
			}
			case 'indexListMenu2': {
				log('@ indexListMenu2...');
				indexList.loadBookContents();
				ILM2.addClass('on');
				ILM2_a.addClass('on');
				break;
			}
			case 'indexListMenu3': {
				log('@ indexListMenu3...');
				indexList.loadMyContents();
				ILM3.addClass('on');
				ILM3_a.addClass('on');
				if (ViewerManager.CustomizeType == "DEFAULT") {
					if ($("li[rel=tab1]").length > 0 ) {
						$("li[rel=tab1]").remove();
						$("li[rel=tab2]").remove();
						$("li[rel=tab3]").remove();
					}
				}
				break;
			}
		}
	}
	/*
	$("#searchListMenu1").on("click", function () {
		$("#searchWord").val("");
		search.excuteSearch("");
		$(this).css({"background-color" : "#017afd","color" : "#FFFFFF"});
		$("#searchListMenu2").css({"background-color" : "#FFFFFF","color" : "#999999"});
		$("#searchButton").text(ViewerManager.Local.searchButtonText).css("background-color", "#017afd");
	});

	$("#searchListMenu2").on("click", function () {
		search.searchByNaver("");
		$(this).css({"background-color" : "#23b300","color" : "#FFFFFF"});
		$("#searchListMenu1").css({"background-color" : "#FFFFFF","color" : "#999999"});
		$("#searchButton").text(ViewerManager.Local.searchButtonText).css("background-color", "#017afd");
	});
	 */

	$(".zoomIn").on("click", function () {
		log("@ click zoomIn button!");

		if ($('#bookmark_container').css('display') == 'block') {
			$('#bookmark_container').css('display', 'none');
		}

		var rate1 = parseInt(ViewerManager.Settings.zoomRate1) / 100;
		var rate2 = parseInt(ViewerManager.Settings.zoomRate2) / 100;

		if (ViewerManager.zoomScore == 1) {
			ViewerManager.zoomScore = rate1;
			zoom.initZoom();
			zoom.setPreviewArea(ViewerManager.zoomScore);
			zoom.noticeZoomRate();
			zoom.zoomViewportCenterAlign();
		}
		else if (ViewerManager.zoomScore == rate1) {
			ViewerManager.zoomScore = rate2;
			zoom.setPreviewArea(ViewerManager.zoomScore);
			zoom.noticeZoomRate();
			zoom.zoomViewportCenterAlign();

			$(".zoomIn").css("display", "none");
			$(".zoomIn").parent().css("width", "0px");
			$(".zoomOut").css("display", "block");
			$(".zoomOut").parent().css("width", "52px");
		}

		log("@ zoomRate : " + ViewerManager.zoomRate);
		log("@ ViewerManager.zoomScore : " + ViewerManager.zoomScore);
		log("@ scale : " + ViewerManager.zoomRate * ViewerManager.zoomScore);

		$("#components").css("pointer-events", "none");

		draw._zoom();
		closeOtherPopup();
	});

	$(".zoomOut").on("click", function () {
		log("@ click zoomOut button!");

		$(".zoomOut").css("display", "none");
		$(".zoomOut").parent().css("width", "0px");
		$(".zoomIn").css("display", "block");
		$(".zoomIn").parent().css("width", "52px");

		if ($('#bookmark_container').css('display') == 'none') {
			$('#bookmark_container').css('display', 'block');
		}

		if (ViewerManager.zoomScore === 1) {
			log("@ can not zoomOut any more!");
		} else {
			ViewerManager.zoomScore = 1;//ViewerManager.zoomScore - 0.5;
			log("@ ViewerManager.zoomScore : " + ViewerManager.zoomScore);
			log("@ scale : " + ViewerManager.zoomRate * ViewerManager.zoomScore);
			if (ViewerManager.zoomScore === 1) {
				zoom.clearZoom();
				zoom.zoomViewportCenterAlign();
				//$("#header_title").text(ViewerManager.Local.cntsTitle.getStringLength(page.adjustTitleLength()));
			} else {
				$("#pages, #drawing_container").css({
					"-ms-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
					"-webkit-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
					"transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
					"transform-origin": "0% 0%",
					"-webkit-transform-origin": "0% 0%",
					"-ms-transform-origin": "0% 0%"
				});
				zoom.setPreviewArea(ViewerManager.zoomScore);
				zoom.noticeZoomRate();
				zoom.zoomViewportCenterAlign();
			}
		}

		draw._zoom();
		closeOtherPopup();

	});

	var kakaoInit = false;
		//sns share
	$("#btn_sns_share").bind("click", function () {
		var snsTempStr  =
			'<div id ="sns_container_bg">' +
				'<div id ="sns_container_content">' +
					'<img id ="sns_comunication"  src ="images/logo/comunication_logo.png"  data-sns ="comunication" class ="sns_share" title ="소통공간" />' +
					'<img id ="sns_kakao"  src ="images/logo/kakao_logo.png" data-sns ="kakao" class ="sns_share" title ="kakao" />' +
					'<img id ="sns_band"  src ="images/logo/band_logo.png" data-sns ="band" class ="sns_share" title ="band" />' +
					'<img id ="sns_line"  src ="images/logo/line_logo.png" data-sns ="line" class ="sns_share" title ="line" />' +
				'</div>'+
			'</div>';

	   var isPc = CONTROL.browser.pc == 'PC' ? true: false;
	   var $sns_container = $(snsTempStr);
	   var $sns_content = $sns_container.find('#sns_container_content').css({
			'position': 'absolute',
			'left' : isPc ? $(this).offset().left + 'px' : '50%',
			'top' : isPc ?($(this).offset().top + $(this).height() + 5) + 'px' : '40%',
			'width' : '200px',
			'height' : '50px',
			'zIndex' : 9999999,
			'background-color' : '#ffffff'
		});

		if (!isPc) {
			$sns_content.css('margin-left' , "-100px");
			$sns_content.css('margin-top' , "-25px");
		}else {
			$sns_content.find('#sns_comunication, #sns_kakao, #sns_line').remove().end().css('width' , '50px')
		}
		$sns_content.find('.sns_share').css('cursor', 'pointer').click(function(event){
			var targetSns = $(this).data('sns');
			var url = document.location;
			var bookName = ViewerManager.GetData.EPUB.TITLE;
			var _br  = '\r\n';

			switch(targetSns){
				case 'kakao':
					if (kakaoInit == false ) {
						Kakao.init('1bfa966741789516b3eee0352d0a197b');
						kakaoInit= true;
					}
					Kakao.Link.sendTalkLink({label: bookName +_br + _br + url});
				break;

				case 'comunication':
					setTimeout(function(){ location.href = 'intent://mcstsnsHost?android.intent.extra.TEXT=' + bookName + _br + url +'#Intent;scheme=mcstsns;action=android.intent.action.VIEW;category=android.intent.category.BROWSABLE;package=com.tiger.moiso;end'}, 100);
				break;

				case 'band':
					var o  = {
				                	method:'web2app',
				                	param:'create/post?text=' + bookName + _br + url,
				                	a_store:'itms-apps://itunes.apple.com/app/id542613198?mt=8',
				                	g_store:'market://details?id=com.nhn.android.band',
				                	a_proto:'bandapp://',
				                	g_proto:'scheme=bandapp;package=com.nhn.android.band'
				            };
			            	if (CONTROL.browser.pc != 'PC'){
			            		// Android
				            	if(navigator.userAgent.match(/android/i)){
							setTimeout(function(){ location.href = 'intent://' + o.param + '#Intent;' + o.g_proto + ';end'}, 100);
						} else if(navigator.userAgent.match(/(iphone)|(ipod)|(ipad)/i)) {
							// Apple
							setTimeout(function(){ location.href = o.a_store; }, 200);
							setTimeout(function(){ location.href = o.a_proto + o.param }, 100);
						}
					}else if (CONTROL.browser.pc == 'PC' ){
						window.open("http://www.band.us/plugin/share?body="+bookName +encodeURIComponent("\n")+url+"&route="+encodeURIComponent(location.href), "share_band", "width=410, height=540, resizable=no");
					}
				break;

				case 'line':
					location.href ="http://line.me/R/msg/text/?" + bookName + _br + url;
				break;
			}

		});

		$sns_container.one('click' , function(){$sns_container.hide();$sns_container.remove();});
		$sns_content.one('click' , function(){$sns_container.hide();$sns_container.remove();});
		$('body').append($sns_container);
		$sns_container.show();
	});

	// app setup button
	$("#setApp").bind("click", function () {
		selectViewer.inside_connectView();
	});

	// ad close button
	/*$('#img-adclose').bind('click', function (e){
		console.log("??", $('#div-ad')[0]);
    	$('#div-ad')[0].innerHTML = '';
    });*/
	function Int(val) {
		var  len = val.length;
		if(len < 1) return 0;
		for(k=0;k<len;k++) {
			if(val.charAt(k) < '0' || val.charAt(k) > '9') return 0;
        }
		return 1;
	}

	Array.prototype.unique = function()
	{

		  var a = {};
		  for(var i=0; i<this.length; i++)
		  {
			if(typeof a[this[i]] == "undefined")
			  a[this[i]] = 1;
		  }
		  this.length = 0;
		  for(var i in a)
			this[this.length] = i;
		  return this;
	}
	function numberorder(a,b){
		return a - b;
	}

	// web print button
	var total_print_page = 0;
	
	$("#btn_print").on("click", function () {
		log("@ click print button!");

		//$('#print-frame').height(($(window).height() - $('#set-print').height() - 30));
		$('#print-frame').height( $(window).height() );
		var frameID = document.getElementById("print-frame");

		

		frameID.contentWindow.input_part_page();
		frameID.contentWindow.set_print_page();

		
		$('#print-modal').show();
		

	});
		$('.btn-print, .btn-close').unbind("click");
		$('.btn-print').on("click", function() {

			$('#print-frame').contents().find('#print-area').html("");
			$('#print-frame').contents().find('#send-print-btn').hide();
			document.getElementById("print-frame").contentWindow.close_print = false;
			document.getElementById("print-frame").contentWindow.bkgload = 0;
			idef_pg = 0;
			var p = new Array();


			switch( $('input:radio[name=ptype]:checked').val() )
			{
				case "A" :
					var p2 = ViewerManager.PAGE_CURRENT_NUMBER;
					p = new Array();
					p[0] = p2;
					p[1] = p2 + 1;
				break;
				case "B" :
					var p2 = ViewerManager.PAGE_CURRENT_NUMBER;
					p = new Array();
					p[0] = p2;
				break;
				case "C" :
					var p2 = ViewerManager.PAGE_CURRENT_NUMBER;
					p = new Array();
					p[0] = p2 + 1;
				break;

				case "D" :
					var n = 0;
					p = new Array();
					var localStorageDatas = JSON.parse(CONTROL.save_target("bookmark"));
					if (localStorageDatas !== null && localStorageDatas["bookmark"].length > 0) {
						for (var i = 0; i < localStorageDatas["bookmark"].length; i++)
							p[n++] = localStorageDatas["bookmark"][i].pageno;
					}
				break;

				case "E" :
					var n = 0;
					p = new Array();
					for( p2 = 1; p2 <= ViewerManager.PAGE_TOTAL_NUMBER; p2++)
						p[n++] = p2;
				break;
				case "F" :
					var p2 = $("input[name=ipage]").val();

					if(p2) {
						var d3 = new Array();
						var d = new Array();
						if(p2.indexOf(",") == -1) d[0] = p2;
						else d = p2.split(",");

						for(i=0; i<=d.length-1; i++) {
							if(d[i]) {
								if(d[i].indexOf("-") > -1) {
									var d2 = d[i].split("-");

									if(d2[0] && d2[1] && Int(d2[0]) && Int(d2[1]) && d2[0] >= 1 && d2[0] <= ViewerManager.PAGE_TOTAL_NUMBER)
									{
										var c = d3.length;

										for(m = parseInt(d2[0]); m <= parseInt(d2[1]); m++)
										{
											d3[c] = m;
											c++;
										}
									}

								}
							}
						}


						var m = d.length;
						for(i=0; i < d3.length; i++) {
							if(d3[i]) {
								d[m] = d3[i];
								m++;
							}
						}

						p = new Array();
						var c=0;
						for(i=0; i < d.length; i++) {

							if(d[i] && d[i] != " ") {
								try {
									if(d[i].indexOf("-") > -1)
										continue;
								}catch(e){}

								if(Int(d[i]) && d[i] <= ViewerManager.PAGE_TOTAL_NUMBER) {
									p[c] = d[i];
									c++;
								}
							}
						}

					} else {
						alert("인쇄 범위를 입력하세요");
						$('#ipage').focus();
						return;
					}
				break;

			}
			p.unique();
			p.sort(numberorder);
			total_print_page = p.length;

			for(i = 0; i < total_print_page; i++)
			{
				if( (ViewerManager.pageHTMLData[ p[i] ][1]).indexOf(".xhtml") > 0 )
				{
					var option = {
						type: "GET",
						url : 'epub/OEBPS/'+ViewerManager.pageHTMLData[ p[i] ][1],
						async: false,
						dataType : 'html',
						success : get_print_page,
						error : function() {
							console.log( "error:"+p[i] );
						}
					};

					$.ajax(option);
				}
				else {
					get_print_page( ViewerManager.pageHTMLData[ p[i] ][1] );
				}
			}

		});

		var idef_pg = 0;
		var save_html = [];
		var paper_size_arr = [{
			"A4":[740,1047],
			"A3":[1024, 1449]
		}];
		function get_print_page( html )
		{
			var p_width = (ViewerManager.iframeContentsWidth * 25.4) / 72;
			var p_height = (ViewerManager.iframeContentsHeight * 25.4) / 72;
			var viewRate = p_height / p_width;
			var v_rate, h_rate;

			if(p_width > 210)
				v_rate = 210 / p_width;
			if(p_height > 297)
				h_rate = 297 / p_height;
			var prt_scale = 1;
			if(v_rate > h_rate)
				ptr_scale = h_rate;
			else
				prt_scale = v_rate;

			prt_scale = 0.84;

			var paper_size = $('input:radio[name=paper]:checked').val();

			var pe_width = paper_size_arr[0][paper_size][0];
			var pe_height = paper_size_arr[0][paper_size][1];
			var pew = pe_width / ViewerManager.iframeContentsWidth;
			var peh = pe_height / ViewerManager.iframeContentsHeight;
			prt_scale = pew;
			if(peh < pew)
				prt_scale = peh;
			idef_pg++;

			var tmp_html = html.replace("<body", "<printbody");
			tmp_html = tmp_html.replace("</body", "</printbody");
			tmp_html = tmp_html.replace(/epub\/OEBPS\/content\//gi, "");
			tmp_html = tmp_html.replace(/images\/page/gi, "epub/OEBPS/content/images/page");
			tmp_html = tmp_html.replace(/images\/icon/gi, "epub/OEBPS/content/images/icon");
			tmp_html = tmp_html.replace(/Tbox_/g, "p_"+idef_pg+"_Tbox_");
			tmp_html = tmp_html.replace(/text_/g, "p_"+idef_pg+"_text_");
			tmp_html = tmp_html.replace(/\"backgnd\"/gi, "\"backgnd-"+idef_pg+"\" onload=\"try{load_backgnd('backgnd-"+idef_pg+"');}catch(e){}\" ");
			var pageHtml = "<div>"+tmp_html+"</div>";

			var set_css = "";
			var get_css_path = "";
			$(pageHtml).find("link").each(function() {
				if($(this).attr("id") == "page_css") {
					if( ($(this).attr('href')).indexOf("OEBPS") < 0  )
						get_css_path = "epub/OEBPS/content/"+$(this).attr('href');
					else
						get_css_path = $(this).attr('href');
					set_css += "<style type='text/css'>[*input_pagecss*]</style>";
				}
				else
					set_css += "<link type=\"text/css\" href=\"epub/OEBPS/content/"+$(this).attr('href')+"\"  rel=\"stylesheet\">";
			});
			var break_class = "break-after";
			if(idef_pg % 2 == 0)
				break_class =  "break-before";
			var set_body = $(pageHtml).find("printbody").html();
			var input_print_page = "<div class='page-out a4'><div class='set-scale' style='width:"+ViewerManager.iframeContentsWidth+"px;height:"+ViewerManager.iframeContentsHeight+"px;'>"+set_css+set_body+"</div></div>";
			save_html[ idef_pg ] = input_print_page;

			if(get_css_path) {
				var option = {
					type: "GET",
					indexValue: idef_pg,
					url : get_css_path,
					async: false,
					dataType : 'html',
					success : function(data) {
						var frameID = document.getElementById("print-frame");
						var g_css = data.replace(/Tbox_/g, "p_"+this.indexValue+"_Tbox_");
						g_css = g_css.replace(/text_/g, "p_"+this.indexValue+"_text_");
						var get_html = save_html[this.indexValue];
						var input_print_page = get_html.replace("[*input_pagecss*]", g_css);

						$('#print-frame').contents().find('#print-area').append(input_print_page).trigger("create");
						//$('#print-frame').contents().find('body').scrollTop(  frameID.contentWindow.document.body.offsetHeight * prt_scale );
						$('#print-frame').contents().scrollTop(frameID.contentWindow.document.body.offsetHeight * prt_scale - (ViewerManager.iframeContentsHeight * prt_scale) );

						if(this.indexValue >= total_print_page)
						{
							setTimeout(function(){
								frameID.contentWindow.print_start(total_print_page, prt_scale,ViewerManager.iframeContentsWidth, ViewerManager.iframeContentsHeight);
							}, 500);
						}
					},
					error:function(request,status,error){
						console.log( "css error:"+idef_pg+":"+get_css_path );
						console.log("code:"+request.status+"\n"+"message:"+request.responseText+"\n"+"error:"+error);
					}
				};

				$.ajax(option);
			}
		}
		$('.btn-close').on("click", function() {
			$("#set-print").show();
			$('#print-frame').contents().find('#print-area').html("");
			$('#print-frame').contents().find('#send-print-btn').hide();
			$('#print-modal').hide();
		});

	$("#btn_more").on("click", function () {
		log("@ click more button!");

		if (browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.androidPhone) {
			if(CONTROL.responsiveUI.hide_menu_item[ViewerManager.CustomizeType] instanceof Array)
			{
				$("#morePopupTemplet").css(CONTROL.responsiveUI.hide_menu_item[ViewerManager.CustomizeType]['css']);
				$("#morePopupTemplet").find("img").css("float","left");
			}
			else
				$("#morePopupTemplet").css("left", "20px");
		} else {
			if(CONTROL.responsiveUI.hide_menu_item[ViewerManager.CustomizeType] instanceof Array)
			{
				$("#morePopupTemplet").css(CONTROL.responsiveUI.hide_menu_item[ViewerManager.CustomizeType]['css']);
				$("#morePopupTemplet").find("img").css("float","left");
			}
			else
				$("#morePopupTemplet").css("left", "165px");
		}

		if(CONTROL.responsiveUI.hide_menu_item[ViewerManager.CustomizeType] instanceof Array)
		{
			if($("#morePopupTemplet").css("display") == "block")
			{
				$("#morePopupTemplet").fadeOut("fast", function () {});
				return;
			}
		}

		$("#morePopupTemplet").fadeIn("fast", function () {

			$(this).on("click", function () {
				$("#morePopupTemplet").fadeOut("fast");
			});

		});

		closeOtherPopup("btn_more");

	});

	$("#btn_login").on("click", function () {
		//if (String(ViewerManager.userInfo.loginKey).length > 0) {return;}
		var _this = $(this);
		log("@ click login button!");
		if (_this.hasClass('login')) {
			var _logout = confirm("로그아웃 하시겠습니까?");
			if (_logout) {
				_this.removeClass('login');
				location.href = API.logOut();
			}
		} else {
			location.href = API.logIn() + "?epub=" + ViewerManager.userInfo.cntsId;
		}
	});

	// 파일 다운로드 버튼 추가
	$("#btn_filedownload").on("click", function () {
		if (ViewerManager.fileDownloadURL != "undefined" && ViewerManager.fileDownloadURL.length > 0) {
			//console.log("fileDownloadURL", ViewerManager.fileDownloadURL);
			location.href = ViewerManager.fileDownloadURL;
			location.target = "_blank";
		}
	});

	// 창닫기 버튼 추가
	$("#btn_winclose").on("click", function () {
		var isiPad = navigator.userAgent.match(/iPad/i) != null;
        var isiPhone = navigator.userAgent.match(/iPhone/i) != null;
        var fwin = window.open('about:blank', '_self')
		fwin.close();
		/*
		if (isiPad || isiPhone) 
			window.open(location, '_self').close();
		else
			window.close();
		*/
		if (ViewerManager.CustomizeType == "SSG" && ViewerManager.SSG.returnURL != "undefined" && ViewerManager.SSG.returnURL.length > 0) {
			//console.log("return_url", ViewerManager.SSG.returnURL);
			location.href = ViewerManager.SSG.returnURL;
			location.target = "_self";
		}
	});

	// Info 버튼 추가
	$(".btn_info").on("click", function (event) {
		$(".help_close").trigger("click");
		if ($(".info_show").css("display") == "block") {
			$(".info_close").trigger("click");
			return false;
		}
		
		if($(window).width() > 586 )
 			$(".info_show").css( {'left':(event.clientX - 586) +'px', "width":"586px"});
		else
			$(".info_show").css( {'left':'0px' ,"width":"100%"});
		$(".info_show").fadeIn();
	});

	$(".info_close").on("click", function (e) {
		e.preventDefault;
		$(".info_show").fadeOut();
		$(".btn_info").attr("src", "images/titan_bottomMenu/bottomMenu_Info_01.png");
	});


	// 활동도우미 버튼 추가
	$(".btn_help").on("click", function (event) {
		$(".info_close").trigger("click");
		if ($(".help_show").css("display") == "block") {
			$(".help_close").trigger("click");
			return false;
		}
		$(".help_show").css( {'left':(event.clientX - 149) +'px'});
		$(".help_show").fadeIn()
	});

	$(".help_close").on("click", function () {
		$(".help_show").fadeOut();
		$(".btn_help").attr("src", "images/titan_bottomMenu/bottomMenu_Help_01.png");
	});

	// 댓글 게시판 버튼 추가
	if (ViewerManager.Settings.useComment == 'true') {
		var commentDiv = document.getElementById('commentBoard');
		var commentTitle = $('#header_title');
		var commentWrite = $('#comment_write');
		var commentClose = $('#comment_close');

		commentTitle.css('cursor', 'pointer');
		commentTitle.on('click', function () {
			var thisTime;

			if (String(ViewerManager.userInfo.loginKey).length > 0) {
				thisTime = (new Date()).yyyymmddhh24miss();
				window.localStorage.setItem('comment_' + ViewerManager.GetData.EPUB.ID, thisTime);
				document.getElementById('comment_btn').style.background = 'url("./images/titan_topMenu/topMenu_comment_normal.png") no-repeat';
				commentDiv.style.display = 'block';
			}
			else {
				location.href = API.logIn() + "?epub=" + ViewerManager.userInfo.cntsId;
			}
		});

		commentWrite.on('click', function () {
			$('#commentBoard_content iframe').attr('src', API.commentURL() + '?book_num=' + ViewerManager.GetData.EPUB.ID + '&page=write');
		});

		commentClose.on('click', function () {
			$('#commentBoard_content iframe').attr('src', API.commentURL() + '?book_num=' + ViewerManager.GetData.EPUB.ID);
			commentDiv.style.display = 'none';
		});
	}

	// Move, Select
	$(".btnMove").on("click", function() {
		$("#drawing_container").show();
		$("#zoomArea").show();
		$("#drawing_container").css({
			"pointer-events": "auto",
			"cursor": "-webkit-grab"
		});
		$(this).attr("src", "images/titan_bottomMenu/movePageIcon02.png");
		$(".btnSelect").attr("src","images/titan_bottomMenu/selectTextIcon01.png");
		
	});
	$(".btnSelect").on("click", function() {
		$("#drawing_container").hide();
		$("#zoomArea").hide();
		$("#drawing_container").css({
			"pointer-events": "none",
			"cursor": "default"
		});

		$(this).attr("src", "images/titan_bottomMenu/selectTextIcon02.png");
		$(".btnMove").attr("src","images/titan_bottomMenu/movePageIcon01.png");
	});


	//---------------------------------------------------------------------------------------------------------------------------------------------
	// 문체부에 제공한 뷰어는 판서 기능이 없기 때문에  PC 인 경우 텍스트를 긁을 수 있도록 draw_container 제거
	if ( ViewerManager.VIEWER_DEVICE == "PC"){
		$('.page_action_container').remove();
	}

	//-------------- hover event control ----------------------------------------------------------------------------------------------------------
	if (!(browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad))
	{
		$("#btn_close").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_close_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_close_btn_01.png"); }
		);

		// left / right
		$("#btnSlideLeft").hover(
			function () { $(this).attr("src", "images/arrow_left_press.png"); },
			function () { $(this).attr("src", "images/arrow_left.png"); }
		);

		$("#btnSlideRight").hover(
			function () { $(this).attr("src", "images/arrow_right_press.png"); },
			function () { $(this).attr("src", "images/arrow_right.png"); }
		);

		// left / right
		$(".btnBtmLeft").hover(
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_left_02.png"); },
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_left_01.png"); }
		);

		$(".btnBtmRight").hover(
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_right_02.png"); },
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_right_01.png"); }
		);

		// memo button
		$("#btn_memo").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_memo_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_memo_btn_01.png"); }
		);

		// link button
		$("#btn_link").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_link_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_link_btn_01.png"); }
		);

		// link button
		$(".btn_duclass").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_duclass_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_duclass_01.png"); }
		);

		// link button
		$(".btn_teacher_dataroom").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_teacher_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_teacher_01.png"); }
		);


		// first button
		$("#btnSlideLeftFirst").hover(
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_sliderBtnFirst_02.png"); },
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_sliderBtnFirst_01.png"); }
		);

		// last button
		$("#btnSlideRightLast").hover(
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_sliderBtnLast_02.png"); },
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_sliderBtnLast_01.png"); }
		);



		// indexlist button
		$(".indexList").hover(

			function () { $(this).attr("src", "images/titan_topMenu/topMenu_indexList_btn_02.png"); },
			function () {
				if (ViewerManager.currentLayerPopup === "indexListTemplet") {
					$(this).attr("src", "images/titan_topMenu/topMenu_indexList_btn_02.png");
				} else {
					$(this).attr("src", "images/titan_topMenu/topMenu_indexList_btn_01.png");
				}
			}
		);

		// search button
		$("#btn_search").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_search_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_search_btn_01.png"); }
		);

		// draw button
		$("#btn_draw").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_draw_btn_02.png"); },
			function () {
				if ($("#header_menu_detail").css("display") === "none") {
					$(this).attr("src", "images/titan_topMenu/topMenu_draw_btn_01.png");
				} else {
					$(this).attr("src", "images/titan_topMenu/topMenu_draw_btn_02.png");
				}
			}
		);

		// share button
		$("#btn_sns_share").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_share_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_share_btn_01.png"); }
		);

		// topMenu up / down
		$("#btn_menu").hover(
			function () {
				if ($("#header").css("display") === "none") {
					$(this).attr("src", "images/topArrowDown_btn_02.png");
				} else {
					$(this).attr("src", "images/topArrowUp_btn_02.png");
				}
			},
			function () {
				if ($("#header").css("display") === "none") {
					$(this).attr("src", "images/topArrowDown_btn_01.png");
				} else {
					$(this).attr("src", "images/topArrowUp_btn_01.png");
				}
			}
		);

		// bottomMenu - thumbnail button hover
		$("#callThumbnail").hover(
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_thumbnail_02.png"); },
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_thumbnail_01.png"); }
		);

		// bottomMenu - history button hover
		$("#history").hover(
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_history_02.png"); },
			function () { $(this).attr("src", "images/titan_bottomMenu/bottomMenu_history_01.png"); }
		);

		// draw select option button
		$("#selectPen").hover(
			function () { $(this).attr("src", "images/drawing/draw_penButton_02.png"); },
			function () {
				if ($("#palette_pen").css("display") === "block") {
					$(this).attr("src", "images/drawing/draw_penButton_02.png");
				} else {
					$(this).attr("src", "images/drawing/draw_penButton_01.png");
				}
			}
		);

		$("#selectHighlighter").hover(
			function () { $(this).attr("src", "images/drawing/draw_highlightButton_02.png"); },
			function () {
				if ($("#palette_highlighter").css("display") === "block") {
					$(this).attr("src", "images/drawing/draw_highlightButton_02.png");
				} else {
					$(this).attr("src", "images/drawing/draw_highlightButton_01.png");
				}
			}
		);

		$("#selectEraser").hover(
			function () { $(this).attr("src", "images/drawing/draw_eraserButton_02.png"); },
			function () {
				if ($("#palette_eraser").css("display") === "block") {
					$(this).attr("src", "images/drawing/draw_eraserButton_02.png");
				} else {
					$(this).attr("src", "images/drawing/draw_eraserButton_01.png");
				}
			}
		);

		$("#btn_pageMode").hover(
			function () {
				if (ViewerManager.pageMODE === "SINGLE") {
					$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Double2_02.png");
				}
				else {
					if(ViewerManager.pixeWidth)
						$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Double_02.png");
					else
						$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Single_02.png");
				}

			},
			function () {
				if (ViewerManager.pageMODE === "SINGLE") {
					$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Double2_01.png");
				} else {
					if(ViewerManager.pixeWidth)
						$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Double_01.png");
					else
						$(this).attr("src", "images/titan_topMenu/topMenu_pageMode_Single_01.png");
				}
			}
		);

		$(".searchList").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_search_btn_02.png"); },
			function () {
				if (ViewerManager.currentLayerPopup === "searchListTemplet") {
					$(this).attr("src", "images/titan_topMenu/topMenu_search_btn_02.png");
				} else {
					$(this).attr("src", "images/titan_topMenu/topMenu_search_btn_01.png");
				}
			}
		);

		$(".zoomIn").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_ZoomIn_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_ZoomIn_btn_01.png"); }
		);

		$(".zoomOut").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_ZoomOut_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_ZoomOut_btn_01.png"); }
		);

		$("#btn_fullScreen").hover(
			function () {
				if ($(this).attr("src") === "images/titan_topMenu/topMenu_FullScreen_btn_01.png") $(this).attr("src", "images/titan_topMenu/topMenu_FullScreen_btn_02.png");
				else $(this).attr("src", "images/titan_topMenu/topMenu_windowScreen_btn_02.png");
			},
			function () {
				if ($(this).attr("src") === "images/titan_topMenu/topMenu_FullScreen_btn_02.png" || $(this).attr("src") === "images/titan_topMenu/topMenu_FullScreen_btn_01.png") $(this).attr("src", "images/titan_topMenu/topMenu_FullScreen_btn_01.png");
				else $(this).attr("src", "images/titan_topMenu/topMenu_windowScreen_btn_01.png");
			}
		);

		$("#btn_print").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_print_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_print_btn_01.png"); }
		);

		$("#btn_more").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_more_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_more_btn_01.png"); }
		);

		$("#btn_winclose").hover(
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_windowclose_btn_02.png"); },
			function () { $(this).attr("src", "images/titan_topMenu/topMenu_windowclose_btn_01.png"); }
		);


		$(".btn_info").hover(
			function () {
				if ($(".info_show").css("display") == "none") {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Info_02.png");
				} else {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Info_02.png");
				}
			},
			function () {
				if ($(".info_show").css("display") == "none") {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Info_01.png");
				} else {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Info_02.png");
				}
			}
		);


		$(".btn_help").hover(
			function () {
				if ($(".help_show").css("display") == "none") {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Help_02.png");
				} else {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Help_02.png");
				}
			},
			function () {
				if ($(".help_show").css("display") == "none") {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Help_01.png");
				} else {
					$(this).attr("src", "images/titan_bottomMenu/bottomMenu_Help_02.png");
				}
			}
		);
		/*
		$(".btnMove").hover(
			function() {
				$(this).attr("src","images/titan_bottomMenu/movePageIcon02.png");
			},
			function() {
				$(this).attr("src","images/titan_bottomMenu/movePageIcon01.png");
			}
		);

		$(".btnSelect").hover(
			function() {
				$(this).attr("src","images/titan_bottomMenu/selectTextIcon02.png");
			},
			function() {
				$(this).attr("src","images/titan_bottomMenu/selectTextIcon01.png");
			}
		);
		*/
		//$("#btn_login").hover(
			//function () { $(this).attr("src", "images/titan_topMenu/topMenu_login_btn_02.png"); }
		//);
	}

	if (String(ViewerManager.userInfo.loginKey).length > 0) {
		$("#btn_login").addClass('login');
		//$("#btn_login").css('cursor','auto');
		$("#btn_login").attr({
			'src' : 'images/titan_topMenu/topMenu_login_btn_02.png',
			'alt' : '로그아웃',
			'title' : '로그아웃',
		});
	};
	//---------------------------------------------------------------------------------------------------------------------------------------------
	var getViewerManager = function() {
		console.log(ViewerManager);
	};
	var returnUI = {
		indexList_click : indexList_click,
		dbclick_zoom : dbclick_zoom
	};

	var dbclickZoom = "in";
	function dbclick_zoom() {
			$(window).unbind("dblclick");
			if(dbclickZoom == "in")
			{
				log("@ click zoomIn button!");

				if ($('#bookmark_container').css('display') == 'block') {
					$('#bookmark_container').css('display', 'none');
				}

				var rate1 = parseInt(ViewerManager.Settings.zoomRate1) / 100;
				var rate2 = parseInt(ViewerManager.Settings.zoomRate2) / 100;

				if (ViewerManager.zoomScore == 1) {
					ViewerManager.zoomScore = rate1;
					zoom.initZoom();
					zoom.setPreviewArea(ViewerManager.zoomScore);
					zoom.noticeZoomRate();
					zoom.zoomViewportCenterAlign();
				}
				else if (ViewerManager.zoomScore == rate1) {
					ViewerManager.zoomScore = rate2;
					zoom.setPreviewArea(ViewerManager.zoomScore);
					zoom.noticeZoomRate();
					zoom.zoomViewportCenterAlign();

					$(".zoomIn").css("display", "none");
					$(".zoomIn").parent().css("width", "0px");
					$(".zoomOut").css("display", "block");
					$(".zoomOut").parent().css("width", "52px");
					dbclickZoom = "out";
				}

				log("@ zoomRate : " + ViewerManager.zoomRate);
				log("@ ViewerManager.zoomScore : " + ViewerManager.zoomScore);
				log("@ scale : " + ViewerManager.zoomRate * ViewerManager.zoomScore);

				$("#components").css("pointer-events", "none");

				draw._zoom();
				closeOtherPopup();

				$(window).dblclick(function(){ dbclick_zoom();});
			}
			else
			{
				log("@ click zoomOut button!");
				dbclickZoom = "in";
				$(".zoomOut").css("display", "none");
				$(".zoomOut").parent().css("width", "0px");
				$(".zoomIn").css("display", "block");
				$(".zoomIn").parent().css("width", "52px");

				if ($('#bookmark_container').css('display') == 'none') {
					$('#bookmark_container').css('display', 'block');
				}

				if (ViewerManager.zoomScore === 1) {
					log("@ can not zoomOut any more!");
				} else {
					ViewerManager.zoomScore = 1;//ViewerManager.zoomScore - 0.5;
					log("@ ViewerManager.zoomScore : " + ViewerManager.zoomScore);
					log("@ scale : " + ViewerManager.zoomRate * ViewerManager.zoomScore);
					if (ViewerManager.zoomScore === 1) {
						zoom.clearZoom();
						zoom.zoomViewportCenterAlign();
						//$("#header_title").text(ViewerManager.Local.cntsTitle.getStringLength(page.adjustTitleLength()));
					} else {
						$("#pages, #drawing_container").css({
							"-ms-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
							"-webkit-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
							"transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
							"transform-origin": "0% 0%",
							"-webkit-transform-origin": "0% 0%",
							"-ms-transform-origin": "0% 0%"
						});
						zoom.setPreviewArea(ViewerManager.zoomScore);
						zoom.noticeZoomRate();
						zoom.zoomViewportCenterAlign();
					}
				}

				draw._zoom();
				closeOtherPopup();
			}
	}

	return returnUI;
});
