	
define(['jquery', 'log'], function ($, log) {
	'use strict';

	log("\n @ import bookmark.js ... \n");

	var bookmarkDatas;
	//ViewerManager.bookmarkDeletes = [];

	var initBookmarkIcon = function (frameName, PAGE_CURRENT_NUMBER) {
		
		var bookmarkIcon = document.createElement("IMG"),
			bookmarkIconAdjustX = (parseInt((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager.zoomRate) * ViewerManager.zoomRate) / 2) - 5);

		switch (ViewerManager.pageMODE) {
			case "SINGLE": {
				bookmarkIcon.setAttribute("id", "bookmarkRight");
				bookmarkIcon.setAttribute("src", "images/bookmark/img_bookmark.png");
				bookmarkIcon.setAttribute("style", "position: absolute; right:" + parseInt($('#pages').css('margin-left').split('px')[0]) + "px;");
				bookmarkIcon.setAttribute("alt", "책갈피");
				bookmarkIcon.setAttribute("title", "책갈피");
				break;
			}
			case "DOUBLE": {
				if (frameName == "#leftPageFrame" && PAGE_CURRENT_NUMBER != 1) {
					bookmarkIcon.setAttribute("id", "bookmarkLeft");
					bookmarkIcon.setAttribute("src", "images/bookmark/img_bookmark.png");
					bookmarkIcon.setAttribute("style", "position: absolute; left:" + parseInt($('#pages').css('margin-left').split('px')[0]) + "px;");
					bookmarkIcon.setAttribute("alt", "좌측 책갈피");
					bookmarkIcon.setAttribute("title", "좌측 책갈피");
				} else if (frameName == "#rightPageFrame" && PAGE_CURRENT_NUMBER != ViewerManager.PAGE_TOTAL_NUMBER + 1) {
					bookmarkIcon.setAttribute("id", "bookmarkRight");
					bookmarkIcon.setAttribute("src", "images/bookmark/img_bookmark.png");
					bookmarkIcon.setAttribute("style", "position: absolute; right:" + parseInt($('#pages').css('margin-left').split('px')[0]) + "px;");
					bookmarkIcon.setAttribute("alt", "우측 책갈피");
					bookmarkIcon.setAttribute("title", "우측 책갈피");
				}
				break;
			}
		}

		bookmarkIcon.addEventListener("click", function () {
			insertBookmarkData(bookmarkIcon.getAttribute("id"), PAGE_CURRENT_NUMBER);
		}, true);

		if (document.getElementById(bookmarkIcon.getAttribute("id")) == null) {
			document.getElementById("bookmark_container").appendChild(bookmarkIcon);	
		}

		loadBookmarkData(bookmarkIcon.getAttribute("id"));
	},	

	loadBookmarkData = function (bookmarkId) {
		log("@ Bookmark loaded");
		bookmarkDatas = JSON.parse(CONTROL.save_target("bookmark"));
		
		try {
			var thisDate = (new Date()).yyyymmddhh24miss();
			for (var i = 0; i < bookmarkDatas.bookmark.length; i++) {
				var pageNo = bookmarkDatas.bookmark[i].pageNo == undefined ? parseInt(bookmarkDatas.bookmark[i].pageNum) : parseInt(bookmarkDatas.bookmark[i].pageNo);
				pageNo = bookmarkDatas.bookmark[i].pageno == undefined ? parseInt(pageNo) : parseInt(bookmarkDatas.bookmark[i].pageno);
				// 20151222 이전에 저장된 데이터를 교체
				if (bookmarkDatas.bookmark[i].cntsId != undefined || bookmarkDatas.bookmark[i].pageNum != undefined || bookmarkDatas.bookmark[i].pageNo != undefined || bookmarkDatas.bookmark[i].bookId == undefined || bookmarkDatas.bookmark[i].lastdate == undefined) {
					var _bookID = bookmarkDatas.bookmark[i].cntsId != undefined ? bookmarkDatas.bookmark[i].cntsId : ViewerManager.GetData.EPUB.ID;
					var _pageNo = pageNo;
					var _lastDate = bookmarkDatas.bookmark[i].lastdate != undefined ? bookmarkDatas.bookmark[i].lastdate : thisDate;
					bookmarkDatas.bookmark[i] = {
						bookId : String(_bookID),
						pageno : String(_pageNo),
						lastdate : String(_lastDate)
					}
					CONTROL.save_target("bookmark", JSON.stringify(bookmarkDatas));
				}
				// end
				if (ViewerManager.VIEWER_TYPE == 'LOCAL') {
					if (ViewerManager.GetData.EPUB.ID == bookmarkDatas.bookmark[i].bookId) {
						if ((ViewerManager.pageMODE === "DOUBLE" ? (bookmarkId === "bookmarkLeft" && !ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER) ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1 : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) === pageNo) {
							document.getElementById(bookmarkId).setAttribute("src", "images/bookmark/img_bookmark_over.png");
							break;
						}
					}
				} else {
					if ((ViewerManager.pageMODE === "DOUBLE" ? (bookmarkId === "bookmarkLeft" && !ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER) ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1 : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)) === pageNo) {
						document.getElementById(bookmarkId).setAttribute("src", "images/bookmark/img_bookmark_over.png");
						break;
					}
				}
			}
		} catch (err) {
			log('@ Bookmark load Failed : ' + err);
		}
	}, 

	insertBookmarkData = function (bookmarkId, PAGE_CURRENT_NUMBER) {
		//bookmarkDatas = JSON.parse(CONTROL.save_target("bookmark"));

		var currentPageNumber = PAGE_CURRENT_NUMBER, lastDate,
		insertBookmark = function () {
			lastDate = (new Date()).yyyymmddhh24miss();
			//ViewerManager.bookmarkDeletes[parseInt(currentPageNumber)] = "";
			//console.log(ViewerManager.bookmarkDeletes);
			bookmarkDatas = JSON.parse(CONTROL.save_target("bookmark"));
			bookmarkDatas.bookmark.push({
				bookId : String(ViewerManager.GetData.EPUB.ID),
				pageno : String(currentPageNumber),
				lastdate : String(lastDate)
			});

			try {
				CONTROL.save_target("bookmark", JSON.stringify(bookmarkDatas));
			} catch (e) {
				log(e);
			}
			log('@ save bookmark sucess!');
			document.getElementById(bookmarkId).setAttribute("src", "images/bookmark/img_bookmark_over.png");
		};

		try {
			if (ViewerManager.pageMODE == "DOUBLE") {			
				if (parseInt(PAGE_CURRENT_NUMBER) == 1) currentPageNumber = parseInt(currentPageNumber);
				else if (bookmarkId == "bookmarkLeft" && !ViewerManager.isOddCheck(PAGE_CURRENT_NUMBER)) currentPageNumber = parseInt(PAGE_CURRENT_NUMBER) - 1;
			}

			bookmarkDatas = JSON.parse(CONTROL.save_target("bookmark"));
			if (document.getElementById(bookmarkId).getAttribute('src') == 'images/bookmark/img_bookmark_over.png') {
				// 삭제
				for (var i = 0; i < bookmarkDatas.bookmark.length; i++) {
					var pageNo = bookmarkDatas.bookmark[i].pageno == undefined ? parseInt(bookmarkDatas.bookmark[i].pageNo) : parseInt(bookmarkDatas.bookmark[i].pageno);
					if (parseInt(currentPageNumber) == parseInt(pageNo)) {
						lastDate = (new Date()).yyyymmddhh24miss();
						//ViewerManager.bookmarkDeletes[parseInt(currentPageNumber)] = lastDate;
						//console.log(ViewerManager.bookmarkDeletes);
						bookmarkDatas.bookmark.splice(i, 1);
						log('@ already bookmarked --> bookmark deleted...');
						CONTROL.save_target("bookmark", JSON.stringify(bookmarkDatas));
						document.getElementById(bookmarkId).setAttribute("src", "images/bookmark/img_bookmark.png");
						break;
					}
				}
			} else if (document.getElementById(bookmarkId).getAttribute('src') == 'images/bookmark/img_bookmark.png') {
				// 추가
				insertBookmark();
			}
		} catch (err) {
			log("@ bookmark Insert failed : " + err);
		}
	};


	var exportBookmark = {
		initBookmarkIcon : initBookmarkIcon
	};
	return exportBookmark;
});