
define(['jquery', 'base64', 'log', 'browser'], function ($, base64, log, browser) {
	'use strict';

	log("\n @ import draw.js ... \n");

	if (browser.ie9 || browser.ie10) {
		$('#drawing_container').remove();
	}

	// 초기 저장공간 설정
	//CONTROL.save_target("draw");

	var drawDatas, svgNS = 'http://www.w3.org/2000/svg';
	var initCheck = false, canvas, svg, rect,
		sMask, smRect, sDraw, test, smHTML, sdHTML,
		path = [], newPath, maskPath, maskRect, movePoint, attrD, drawCount, drawTerm = 0,
		drawSvgData = '',
		firstSVG, first_y,
		deletePage = [], startPage, movePage, drawPage, drawArray = [];

	var draw = {
		isDrawing: false,
		mousedown: function (coordinates) {
			first_y = coordinates.y * ViewerManager.zoomRate + Number($('#pages').css('margin-top').split('px')[0]);
			if (first_y <= $('#header_menu_detail').height()) {return;}

			path = [];
			movePoint = [Number(coordinates.x).setPoint(3), Number(coordinates.y).setPoint(3)];
			path.push(movePoint);

			this.isDrawing = true;

			// SVG 를 이용해서 그려줌
			// 새로운 패스를 만들어줌
			newPath = document.createElementNS(svgNS, 'path');
			newPath.setAttribute('opacity', ViewerManager.GLOBALALPHA);
			newPath.setAttribute('fill', 'none');
			newPath.setAttribute('stroke', ViewerManager.LINECOLOR);
			newPath.setAttribute('stroke-width', ViewerManager.LINEWIDTH);
			newPath.setAttribute('stroke-linecap', 'round');
			newPath.setAttribute('stroke-linejoin', 'round');
			newPath.setAttribute('d', 'M' + path[0][0] + ',' + path[0][1]);

			maskPath = document.createElementNS(svgNS, 'path');
			maskPath.setAttribute('opacity', ViewerManager.GLOBALALPHA);
			maskPath.setAttribute('fill', 'none');
			maskPath.setAttribute('stroke', ViewerManager.LINECOLOR);
			maskPath.setAttribute('stroke-width', ViewerManager.LINEWIDTH);
			maskPath.setAttribute('stroke-linecap', 'round');
			maskPath.setAttribute('stroke-linejoin', 'round');
			maskPath.setAttribute('d', 'M' + path[0][0] + ',' + path[0][1]);

			sMask = document.getElementById('svgMask');
			sDraw = document.getElementById('svgDrawGroup');

			if (ViewerManager.GLOBALCOMPOSITEOPERATION == 'destination-out') {
				// 일반 그리기는 저장용으로 가지고 있어야함
				newPath.setAttribute('visibility', 'hidden');
				// svg 1.2 composite operation
				//newPath.setAttribute('comp-op', 'dst-out');
				sDraw.appendChild(newPath);

				// 지우개는 마스크를 이용
				maskPath.setAttribute('stroke', '#000000');
				sMask.appendChild(maskPath);
			} else {
				// 마스크를 덮어줘야함
				//maskPath.setAttribute('opacity', 1);
				maskPath.setAttribute('stroke', '#FFFFFF');
				sMask.appendChild(maskPath);

				// 일반 그리기
				// svg 1.2 composite operation
				//newPath.setAttribute('comp-op', 'src-over');
				sDraw.appendChild(newPath);
			}

			attrD = newPath.getAttribute('d');

			drawCount = 0;

			if (movePoint[0] <= parseInt(ViewerManager.iframeContentsWidth)) {
				startPage = 'left';
			} else {
				startPage = 'right';
			}
			movePage = startPage;
			drawPage = '';
		},
		mousemove: function (coordinates) {
			if (this.isDrawing) {
				// 업데이트 되는 내용만 그려줘야함, 투명도를 지닌 선이 겹쳐져서 불투명이 되는 현상
				movePoint = [Number(coordinates.x).setPoint(3), Number(coordinates.y).setPoint(3)];
				path.push(movePoint);

				drawCount++;
				var d;
				if (drawCount == 1) {
					d = ' Q' + movePoint[0] + ',' + movePoint[1];
				} else {
					d = ' ' + movePoint[0] + ',' + movePoint[1];
				}
				attrD = attrD + d;
				if (drawCount%2 == 0) {
					$(newPath).attr('d', attrD);
					$(maskPath).attr('d', attrD);
				}

				// 그려진 부분에 대해서만 저장
				if (drawPage == '') {
					if (movePoint[0] <= parseInt(ViewerManager.iframeContentsWidth)) {
						movePage = 'left';
					} else {
						movePage = 'right';
					}

					if (startPage != movePage) {
						drawPage = movePage;
					}
				}
			}
		},
		mouseup: function () {
			if (this.isDrawing == false && ($('#drawing:hover').length !== 0 || $('#close_draw:hover').length !== 0)) {
				log("@ mouseenter! ");
				return;
			} else {
				log("@ mouseleave! ");
			}

			this.isDrawing = false;
			createDrawObject();
		}
	},

	createDrawObject = function () {
		console.log("@ createDrawObject...");

		// 현재 저장되는 페이지 방향을 저장
		// 여기에서 single, double 결정도 해야함
		var drewPage;
		if (drawPage == '') drawPage = startPage; drewPage = startPage;
		if (startPage != drawPage) drewPage = 'double';
		drawArray.push(drewPage);

		// filtering garbage data
		var dataPage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;

		drawSvgData = svg.innerHTML;
	},

	hideDrawMenu = function () {
		if ($("#draw_detail").css("display") === "block") {
			$("#btn_draw").attr("src", "images/titan_topMenu/topMenu_draw_btn_01.png");
			$("#draw_detail").slideUp("slow", function () {
				$('#header_menu_detail').css({"display": "none"});
			});
		}
	},

	attachCanvasEvent = function () {
		log("@ attachCanvasEvent...");
		// 광고 안보이기
		if ($('#div-ad-left').length > 0 ) $('#div-ad-left').css('display', 'none');
		if ($('#div-ad-right').length > 0 ) $('#div-ad-right').css('display', 'none');

		if (svg == null) {svg = document.getElementById('drawingSVG')};
		svg.addEventListener(ViewerManager.eventSelector.downEvent, procEvent, false);
		svg.addEventListener(ViewerManager.eventSelector.moveEvent, procEvent, false);
		svg.addEventListener(ViewerManager.eventSelector.upEvent, procEvent, false);
		onDrawMode();
	},

	detachCanvasEvent = function () {
		log("@ detachCanvasEvent...");
		// 광고 보이기
		if ($('#div-ad-left').length > 0 ) $('#div-ad-left').css('display', 'none');
		if ($('#div-ad-right').length > 0 ) $('#div-ad-right').css('display', 'none');

		//ViewerManager.LINEWIDTH = "0";
		if (svg == null) {svg = document.getElementById('drawingSVG')};
		svg.removeEventListener(ViewerManager.eventSelector.downEvent, procEvent, false);
		svg.removeEventListener(ViewerManager.eventSelector.moveEvent, procEvent, false);
		svg.removeEventListener(ViewerManager.eventSelector.upEvent, procEvent, false);
		offDrawMode();
	},

	procEvent = function (event) {
		var pages_margin_left = $('#pages').css('margin-left').split('px')[0];
		var pages_margin_top = $('#pages').css('margin-top').split('px')[0];

		var coordinates,
		getCoordinates = function (event) {
			var svgLeft = Number(svg.style.left.replace('px',''));
			coordinates = {
				x: ((event.clientX - Number(pages_margin_left)) / ViewerManager.zoomRate) - (svgLeft) + drawTerm,
				y: ((event.clientY - Number(pages_margin_top)) / ViewerManager.zoomRate)
			};
			return coordinates;
		};

		switch (event.type) {
			case "mousedown": {
				draw["mousedown"](getCoordinates(event));
				break;
			}
			case "mousemove": {
				draw["mousemove"](getCoordinates(event));
				break;
			}
			case "touchstart": {
				draw["mousedown"](getCoordinates(event.touches.item(0)));
				break;
			}
			case "touchmove": {
				draw["mousemove"](getCoordinates(event.touches.item(0)));
				break;
			}
			case "mouseup":
			case "touchend": {
				draw["mouseup"]();
				break;
			}
		}
	},

	onDrawMode = function () {
		$('#drawing_container').css("pointer-events", "auto");
		$("#header_title").text(ViewerManager.Local.modeTitle).css("left", "50%").css("left", "-=50px");
		$("#currentModeNotice").css("display", "block").text(ViewerManager.Local.modeNoticeText);
	},

	offDrawMode = function () {
		$('#drawing_container').css("pointer-events", "none");
		$("#header_title").text(ViewerManager.Local.cntsTitle.getStringLength(parseInt(((ViewerManager.bookContainerWidth * 0.1) / 2) - 32)) + "...");
		$("#currentModeNotice").empty().css("display", "none");
	},

	drawObjToCanvas = function (_svgData, _drawData) {
		console.log("@ drawObjToCanvas...");
		log(_svgData, _drawData);

		if (_svgData != null && _svgData != undefined) {
			// svg 를 그려줌
			svg.innerHTML = _svgData;

			// 객체 초기화에 따른 캐시
			sMask = document.getElementById('svgMask');
			sDraw = document.getElementById('svgDrawGroup');

			drawSvgData = _svgData;
		}
	},

	saveCanvasData = function (_pageNumber) {
		if (parseInt(_pageNumber) == 0) {return;}
		log("@@ saveCanvasData...");

		// svg 데이터 저장
		if (drawSvgData != null && drawSvgData.length > 0) {
			overWriteLocalData(_pageNumber);
		}
		// 이전 테이터와 비교?
	},

	insertClearRectEraser = function (_pageNumber) {
		log("@ insertClearRectEraser...");

		var _x = parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0 ? 0 : ViewerManager.iframeContentsWidth;
		// 일반 그리기는 저장용으로 가지고 있어야함
		sDraw = document.getElementById('svgDrawGroup');
		rect = document.createElementNS(svgNS, 'rect');
		rect.setAttributeNS(null, 'opacity', '1');
		rect.setAttributeNS(null, 'fill', '#660099');
		rect.setAttributeNS(null, 'x', _x);
		rect.setAttributeNS(null, 'y', '0');
		rect.setAttributeNS(null, 'visibility', 'hidden');
		rect.setAttributeNS(null, 'width', ViewerManager.iframeContentsWidth);
		rect.setAttributeNS(null, 'height', ViewerManager.iframeContentsHeight);
		sDraw.appendChild(rect);

		// 마스크 박스
		sMask = document.getElementById('svgMask');
		maskRect = document.createElementNS(svgNS, 'rect');
		maskRect.setAttributeNS(null, 'opacity', '1');
		maskRect.setAttributeNS(null, 'fill', '#000000');
		maskRect.setAttributeNS(null, 'x', _x);
		maskRect.setAttributeNS(null, 'y', '0');
		maskRect.setAttributeNS(null, 'width', ViewerManager.iframeContentsWidth);
		maskRect.setAttributeNS(null, 'height', ViewerManager.iframeContentsHeight);
		sMask.appendChild(maskRect);

		// 저장이 필요함
		createDrawObject();
		saveCanvasData(ViewerManager.PAGE_CURRENT_NUMBER);
	},

	clearCanvas = function (_delLocalData) {
		console.log("@ clearCanvas...");
		try {
			if (_delLocalData) {
				switch (ViewerManager.pageMODE) {
					case "SINGLE":
						insertClearRectEraser(ViewerManager.PAGE_CURRENT_NUMBER);

						break;
					case "DOUBLE": {
						console.log('clearCanvas DOUBLE');
						if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
							deleteLocalData(ViewerManager.PAGE_CURRENT_NUMBER);
						} else {
							deleteLocalData(parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1);
							deleteLocalData(ViewerManager.PAGE_CURRENT_NUMBER);
						}

						svg.innerHTML = firstSVG;
						drawSvgData = '';

						//CONTROL.makeSVG(null, 'delete');
						break;
					}
				}
			}
		} catch (e) {
			log("@ clearCanvas Error : " + e);
		}
	},

	loadServerData = function () {
		log("@ loadServerData...");
		// load server draw data
		drawDatas = JSON.parse(CONTROL.save_target("draw"));

		if (drawDatas.draw.length > 0) {
			// localStorage searching
			var save_each = false;
			for (var i = 0; i < drawDatas.draw.length; i++) {
				var pageNo = drawDatas.draw[i].pageNo == undefined ? parseInt(drawDatas.draw[i].pageNum) : parseInt(drawDatas.draw[i].pageNo);
				pageNo = drawDatas.draw[i].pageno == undefined ? pageNo : parseInt(drawDatas.draw[i].pageno);

				if (ViewerManager.VIEWER_TYPE == 'LOCAL') {
					if (ViewerManager.GetData.EPUB.ID == drawDatas.draw[i].bookId) {
						if (ViewerManager.pageMODE == "SINGLE") {
							if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
								drawObjToCanvas(drawDatas.draw[i].svg, drawDatas.draw[i].imgData);
								break;
							}
						} else if (ViewerManager.pageMODE == "DOUBLE") {
							if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
								if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
									drawObjToCanvas(drawDatas.draw[i].svg, drawDatas.draw[i].imgData);
									break;
								}
							} else {
								if ((parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) == pageNo || parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
									drawObjToCanvas(drawDatas.draw[i].svg, drawDatas.draw[i].imgData);
									break;
								}
							}
						}
					}
				} else {
					// 20151222 이전에 저장된 데이터를 교체 ++ 2.6.1 이전 버전의 캔버스 데이터를 교체
					//console.log(drawDatas.draw[i].cntsId != undefined, drawDatas.draw[i].pageNum != undefined, drawDatas.draw[i].bookId == undefined, drawDatas.draw[i].svg == undefined);
					if (drawDatas.draw[i].svg == undefined) {save_each = true;}
					if (drawDatas.draw[i].cntsId != undefined || drawDatas.draw[i].pageNum != undefined || drawDatas.draw[i].bookId == undefined || drawDatas.draw[i].svg == undefined) {
						var _bookID = drawDatas.draw[i].cntsId != undefined ? drawDatas.draw[i].cntsId : ViewerManager.GetData.EPUB.ID;
						var _pageNo = String(pageNo);
						var _imageData = drawDatas.draw[i].imgData;
						var _lastDate = drawDatas.draw[i].lastDate != undefined ? drawDatas.draw[i].lastDate : (new Date()).yyyymmddhh24miss();
						var _svg = drawDatas.draw[i].svg;

						//console.log(i, _bookID, _pageNo, _imageData, _lastDate, _svg);

						if (_imageData != undefined && _svg == undefined) {
							_svg = convertImageToSVG(_imageData);
						}

						var savePage = parseInt(_pageNo) == 1 ? parseInt(_pageNo) : parseInt(_pageNo)%2 == 0 ? parseInt(_pageNo) : parseInt(_pageNo) - 1;
				        if (savePage < 10) {
				            savePage = '000' + String(savePage);
				        } else if (savePage >= 10 && savePage < 100) {
				            savePage = '00' + String(savePage);
				        } else if (savePage >= 100 && savePage < 1000) {
				            savePage = '0' + String(savePage);
				        } else if (savePage >= 1000 && savePage <= 10000) {
				            savePage = String(savePage);
				        }

				        _svg = _svg.replace(/\t/gi, '');

						drawDatas.draw[i] = {
							bookId : _bookID,
							pageno : _pageNo,
							lastdate : _lastDate,
							svg : _svg,
							drawurl : savePage + '.svg',
							show : 'true'
						}

						if (i == drawDatas.draw.length - 1) {
							CONTROL.save_target("draw", JSON.stringify(drawDatas));
							if (save_each == true) {CONTROL.save_svg_each();}

							if (ViewerManager.pageMODE == "SINGLE") {
								if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
									drawObjToCanvas(drawDatas.draw[i].svg, null);
									//break;
								}
							} else if (ViewerManager.pageMODE == "DOUBLE") {
								if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
									if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
										drawObjToCanvas(drawDatas.draw[i].svg, null);
										//break;
									}
								} else {
									if ((parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) == pageNo || parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
										drawObjToCanvas(drawDatas.draw[i].svg, null);
										//break;
									}
								}
							}
						}
					} else {
						// 이전 데이터가 변환이 끝난 경우
						if (ViewerManager.pageMODE == "SINGLE") {
							if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
								drawObjToCanvas(drawDatas.draw[i].svg, drawDatas.draw[i].imgData);
								break;
							}
						} else if (ViewerManager.pageMODE == "DOUBLE") {
							if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1) {
								if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
									drawObjToCanvas(drawDatas.draw[i].svg, drawDatas.draw[i].imgData);
									break;
								}
							} else {
								if ((parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) == pageNo || parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == pageNo) {
									drawObjToCanvas(drawDatas.draw[i].svg, drawDatas.draw[i].imgData);
									break;
								}
							}
						}
					}
				}
			}
		}
	},

	convertImageToSVG = function(_imageData) {
		log('convertImageToSVG', _imageData);
		var returnSVG, drawObj = JSON.parse(_imageData), prevData = null, presentData;

		svg.innerHTML = firstSVG;
		// 기존 데이터를 svg로 변경해줌
		// canvas 정보는 다시 svg로 변환해줘야함
		sMask = document.getElementById('svgMask');
		sDraw = document.getElementById('svgDrawGroup');

		for (var index in drawObj["data"]) {
			// 기존 데이터가 중복 데이터가 많음
			// 여기서 중복 데이터를 걸러내야함
			presentData = JSON.stringify(drawObj["data"][index]);
			if (prevData != null && prevData == presentData) {
				prevData = presentData;
				continue;
			}

			var _opacity, _stroke, _strokeWidth, _d, _x;

			if (drawObj['data'][index]['globalCompositeOperation'] == 'source-over') {
				// 일반 펜
				_opacity = '1';
				_stroke = drawObj['data'][index]['color'];
				if (_stroke.indexOf('Black') != -1) {
					_stroke = '#000000';
				} else if (_stroke.indexOf('Purple') != -1) {
					_stroke = '#6F00FF';
				} else if (_stroke.indexOf('Red') != -1) {
					_stroke = '#FF0000';
				} else if (_stroke.indexOf('Yellow') != -1) {
					_stroke = '#FFFF00';
				} else if (_stroke.indexOf('Green') != -1) {
					_stroke = '#00FF00';
				} else if (_stroke.indexOf('Blue') != -1) {
					_stroke = '#0000FF';
				}
				_strokeWidth = drawObj['data'][index]['lineWidth'];
				_d = makeD(drawObj['data'][index]['path']);

				newPath = document.createElementNS(svgNS, 'path');
				newPath.setAttribute('opacity', _opacity);
				newPath.setAttribute('fill', 'none');
				newPath.setAttribute('stroke', _stroke);
				newPath.setAttribute('stroke-width', _strokeWidth);
				newPath.setAttribute('stroke-linecap', 'round');
				newPath.setAttribute('stroke-linejoin', 'round');
				newPath.setAttribute('d', _d);

				maskPath = document.createElementNS(svgNS, 'path');
				maskPath.setAttribute('opacity', _opacity);
				maskPath.setAttribute('fill', 'none');
				maskPath.setAttribute('stroke', _stroke);
				maskPath.setAttribute('stroke-width', _strokeWidth);
				maskPath.setAttribute('stroke-linecap', 'round');
				maskPath.setAttribute('stroke-linejoin', 'round');
				maskPath.setAttribute('d', _d);

				// 마스크를 덮어줘야함
				//maskPath.setAttribute('opacity', 1);
				maskPath.setAttribute('stroke', '#FFFFFF');
				sMask.appendChild(maskPath);

				// 일반 그리기
				// svg 1.2 composite operation
				//newPath.setAttribute('comp-op', 'src-over');
				sDraw.appendChild(newPath);

			} else if (drawObj["data"][index]["globalCompositeOperation"] == 'xor') {
				// 형광 펜
				_opacity = '0.5';
				_stroke = drawObj['data'][index]['color'];
				if (_stroke.replace(/\s/gi, '').indexOf('rgba(0,0,0') != -1) {
					_stroke = "#000000";
				} else if (_stroke.replace(/\s/gi, '').indexOf('rgba(111,0,255') != -1) {
					_stroke = "#6F00FF";
				} else if (_stroke.replace(/\s/gi, '').indexOf('rgba(255,0,0') != -1) {
					_stroke = "#FF0000";
				} else if (_stroke.replace(/\s/gi, '').indexOf('rgba(255,255,0') != -1) {
					_stroke = "#FFFF00";
				} else if (_stroke.replace(/\s/gi, '').indexOf('rgba(0,255,0') != -1) {
					_stroke = "#00FF00";
				} else if (_stroke.replace(/\s/gi, '').indexOf('rgba(0,0,255') != -1) {
					_stroke = "#0000FF";
				}
				_strokeWidth = drawObj['data'][index]['lineWidth'];
				_d = makeD(drawObj['data'][index]['path']);

				// 마스크를 덮어줘야함
				maskPath = document.createElementNS(svgNS, 'path');
				//maskPath.setAttribute('opacity', 1);
				maskPath.setAttribute('opacity', _opacity);
				maskPath.setAttribute('fill', 'none');
				maskPath.setAttribute('stroke', '#FFFFFF');
				maskPath.setAttribute('stroke-width', _strokeWidth);
				maskPath.setAttribute('stroke-linecap', 'round');
				maskPath.setAttribute('stroke-linejoin', 'round');
				maskPath.setAttribute('d', _d);
				sMask.appendChild(maskPath);

				// 일반 그리기
				newPath = document.createElementNS(svgNS, 'path');
				newPath.setAttribute('opacity', _opacity);
				newPath.setAttribute('fill', 'none');
				newPath.setAttribute('stroke', _stroke);
				newPath.setAttribute('stroke-width', _strokeWidth);
				newPath.setAttribute('stroke-linecap', 'round');
				newPath.setAttribute('stroke-linejoin', 'round');
				newPath.setAttribute('d', _d);
				// svg 1.2 composite operation
				//newPath.setAttribute('comp-op', 'src-over');
				sDraw.appendChild(newPath);
			} else if (drawObj["data"][index]["globalCompositeOperation"] == 'destination-out') {
				// 지우개
				_strokeWidth = drawObj['data'][index]['lineWidth'];
				_d = makeD(drawObj['data'][index]['path']);

				// 일반 그리기는 저장용으로 가지고 있어야함
				newPath = document.createElementNS(svgNS, 'path');
				newPath.setAttribute('opacity', '1');
				newPath.setAttribute('fill', 'none');
				newPath.setAttribute('stroke', '#660099');
				newPath.setAttribute('stroke-width', _strokeWidth);
				newPath.setAttribute('stroke-linecap', 'round');
				newPath.setAttribute('stroke-linejoin', 'round');
				newPath.setAttribute('d', _d);
				newPath.setAttribute('visibility', 'hidden');
				// svg 1.2 composite operation
				//newPath.setAttribute('comp-op', 'dst-out');
				sDraw.appendChild(newPath);

				maskPath = document.createElementNS(svgNS, 'path');
				maskPath.setAttribute('opacity', '1');
				maskPath.setAttribute('fill', 'none');
				maskPath.setAttribute('stroke', '#000000');
				maskPath.setAttribute('stroke-width', _strokeWidth);
				maskPath.setAttribute('stroke-linecap', 'round');
				maskPath.setAttribute('stroke-linejoin', 'round');
				maskPath.setAttribute('d', _d);
				// 지우개는 마스크를 이용
				sMask.appendChild(maskPath);
			} else if (drawObj["data"][index]["globalCompositeOperation"] == 'clearRect'){
				// 지우개 박스
				if (drawObj['data'][index]['target'] == 'leftFrame') {
					_x = '0';
				} else if (drawObj['data'][index]['target'] == 'rightFrame') {
					_x = ViewerManager.iframeContentsWidth;
				}

				// 일반 그리기는 저장용으로 가지고 있어야함
				rect = document.createElementNS(svgNS, 'rect');
				rect.setAttributeNS(null, 'opacity', '1');
				rect.setAttributeNS(null, 'fill', '#660099');
				rect.setAttributeNS(null, 'x', _x);
				rect.setAttributeNS(null, 'y', '0');
				rect.setAttributeNS(null, 'visibility', 'hidden');
				rect.setAttributeNS(null, 'width', ViewerManager.iframeContentsWidth);
				rect.setAttributeNS(null, 'height', ViewerManager.iframeContentsHeight);
				sDraw.appendChild(rect);

				sMask = document.getElementById('svgMask');
				// 마스크 박스
				maskRect = document.createElementNS(svgNS, 'rect');
				maskRect.setAttributeNS(null, 'opacity', '1');
				maskRect.setAttributeNS(null, 'fill', '#000000');
				maskRect.setAttributeNS(null, 'x', _x);
				maskRect.setAttributeNS(null, 'y', '0');
				maskRect.setAttributeNS(null, 'width', ViewerManager.iframeContentsWidth);
				maskRect.setAttributeNS(null, 'height', ViewerManager.iframeContentsHeight);
				sMask.appendChild(maskRect);
			}

			prevData = JSON.stringify(drawObj["data"][index]);
		}

		returnSVG = svg.innerHTML;
		returnSVG = returnSVG.replace(/\t/gi, '');

		return returnSVG;
	},

	// svg 데이터가 달라서 변환해줘야함
	convertWebToApp = function (_websvg) {
		log('convertWebToApp', _websvg);
		var returnSVG, i, j, k, svgMask, svgGroup;
		// 앱에서 사용하는 형태로 변환
        var tempSVG = document.createElementNS(svgNS, 'svg');
        tempSVG.innerHTML = _websvg;

        if (tempSVG.childNodes.length == 0) {
        	tempSVG = null;
        	returnSVG = '';
        	return returnSVG;
        }

        for (i = 0; i < tempSVG.childNodes.length; i++) {
			var thisNodeName = tempSVG.childNodes[i].nodeName.toLowerCase();
			if (thisNodeName == 'mask') {
				svgMask = tempSVG.childNodes[i].cloneNode(true);
				tempSVG.removeChild(tempSVG.childNodes[i]);
				i--;
			} else if (thisNodeName == 'g') {
				svgGroup = tempSVG.childNodes[i].cloneNode(true);
				tempSVG.removeChild(tempSVG.childNodes[i]);
				i--;
			}
		}

		var tempGroup = document.createElementNS(svgNS, 'g');
		tempGroup.innerHTML = svgGroup.innerHTML;

		for (i = 0; i < tempGroup.childNodes.length; i++) {
			var thisNodeName = tempGroup.childNodes[i].nodeName.toLowerCase();
			if (tempGroup.childNodes[i].nodeType == '1') {
				// ie, edge 에서 저장되는 형식이 좀 다름
				/*if (browser.ie11 || browser.edge) {
					if (thisNodeName == 'path') {
						var d_array = tempGroup.childNodes[i].getAttribute('d').split('Q');
						for (j = 0; j < d_array.length; j++) {
							var _point;
							_point = d_array[j].split(' ');
							if (j == 0) {
								d_array[j] = _point[1] + ',' + _point[2];
								d_array[j] = 'M' + d_array[j];
							} else if (j == 1) {
								d_array[j] = _point[0] + ',' + _point[1];
								d_array[j] = 'Q' + d_array[j];
							} else {

								d_array[j] = _point[0] + ',' + _point[1];
							}
						}
					}
				}*/

				if (tempGroup.childNodes[i].getAttribute('visibility') != null) {
					tempGroup.childNodes[i].removeAttribute('visibility');
				}
				tempSVG.appendChild(tempGroup.childNodes[i].cloneNode(true));
			}
		}

        returnSVG = tempSVG.innerHTML;
        returnSVG = returnSVG.replace(/\t/gi, '');
        returnSVG = returnSVG.replace(/\n/gi, '');

        log('returnSVG', returnSVG);

        tempSVG = null;

        return returnSVG;
	},

	// svg 데이터가 달라서 변환해줘야함
	convertAppToWeb = function (_appsvg) {
		log('convertAppToWeb', _appsvg);
		var returnSVG, i, j, k, svgMask, svgGroup;
		// 웹에서 사용하는 형태로 변환

		// 기본 틀 작성
		var tempSVG = document.createElementNS(svgNS, 'svg');
		tempSVG.innerHTML = firstSVG;

		for (i = 0; i < tempSVG.childNodes.length; i++) {
			var thisNodeName = tempSVG.childNodes[i].nodeName.toLowerCase();
			if (thisNodeName == 'mask') {
				svgMask = tempSVG.childNodes[i];
			} else if (thisNodeName == 'g') {
				svgGroup = tempSVG.childNodes[i];
			}
		}

		var _drawPath, _maskPath, _drawRect, _maskRect;
		for (i = 0; i < _appsvg.length; i++) {
			if (_appsvg[i].nodeType == 1) {
				if (_appsvg[i].tagName == 'path') {
					_drawPath = _appsvg[i].cloneNode(true);
					_maskPath = _drawPath.cloneNode(true);

					if (_drawPath.getAttribute('stroke') == '#660099') {
	                	// 지우개
	                	_drawPath.setAttribute('visibility', 'hidden');
	                	if (_drawPath.getAttribute('xmlns') != null) {
	                		_drawPath.removeAttribute('xmlns');
	                	}
	                	svgGroup.appendChild(_drawPath);

	                	_maskPath.setAttribute('stroke', '#000000');
	                	if (_maskPath.getAttribute('xmlns') != null) {
	                		_maskPath.removeAttribute('xmlns');
	                	}
	                	svgMask.appendChild(_maskPath);
	                } else {
	                	// 펜선
	                	_maskPath.setAttribute('stroke', '#FFFFFF');
	                	if (_maskPath.getAttribute('xmlns') != null) {
	                		_maskPath.removeAttribute('xmlns');
	                	}
	                	svgMask.appendChild(_maskPath);

	                	if (_drawPath.getAttribute('xmlns') != null) {
	                		_drawPath.removeAttribute('xmlns');
	                	}
	                	svgGroup.appendChild(_drawPath);
	                }
				} else if (_appsvg[i].tagName == 'rect') {
					// 지우개 박스
					_drawRect = _appsvg[i].cloneNode(true);
					_maskRect = _drawRect.cloneNode(true);

	            	// 지우개
	            	_maskRect.setAttribute('fill', '#000000');
	            	_maskRect.setAttribute('stroke', '#000000');
	            	if (_maskRect.getAttribute('xmlns') != null) {
	            		_maskRect.removeAttribute('xmlns');
	            	}
	            	svgMask.appendChild(_maskRect);

	                _drawRect.setAttribute('visibility', 'hidden');
	                if (_drawRect.getAttribute('xmlns') != null) {
	                	_drawRect.removeAttribute('xmlns');
	            	}
	                svgGroup.appendChild(_drawRect);
				}
			}
		}

        returnSVG = tempSVG.innerHTML;
        returnSVG = returnSVG.replace(/\t/gi, '');

        tempSVG = null;

        return returnSVG;
	},

	makeD = function (_path) {
		var returnDraw, i, _pathLength = _path.length, _movePoint;
		if (_pathLength%2 == 0) {_pathLength = _pathLength - 1;}

		for (i = 0; i < _pathLength; i++) {
			_movePoint = [Number(_path[i][0]).setPoint(3), Number(_path[i][1]).setPoint(3)];
			if (i == 0) {
				returnDraw = 'M' + _movePoint[0] + ',' + _movePoint[1];
			} else if (i == 1) {
				returnDraw = returnDraw + ' Q' + _movePoint[0] + ',' + _movePoint[1];
			} else {
				returnDraw = returnDraw + ' ' + _movePoint[0] + ',' + _movePoint[1];
			}
		}

		return returnDraw;
	},

	excuteInsertDrawDataInLocalStorage = function (_pageNumber, _show) {
		log('excuteInsertDrawDataInLocalStorage', _pageNumber, _show);
		if (ViewerManager.pageMODE == "SINGLE") {
			if (parseInt(_pageNumber) == 1) {
				insertlocalData(_pageNumber, _show);
			} else {
				var doublePage = parseInt(_pageNumber)%2 == 0 ? 1 : - 1;
				var showDoublePage = deletePage[parseInt(_pageNumber) + doublePage] == "false" ? "false" : deletePage[parseInt(_pageNumber) + doublePage] == undefined ? "false" : deletePage[parseInt(_pageNumber) + doublePage];
				insertlocalData((parseInt(_pageNumber) + doublePage), showDoublePage);
				insertlocalData(_pageNumber, _show);
			}
		} else if (ViewerManager.pageMODE == "DOUBLE") {
			if (drawArray.length == 0) return;
			// 페이지 결정, 한면 또는 양면
			var saveType, firstPage, changePage;
			if (drawArray.length == 1) {
				if (drawArray[0] == 'double') {
					firstPage = 'double';
					saveType = 'double';
				} else {
					firstPage = drawArray[0];
					saveType = 'single';
				}
			} else {
				for (var i = 0, drawMax = drawArray.length; i < drawMax; i++) {
					if (i == 0) {
						if (drawArray[0] == 'double') {
							firstPage = 'double';
							saveType = 'double';
							break;
						} else {
							firstPage = drawArray[0];
							saveType = 'single';
						}
					} else {
						if (drawArray[i] == 'double') {
							firstPage = 'double';
							saveType = 'double';
							break;
						} else {
							if (firstPage != drawArray[i]) {
								saveType = 'double';
								break;
							}
						}
					}
				}
			}

			if (saveType == 'single') {
				// 한면만 저장
				if (firstPage == 'left') {
					excuteDeleteSavedLocalStorageData((parseInt(_pageNumber) - 1));
					insertlocalData((parseInt(_pageNumber) - 1));
				} else {
					excuteDeleteSavedLocalStorageData(_pageNumber);
					insertlocalData(_pageNumber);
				}
			} else {
				// 양면 저장
				excuteDeleteSavedLocalStorageData((parseInt(_pageNumber) - 1));
				insertlocalData((parseInt(_pageNumber) - 1));
				excuteDeleteSavedLocalStorageData(_pageNumber);
				insertlocalData(_pageNumber);
			}

			startPage = '', drawPage = '';
			drawArray = [];

			/*
			if (parseInt(_pageNumber) == 1) {
				insertlocalData(_pageNumber);
			} else if (parseInt(_pageNumber) > parseInt(ViewerManager.PAGE_TOTAL_NUMBER)) {
				insertlocalData((parseInt(_pageNumber) - 1));
			} else {
				insertlocalData((parseInt(_pageNumber) - 1));
				insertlocalData(_pageNumber);
			}*/
		}
	},

	excuteDeleteSavedLocalStorageData = function (_pageNumber) {
		log('excuteDeleteSavedLocalStorageData', _pageNumber);

		try {
			drawDatas = JSON.parse(CONTROL.save_target("draw"));
			var dLength = drawDatas.draw.length;

			for (var i = dLength - 1; i > -1; i--) {
				var pageNo = drawDatas.draw[i].pageNo == undefined ? parseInt(drawDatas.draw[i].pageNum) : parseInt(drawDatas.draw[i].pageNo);
					pageNo = drawDatas.draw[i].pageno == undefined ? pageNo : parseInt(drawDatas.draw[i].pageno);

				if (parseInt(_pageNumber) == pageNo) {
					// 무조건 삭제
					drawDatas.draw.splice(i, 1);
				}
			}

			CONTROL.save_target("draw", JSON.stringify(drawDatas));
		} catch (e) {
			log(e);
		}
	},

	overWriteLocalData = function (_pageNumber) {
		log("@ overWriteLocalData...", _pageNumber);

		try {
			drawDatas = JSON.parse(CONTROL.save_target("draw"));
			// 기존삭제 excuteDeleteSavedLocalStorageData, 저장 excuteInsertDrawDataInLocalStorage
			if (drawDatas.draw.length > 0) {
				var find = false;
				for (var i = 0; i < drawDatas.draw.length; i++) {
					// searching localStorage
					var pageNo = drawDatas.draw[i].pageNo == undefined ? parseInt(drawDatas.draw[i].pageNum) : parseInt(drawDatas.draw[i].pageNo);
					pageNo = drawDatas.draw[i].pageno == undefined ? pageNo : parseInt(drawDatas.draw[i].pageno);

					if (ViewerManager.VIEWER_TYPE == 'LOCAL') {
						if (ViewerManager.GetData.EPUB.ID == drawDatas.draw[i].bookId && parseInt(_pageNumber) == pageNo) {
							find = true;

							var doublePage = ViewerManager.pageMODE == 'SINGLE' ? (parseInt(_pageNumber)%2 == 0 ? (parseInt(_pageNumber) + 1) : (parseInt(_pageNumber) - 1)) : (parseInt(_pageNumber) - 1);
							// 삭제
							excuteDeleteSavedLocalStorageData(_pageNumber);
							if (doublePage != 0) {excuteDeleteSavedLocalStorageData(doublePage);}
							// 추가
							excuteInsertDrawDataInLocalStorage(_pageNumber);
							//if (ViewerManager.pageMODE == 'SINGLE' && doublePage != 0) {excuteInsertDrawDataInLocalStorage(doublePage);}
							break;
						} else {
							// 찾는 데이터가 없음
							find = false;
						}
					} else {
						if (parseInt(_pageNumber) == pageNo) {
							find = true;

							var doublePage = ViewerManager.pageMODE == 'SINGLE' ? (parseInt(_pageNumber)%2 == 0 ? (parseInt(_pageNumber) + 1) : (parseInt(_pageNumber) - 1)) : (parseInt(_pageNumber) - 1);
							//var doublePage = ViewerManager.pageMODE == "SINGLE" ? 0 : (parseInt(_pageNumber) - 1);
							// 삭제
							excuteDeleteSavedLocalStorageData(_pageNumber);
							if (doublePage != 0) {excuteDeleteSavedLocalStorageData(doublePage);}
							// 추가
							excuteInsertDrawDataInLocalStorage(_pageNumber);
							//if (ViewerManager.pageMODE == 'SINGLE' && doublePage != 0) {excuteInsertDrawDataInLocalStorage(doublePage);}
							break;
						} else {
							// 찾는 데이터가 없음
							find = false;
						}
					}
				}

				// 이전 데이터가 없는 상태
				if (find == false) {
					excuteInsertDrawDataInLocalStorage(_pageNumber);
				}
			} else {
				// 저장된 데이터가 아예 없는 상태
				excuteInsertDrawDataInLocalStorage(_pageNumber);
			}
		} catch (err) {
			log("@ overWriteLocalData " + err);
		}
	},

	deleteLocalData = function (_pageNumber) {
		log("@ deleteLocalData...");
		try {
			drawDatas = JSON.parse(CONTROL.save_target("draw"));
			for (var i = 0; i < drawDatas.draw.length; i++) {
				var pageNo = drawDatas.draw[i].pageNo == undefined ? parseInt(drawDatas.draw[i].pageNum) : parseInt(drawDatas.draw[i].pageNo);
				pageNo = drawDatas.draw[i].pageno == undefined ? pageNo : parseInt(drawDatas.draw[i].pageno);
				if (parseInt(_pageNumber) == pageNo) {
					drawDatas.draw.splice(i, 1);
					CONTROL.save_target("draw", JSON.stringify(drawDatas));
					log('@ localStorage.draw : ' + JSON.parse(CONTROL.save_target("draw")));
				}
			}
		} catch (e) {
			log("@ deleteLocalData Error : " + e);
		}
	},

	insertlocalData = function (_pageNumber, _imageData, _show) {
		log("@ insertlocalData...");
		log("@ insert date : " + (new Date()).yyyymmddhh24miss(), _pageNumber + 'page');

		// insert draw data to localStorage
		drawDatas = JSON.parse(CONTROL.save_target("draw"));
		log('@ ::: insert draw data to localStorage ... :::');

		var thisShow = "true";
		if (_show == "false") {thisShow = _show;}

		var savePage = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) == 1 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0 ? parseInt(ViewerManager.PAGE_CURRENT_NUMBER) : parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1;
        if (savePage < 10) {
            savePage = '000' + String(savePage);
        } else if (savePage >= 10 && savePage < 100) {
            savePage = '00' + String(savePage);
        } else if (savePage >= 100 && savePage < 1000) {
            savePage = '0' + String(savePage);
        } else if (savePage >= 1000 && savePage <= 10000) {
            savePage = String(savePage);
        }

        drawSvgData = drawSvgData.replace(/\t/gi, '');

		drawDatas.draw.push({
			bookId : ViewerManager.GetData.EPUB.ID,
			pageno : String(_pageNumber),
			lastdate : (new Date()).yyyymmddhh24miss(),
			svg : drawSvgData,
			drawurl : savePage + '.svg',
			show : thisShow
		});

		deletePage[_pageNumber] = thisShow;

		CONTROL.save_target("draw", JSON.stringify(drawDatas));
	},

	setDrawPaletteInfo = function (paletteType) {
		var drawPalette = JSON.parse(window.localStorage.getItem("palette"));

		// log(drawPalette);
		if (drawPalette === null) {
			try {
				window.localStorage.setItem("palette", JSON.stringify({"palette" : []}));
				drawPalette = JSON.parse(window.localStorage.getItem("palette"));
				drawPalette.palette.push({paletteId : "pen", selectColor : "#colorBlack", lineWidth : "6"}, {paletteId : "highlight", selectColor : "#highlighterBlack", lineWidth : "10"});
				window.localStorage.setItem("palette", JSON.stringify(drawPalette));
			} catch (e) {
				log(e);
			}
		}

		$(drawPalette.palette[paletteType].selectColor).trigger("click");
		$("#slider_drawing").slider({
			value: drawPalette.palette[paletteType].lineWidth
		});
		ViewerManager.LINEWIDTH = drawPalette.palette[paletteType].lineWidth;

	},

	insertDrawPaletteInfo = function (valueType, paletteId, setValue) {
		var paletteIndex;

		switch (paletteId) {
			case "pen":
				paletteIndex = 0;
				break;
			case "highlighter":
				paletteIndex = 1;
				break;
		}
		var drawPalette = JSON.parse(window.localStorage.getItem("palette"));

		switch (valueType) {
			case "color":
				drawPalette.palette[paletteIndex].selectColor = setValue;
				break;
			case "lineWidth":
					drawPalette.palette[paletteIndex].lineWidth = setValue;
				break;
		}
		try {
			window.localStorage.setItem("palette", JSON.stringify(drawPalette));
		} catch (e) {
			log(e);
		}
	},

	_init = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('@ draw._init');

		var svgParent = document.getElementById('drawing_container');
		svgParent.style.width = (ViewerManager.iframeContentsWidth * 2) + 'px';
		svgParent.style.height = ViewerManager.iframeContentsHeight + 'px';

		svg = document.getElementById('drawingSVG');
		svg.setAttribute('width', (ViewerManager.iframeContentsWidth * 2) + 'px');
		svg.setAttribute('height', ViewerManager.iframeContentsHeight + 'px');

		sMask = document.getElementById('svgMask');
		sMask.setAttribute('width', (ViewerManager.iframeContentsWidth * 2));
		sMask.setAttribute('height', ViewerManager.iframeContentsHeight);

		smRect = document.getElementById('maskRect');
		smRect.setAttribute('width', (ViewerManager.iframeContentsWidth * 2));
		smRect.setAttribute('height', ViewerManager.iframeContentsHeight);

		sDraw = document.getElementById('svgDrawGroup');
		sDraw.setAttribute('width', (ViewerManager.iframeContentsWidth * 2));
		sDraw.setAttribute('height', ViewerManager.iframeContentsHeight);

		firstSVG = svg.innerHTML;

		drawDatas = JSON.parse(CONTROL.save_target("draw"));
	},

	_loadStart = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('@ draw._loadStart');
		// 판서 잠시 지우기
        $('#draw_detail').css('display', 'none');
        $('#drawing_container').css('display', 'none');

        detachCanvasEvent();
		hideDrawMenu();

		svg.innerHTML = firstSVG;

		drawSvgData = '';
	},

	_loadComplete = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('@ draw._loadComplete');
		// svg 포지션
		if (svg == null) {svg = document.getElementById('drawingSVG')};
		/*if (!browser.ie9 && !browser.ie10) {
	        // svg resize
	        if (svg == null) {svg = document.getElementById('drawingSVG')};
	        svg.setAttribute('width', ViewerManager.iframeContentsWidth * 2 * ViewerManager.zoomRate + 'px');
	        svg.setAttribute('height', ViewerManager.iframeContentsHeight * ViewerManager.zoomRate + 'px');
	    }*/
		if (ViewerManager.pageMODE == "SINGLE") {
			if (parseInt(ViewerManager.PAGE_CURRENT_NUMBER)%2 == 0) {
				drawTerm = 0;
				svg.style.width = ViewerManager.iframeContentsWidth + 'px';
				svg.setAttribute('viewBox', '0 0 ' + ViewerManager.iframeContentsWidth + ' ' + ViewerManager.iframeContentsHeight);
			} else {
				drawTerm = parseInt(ViewerManager.iframeContentsWidth);
				svg.style.width = ViewerManager.iframeContentsWidth + 'px';
				svg.setAttribute('viewBox', ViewerManager.iframeContentsWidth + ' 0 ' + ViewerManager.iframeContentsWidth + ' ' + ViewerManager.iframeContentsHeight);
			}
		} else if (ViewerManager.pageMODE == "DOUBLE") {
			drawTerm = 0;
			svg.style.width = ViewerManager.iframeContentsWidth * 2 + 'px';
			svg.setAttribute('viewBox', '0 0 ' + ViewerManager.iframeContentsWidth * 2 + ' ' + ViewerManager.iframeContentsHeight);
		}

		$('#drawing_container').css({"display" : "block"});
		loadServerData();
	},

	_save = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('@ draw._save');
		saveCanvasData(ViewerManager.PAGE_CURRENT_NUMBER);
	},

	_resize = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('@ draw._resize');
		// draw
	    /*if (!browser.ie9 && !browser.ie10) {
	        // svg resize
	        if (svg == null) {svg = document.getElementById('drawingSVG')};
	        svg.setAttribute('width', ViewerManager.iframeContentsWidth * 2 * ViewerManager.zoomRate + 'px');
	        svg.setAttribute('height', ViewerManager.iframeContentsHeight * ViewerManager.zoomRate + 'px');
	    }*/
	},

	_refresh = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('draw._refresh');
		loadServerData();
	},
	_zoomMove = function() {
		$("#drawing_container").css({
			"pointer-events": "auto",
			"cursor": "-webkit-grab"
		});
	},
	_zoomClick = function() {
		$("#drawing_container").css({
			"pointer-events": "none",
			"cursor": "default"
		});
	},
	_zoom = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('draw._zoom');
		
		if (ViewerManager.zoomScore == 1) {
			$("#drawing_container").css({
				"pointer-events": "none",
				"cursor": "default"
			});
		} else {
			
			if ($("#draw_detail").css("display") === "block") {
				detachCanvasEvent();
				offDrawMode();
				hideDrawMenu();
				console.log( "#draw_detail" );
			}

			$("#drawing_container").css({
				"pointer-events": "auto",
				"cursor": "-webkit-grab"
			});

		}
	}
	
	var exportDraw = {
		attachCanvasEvent : attachCanvasEvent,
		detachCanvasEvent : detachCanvasEvent,
		saveCanvasData : saveCanvasData,
		hideDrawMenu : hideDrawMenu,
		onDrawMode : onDrawMode,
		offDrawMode : offDrawMode,
		clearCanvas : clearCanvas,
		setDrawPaletteInfo : setDrawPaletteInfo,
		insertDrawPaletteInfo : insertDrawPaletteInfo,
		convertWebToApp : convertWebToApp,
		convertAppToWeb : convertAppToWeb,
		_init : _init,
		_loadStart : _loadStart,
		_loadComplete : _loadComplete,
		_save : _save,
		_resize : _resize,
		_refresh : _refresh,
		_zoom : _zoom,
		_zoomMove : _zoomMove,
		_zoomClick : _zoomClick
	};

	CONTROL.draw = exportDraw;

	return exportDraw;
});
