
define(['jquery', 'log'], function ($, log) {
	'use strict';

	log("\n @ import indexList.js ... \n");

	var loadMyContents = function (_getListType) {
		log("@ loadMyContents...");
		var createItemList = function (_listType) {
			var localStorageDatas = JSON.parse(CONTROL.save_target(_listType)),
				listResult = document.createElement('ul'), pageCtlNum,
				listResultLi, thumbNailURL, currentPage, emptyListText, targetElement, whiteClass, grayClass, subInfoText = "",
				convertDateFormat = function (_date) {
					var year = _date.substring(0, 4),
						month = _date.substring(4, 6),
						day = _date.substring(6, 8),
						hour = _date.substring(8, 10),
						minute = _date.substring(10, 12),
						second = _date.substring(12, 14);

					return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second;
				};

			switch (_listType) {
				case "bookmark":
					emptyListText = ViewerManager.Local.indexListEmptyBookmark;
					targetElement = "tab0";
					whiteClass = "thumbnailBgWhite";
					grayClass = "thumbnailBgGray";
				break;
				case "memo":
					emptyListText = ViewerManager.Local.indexListEmptyMemo;
					targetElement = "tab1";
					whiteClass = "row2BgWhite";
					grayClass = "row2BgGray";
				break;
				case "draw":
					emptyListText = ViewerManager.Local.indexListEmptyDraw;
					targetElement = "tab2";
					whiteClass = "thumbnailBgWhite";
					grayClass = "thumbnailBgGray";
				break;
				case "link":
					emptyListText = ViewerManager.Local.indexListEmptyLink;
					targetElement = "tab3";
					whiteClass = "row2BgWhite";
					grayClass = "row2BgGray";
				break;
			}

			if (localStorageDatas !== null && localStorageDatas[_listType].length > 0) {
				for (var i = 0; i < localStorageDatas[_listType].length; i++) {
					// 책 이름에 따라서 보여지도록 수정
					if (localStorageDatas[_listType][i].bookId != ViewerManager.GetData.EPUB.ID) {continue;}
					if (localStorageDatas[_listType][i].show == "false") {continue;}

					listResultLi = document.createElement('li');

					currentPage = localStorageDatas[_listType][i].pageNo == undefined ? localStorageDatas[_listType][i].pageNum : localStorageDatas[_listType][i].pageNo;
					currentPage = localStorageDatas[_listType][i].pageno == undefined ? currentPage : localStorageDatas[_listType][i].pageno;
					if (currentPage > 99) {
						currentPage = "" + currentPage;
					} else if (currentPage > 9) {
						currentPage = "0" + currentPage;
					} else {
						currentPage = "00" + currentPage;
					}

					subInfoText = localStorageDatas[_listType][i].pageNo == undefined ? localStorageDatas[_listType][i].pageNum + ' p' : localStorageDatas[_listType][i].pageNo + ' p';
					subInfoText =  ViewerManager.transRealToVirtualPageIndex(parseInt(localStorageDatas[_listType][i].pageno == undefined ? subInfoText : localStorageDatas[_listType][i].pageno)) + ' p';
					if (ViewerManager.pageMODE == "DOUBLE" && ViewerManager.isOddCheck(parseInt(currentPage))) pageCtlNum = parseInt(currentPage) + 1;
					else pageCtlNum = parseInt(currentPage);

					var movePage = localStorageDatas[_listType][i].pageNo == undefined ? localStorageDatas[_listType][i].pageNum : localStorageDatas[_listType][i].pageNo;
					movePage = localStorageDatas[_listType][i].pageno == undefined ? currentPage : localStorageDatas[_listType][i].pageno;
					if (_listType == 'memo') {
						listResultLi.innerHTML = "<div style='float: left; margin-left: 20px; width: 77%; text-align: left; overflow: hidden;' onclick='ViewerManager.pageLoading(" +
						pageCtlNum + " , " + ViewerManager.PAGE_TOTAL_NUMBER + ")'><p class='memoTitle'>" +
						localStorageDatas[_listType][i].title + "</p><div class='memoContentCut'>" +
						localStorageDatas[_listType][i].memo + "</div><div class='date'>" +
						convertDateFormat(localStorageDatas[_listType][i].lastdate) +
						"</div></div><div class='pageNumber'>" + subInfoText + "</div><div class='deleteContent' onclick='CONTROL.deleteContents(\"" + _listType + "\"," + movePage + "," + localStorageDatas[_listType][i].lastdate + ")'></div>";
					} else if (_listType == 'link') {
						listResultLi.innerHTML = "<div style='float: left; margin-left: 20px; width: 77%; text-align: left; overflow: hidden;' onclick='ViewerManager.pageLoading(" +
						pageCtlNum + " , " + ViewerManager.PAGE_TOTAL_NUMBER + ")'>" + localStorageDatas[_listType][i].linkname.getStringLength(30) + "<br><br>" +
						localStorageDatas[_listType][i].linkurl.getStringLength(165) + "<br><br><div class='date'>" + convertDateFormat(localStorageDatas[_listType][i].lastdate) +
						"</div></div><div class='pageNumber'>" + subInfoText + "</div><div class='deleteContent' onclick='CONTROL.deleteContents(\"" + _listType + "\"," + movePage + "," + localStorageDatas[_listType][i].lastdate + ")'></div>";
					} else {
						if (ViewerManager.thumbnails.length > 0) {
							thumbNailURL = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] + "/" +
							ViewerManager.thumbnails[parseInt(currentPage) - 1];
						}
						else {
							thumbNailURL = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] +
							"/content/images/page" + currentPage + "/thumbnail.jpg";
						}

						if (_listType == 'bookmark') {
							listResultLi.innerHTML = "<div onclick='ViewerManager.pageLoading(" + pageCtlNum + " , " + ViewerManager.PAGE_TOTAL_NUMBER +
							")'><div style='float:left; margin-left: 20px; width:77%; text-align:left; overflow: hidden;'>" +
							"<img class='thumbnailIcon' src='images/common/myContents_bookmark_thumbnailIcon.png'>" +
							"<img class='thumImage' src='" + thumbNailURL + "' height='110' title='" + parseInt(currentPage) + " " + ViewerManager.Local.indexListPage +
							"'></div><div class='date img'>" + convertDateFormat(localStorageDatas[_listType][i].lastdate) +
							"</div><div class='pageNumber'>" + subInfoText + "</div></div><div class='deleteContent' onclick='CONTROL.deleteContents(\"" + _listType + "\"," + movePage + "," + localStorageDatas[_listType][i].lastdate + ")'></div>";
						} else {
							if (parseInt(currentPage) == 0 || parseInt(currentPage) == parseInt(ViewerManager.PAGE_TOTAL_NUMBER) + 1) {
								listResultLi.innerHTML = "<div onclick='ViewerManager.pageLoading(" + pageCtlNum + " , " + ViewerManager.PAGE_TOTAL_NUMBER +
								")'><div style='float:left; margin-left: 20px; width:77%; text-align:left; overflow: hidden;'>" +
								(_listType == "bookmark" ? "<img class='thumbnailIcon' src='images/common/myContents_bookmark_thumbnailIcon.png'>" : "") +
								"</div><div class='date img'>" + convertDateFormat(localStorageDatas[_listType][i].lastdate) +
								"</div><div class='pageNumber'>" + subInfoText + "</div></div>";
							} else {
								listResultLi.innerHTML = "<div onclick='ViewerManager.pageLoading(" + pageCtlNum + " , " + ViewerManager.PAGE_TOTAL_NUMBER +
								")'><div style='float:left; margin-left: 20px; width:77%; text-align:left; overflow: hidden;'>" +
								(_listType == "bookmark" ? "<img class='thumbnailIcon' src='images/common/myContents_bookmark_thumbnailIcon.png'>" : "") +
								"<img class='thumImage' src='" + thumbNailURL + "' height='110' title='" + parseInt(currentPage) + " " + ViewerManager.Local.indexListPage +
								"'></div><div class='date img'>" + convertDateFormat(localStorageDatas[_listType][i].lastdate) +
								"</div><div class='pageNumber'>" + subInfoText + "</div></div>";
							}

						}
					}

					var evenNum = i % 2,
						oddNum = i % 2 + 1;

					if (evenNum === 0 && oddNum === 1) {
						listResultLi.className = whiteClass;
					} else {
						listResultLi.className = grayClass;
					}

					listResult.appendChild(listResultLi);

				}
			} else {
				listResultLi = document.createElement('li');
				listResultLi.innerHTML = emptyListText;
				listResultLi.className = whiteClass;
				listResult.appendChild(listResultLi);

			}
			document.getElementById(targetElement).innerHTML = "";
			document.getElementById(targetElement).appendChild(listResult);
		};

		var inside_html;

		if (ViewerManager.VIEWER_DEVICE == "PC") {
			inside_html =
				"<div id='tabsContainer'>" +
					"<table>" +
					    "<tr>" +
					        "<td style='width: 50px; height: " + (ViewerManager.bookContainerHeight - 202) + "px; vertical-align: top; border-right: 1px solid #dadada; background: #e8eaec;'>" +
					            "<ul class='tabs'>" +
					                "<li rel='tab0'><img src='images/common/myContents_bookmark_02.png' alt='책갈피' title='책갈피'></li>" +
					                "<li rel='tab1'><img src='images/common/myContents_memo_01.png' alt='메모' title='메모'></li>" +
					                "<li rel='tab2'><img src='images/common/myContents_draw_01.png' alt='판서' title='판서'></li>" +
					                "<li style ='display:none' rel='tab3'><img src='images/common/myContents_link_01.png' alt='Link' title='Link'></li>" +
					            "</ul>" +
					        "</td>" +
					        "<td style='vertical-align: top;'>" +
					            "<div id='tabsContainerContents'>" +
					                "<div id='tab0' class='tabContent'></div>" +
					                "<div id='tab1' class='tabContent'></div>" +
					                "<div id='tab2' class='tabContent'></div>" +
					                "<div style ='display:none' id='tab3' class='tabContent'></div>" +
					            "</div>" +
					        "</td>" +
					    "</tr>" +
					"</table>" +
				"</div>";
			$("#indexContents").empty().append(inside_html);
		}
		else
		{
			inside_html =
				"<div id='tabsContainer'>" +
				    "<table>" +
				        "<tr>" +
				            "<td style='width: 50px; height: " + (ViewerManager.bookContainerHeight - 202) + "px; vertical-align: top; border-right: 1px solid #dadada; background: #e8eaec;'>" +
				                "<ul class='tabs'>" +
				                    "<li rel='tab0'><img src='images/common/myContents_bookmark_02.png' alt='BookMark' title='BookMark'></li>" +
					                "<li rel='tab1'><img src='images/common/myContents_memo_01.png' alt='Memo' title='Memo'></li>" +
					                "<li rel='tab2'><img src='images/common/myContents_draw_01.png' alt='Draw' title='Draw'></li>" +
					                "<li style ='display:none' rel='tab3'><img src='images/common/myContents_link_01.png' alt='Link' title='Link'></li>" +
				                "</ul>" +
				            "</td>" +
				            "<td style='vertical-align: top;'>" +
				                "<div id='tabsContainerContents'>" +
				                    "<div id='tab0' class='tabContent'></div>" +
				                    "<div id='tab1' class='tabContent'></div>" +
				                    "<div id='tab2' class='tabContent'></div>" +
				                    "<div style ='display:none' id='tab3' class='tabContent'></div>" +
				                "</div>" +
				            "</td>" +
				        "</tr>" +
				    "</table>" +
				"</div>";
			$("#indexContents").empty().append(inside_html);
		}

		//$("#indexContents").empty().append("<div id='tabsContainer'><table><tr><td style='width: 50px; height: " + (ViewerManager.bookContainerHeight - 202) + "px; vertical-align: top; border-right: 1px solid #dadada; background: #e8eaec;'><ul class='tabs'><li rel='tab0'><img src='images/common/myContents_bookmark_01.png' alt='BookMark'></li><li rel='tab1'><img src='images/common/myContents_memo_01.png' alt='Memo'></li><li rel='tab2'><img src='images/common/myContents_draw_01.png' alt='Draw'></li><li rel='tab3'><img src='images/common/myContents_link_01.png' alt='Link'></li></ul></td><td style='vertical-align: top;'><div id='tabsContainerContents'><div id='tab0' class='tabContent'></div><div id='tab1' class='tabContent'></div><div id='tab2' class='tabContent'></div><div id='tab3' class='tabContent'>123</div></div></td></tr></table></div>");

		// bookmark list
		createItemList("bookmark");

		// draw list
		createItemList("draw");

		// memo list
		createItemList("memo");

		// link list
		createItemList("link");

		// 시작할 때, 선택 영역이 열리도록
		var openTarget;
		if (_getListType) {
			switch (_getListType) {
				case 'bookmark': {
					openTarget = $("#tab0");
					break;
				}
				case 'memo': {
					openTarget = $("#tab1");
					break;
				}
				case 'link': {
					openTarget = $("#tab2");
					break;
				}
			}
		} else {
			openTarget = $("#tab0");
		}
		openTarget.fadeIn();

		$("#tabsContainer ul.tabs li").click(function () {
			for (var i = 0; i < $("#tabsContainer ul.tabs").find("IMG").length; i++) {
				var tempURL = $("#tabsContainer ul.tabs").find("IMG")[i];
				tempURL.setAttribute("src", tempURL.getAttribute("src").replace(/02/gi, '01'));
			}
			$(this).find('IMG').attr("src", $(this).find('IMG').attr("src").replace(/01/gi, '02'));
			$(".tabContent").hide();
			var activeTab = $(this).attr("rel");
			$("#" + activeTab).fadeIn();
		});
	},

	genUUID = function () {
		var d = new Date().getTime();
        	var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
           	var r = (d + Math.random() * 16) % 16 | 0;
           	d = Math.floor(d / 16);
           	return (c == 'x' ? r : (r & 0x7 | 0x8)).toString(16);
        	});
        return uuid;
	},
	ref_parent1_uuid , ref_parent2_uuid, ref_elim,

	loadBookIndex = function () {
		log("@ ...");
		$("#indexContents").empty().append("<div id='indexListContents'></div>");
		// seting content index
		var i, contentIndex = document.createElement('ol'),
		contentIndexList = function () {
			var ePubToc = ViewerManager.ePub.toc.querySelector("ol");

			if (ePubToc !== null) {
				log("@ saved Index list");
				for (var i = 0; i < ePubToc.childNodes.length; i++) {
					switch (ePubToc.childNodes[i].nodeName) {
						case "li":
							if (ePubToc.childNodes[i].childNodes[0].nodeName === "#text") {
								appendIndex("DEPTH1", ePubToc.childNodes[i].childNodes[1].getAttribute("href"), ePubToc.childNodes[i].childNodes[1].innerText);
							} else {
								appendIndex("DEPTH1", ePubToc.childNodes[i].childNodes[0].getAttribute("href"), ePubToc.childNodes[i].childNodes[0].innerText);
							}
							break;
						case "ol":
							for (var l = 0; l < ePubToc.childNodes[i].childNodes.length; l++) {
								if (ePubToc.childNodes[i].childNodes[l].nodeName === "li") {
									appendIndex("DEPTH2", ePubToc.childNodes[i].childNodes[l].childNodes[0].getAttribute("href"), ePubToc.childNodes[i].childNodes[l].childNodes[0].innerText);
								}

								if (ePubToc.childNodes[i].childNodes[l].nodeName === "ol") {
									for (var z = 0; z < ePubToc.childNodes[i].childNodes[l].childNodes.length; z++) {
										if (ePubToc.childNodes[i].childNodes[l].childNodes[z].nodeName === "li") {

											log(ePubToc.childNodes[i].childNodes[l].childNodes[z].childNodes[0].innerText);
											appendIndex("DEPTH3", ePubToc.childNodes[i].childNodes[l].childNodes[z].childNodes[0].getAttribute("href"), ePubToc.childNodes[i].childNodes[l].childNodes[z].childNodes[0].innerText);
										}
									}
								}
							}
							break;
					}
				}

				if (ePubToc.childNodes.length <= 1) {
					log("@ nothing index list only ol tag");
				}
			} else {
				log("@ nothing index list");

			}
			document.getElementById('indexListContents').appendChild(contentIndex);

		},

		appendIndex = function (depth, _curPageNum, _text) {
			console.log("UUID : " + genUUID());
			var cntentIndexLi = document.createElement('li'), pageCtlNum, depthPadding,
			curPageNum = _curPageNum.split("/"),
			curPageNum = parseInt(curPageNum[curPageNum.length - 1].replace(/\D/gi, ''));

			switch (depth) {
				case "DEPTH1":
					depthPadding = 5;
					cntentIndexLi.className = 'listBgGray';
					//var parentIdAttr = document.createAttribute('parentId');
					//parentIdAttr.nodeValue(0);
					//cntentIndexLi.setAttributeNode(parentIdAttr);

					var uuid = genUUID();
					cntentIndexLi.setAttribute('parentId','');
					cntentIndexLi.setAttribute('level', 'level_1');
					cntentIndexLi.setAttribute('uuid', uuid);
					ref_parent1_uuid= uuid;

					break;

				case "DEPTH2":
					depthPadding = 5;
					_text = "- " + _text;
					cntentIndexLi.className = 'listBgWhite';
					var uuid = genUUID();
					cntentIndexLi.setAttribute('parentId', ref_parent1_uuid);
					cntentIndexLi.setAttribute('level', 'level_2');
					cntentIndexLi.setAttribute('uuid', uuid);
					ref_parent2_uuid = uuid;
					cntentIndexLi.style.display = 'none';
					break;

				case "DEPTH3":
					depthPadding = 5;
					_text = "&nbsp;&nbsp;- " + _text;
					cntentIndexLi.className = 'listBgWhite';
					var uuid = genUUID();
					cntentIndexLi.setAttribute('parentId', ref_parent2_uuid);
					cntentIndexLi.setAttribute('level', 'level_3');
					cntentIndexLi.setAttribute('uuid', uuid);
					cntentIndexLi.style.display = 'none';
					break;
			}

			if (ViewerManager.pageMODE === "DOUBLE" && ViewerManager.isOddCheck(curPageNum)) pageCtlNum = parseInt(curPageNum) + 1;
			else pageCtlNum = parseInt(curPageNum);

			var pageStr = "p";
			if (isNaN(curPageNum)) {
				curPageNum = "";
				pageStr = "";
			}
			var level = cntentIndexLi.getAttribute('level');
			var level_margin_left = 0;
			switch(level) {
				case 'level_1':
					level_margin_left = ( 0 * 15 )  + 'px';
					break;
				case 'level_2':
					level_margin_left =  ( 2 * 15 )  + 'px';
					break;
				case 'level_3':
					level_margin_left = ( 3 * 15)  + 'px';
					break;
			}
			cntentIndexLi.innerHTML = "<div style ='position : relative' ><div class='tocText " + depth + "'><i style ='margin-right : 4px; margin-left:" + level_margin_left + "'  class ='btn-index-tree fa fa-lg fa-caret-right'></i>" + (_text ? _text.getStringLength(35) : curPageNum + " " + ViewerManager.Local.indexListPage) + "</div><div class='tocPageNumber'>" + curPageNum +  " " + pageStr+ '</div></div>';
			if (curPageNum != ''){
				cntentIndexLi.addEventListener("click", function () {
					ViewerManager.pageLoading(pageCtlNum, ViewerManager.PAGE_TOTAL_NUMBER);
					cntentIndexLi.className = 'listBgActive';
					$("#indexListTemplet").fadeOut("fast");
				}, false);
			}
			contentIndex.appendChild(cntentIndexLi);
		};
		contentIndexList();

		$('li[level=level_3]'). find('.btn-index-tree').css('visibility' , 'hidden');

		// 목차 인텍스 트리 동작 구성
		$('li[level=level_1]').each(function(){
			var uuid = $(this).attr('uuid');
			if ($('li[parentId='+uuid+ ']').length < 1) {
				$(this).find('.btn-index-tree').css('visibility' , 'hidden')
			}else {
				$(this).addClass('index-tree-collapse');  //초기 닫은 상태로 보여줌
				$(this).find('.btn-index-tree').show();
				$(this).find('.btn-index-tree').click(function(event){
					event.stopPropagation();
					//close statuc --> expand tree
					var $index_btn_tree = $(this);
					if ($index_btn_tree.hasClass('fa-caret-right')){
						$('li[parentId='+uuid+ ']').slideDown('fast', function(){
							$index_btn_tree.removeClass('fa-caret-right').addClass('fa-caret-up');
						});
					}
					//open status --> collapse tree
					else {

						$index_btn_tree.removeClass('fa-caret-up').addClass('fa-caret-right');
						$('li[parentId='+uuid+ ']').slideUp('fast', function(){
							$(this).find('.btn-index-tree').removeClass('fa-caret-up').removeClass('fa-caret-right').addClass('fa-caret-right');
							$index_btn_tree.removeClass('fa-caret-up').addClass('fa-caret-right');
						});

						$('li[parentId='+uuid+ ']').each(function(){
							var $parentElim = $(this);
							var parentId= $(this).attr('uuid');
							$('li[parentId='+parentId+ ']').slideUp('fast', function(){
								$(this).slideUp('fast');
							});
						});
					}
				});
			}
		});

		$('li[level=level_2]').each(function(){
			var uuid = $(this).attr('uuid');
			if ($('li[parentId='+uuid+ ']').length < 1) {
				$(this).find('.btn-index-tree').css('visibility' , 'hidden')
			}else {
				$(this).addClass('index-tree-collapse');  //초기 닫은 상태로 보여줌
				$(this).find('.btn-index-tree').show();
				$(this).find('.btn-index-tree').click(function(event){
					event.stopPropagation();
					//close statuc --> expand tree
					var $index_btn_tree = $(this);
					if ($index_btn_tree.hasClass('fa-caret-right')){
						$('li[parentId='+uuid+ ']').slideDown('fast', function(){
							$index_btn_tree.removeClass('fa-caret-right').addClass('fa-caret-up');
						});
					}
					//open status --> collapse tree
					else {
						$index_btn_tree.removeClass('fa-caret-up').addClass('fa-caret-right');
						$('li[parentId='+uuid+ ']').slideUp('fast', function(){
							$index_btn_tree.removeClass('fa-caret-up').addClass('fa-caret-right');
						});
					}
				});
			}
		});
	},

	loadBookContents = function () {
		log("@ loadBookContents...");
		$("#indexContents").empty().append("<div id='indexListContents'></div>");

		if (ViewerManager.bookcontents.list != null && ViewerManager.bookcontents.list != undefined) {
			var _list, _list_length, listDiv;
			_list = ViewerManager.bookcontents.list
			_list_length = _list.length == undefined ? 1 : _list.length;

			if (_list_length > 0) {
				var i, listUL, listLi, downloadAll = [];
				listDiv = document.getElementById('indexListContents');
				listUL = document.createElement('ul');

				if (_list_length == 1) {
					listLi = document.createElement('li');
					var this_div = document.createElement('div');
					this_div.setAttribute('class', 'bookcontent_div');

					var div_1 = document.createElement('div');
					div_1.setAttribute('class', 'div_1');

					var p_1, p_2, input_1;
					p_1 = document.createElement('p');
					p_1.setAttribute('class', 'filename');
					p_1.setAttribute('data', _list.link_filename);
					p_1.textContent = _list.filename;

					p_2 = document.createElement('p');
					p_2.setAttribute('class', 'filesize');
					p_2.textContent = _list.filesize;

					input_1 = document.createElement('input');
					input_1.setAttribute('class', 'filecheck');
					input_1.setAttribute('type', 'checkbox');

					div_1.appendChild(p_1);
					div_1.appendChild(p_2);
					div_1.appendChild(input_1);

					var div_2 = document.createElement('div');
					div_2.setAttribute('class', 'div_2');

					var p_3 = document.createElement('p');
					p_3.setAttribute('class', 'filememo');
					//p_3.setAttribute('type', 'text');
					//p_3.setAttribute('readonly', 'readonly');
					p_3.textContent = _list.filememo;

					div_2.appendChild(p_3);

					this_div.appendChild(div_1);
					this_div.appendChild(div_2);
					listLi.appendChild(this_div);
					listUL.appendChild(listLi);

					downloadAll[0] = _list.filekey;
				} else if (_list_length > 1) {
					for (i = 0; i < _list_length; i++) {
						listLi = document.createElement('li');
						var this_div = document.createElement('div');
						this_div.setAttribute('class', 'bookcontent_div');

						var div_1 = document.createElement('div');
						div_1.setAttribute('class', 'div_1');

						var p_1, p_2, input_1;
						p_1 = document.createElement('p');
						p_1.setAttribute('class', 'filename');
						p_1.setAttribute('data', _list[i].link_filename);
						p_1.textContent = _list[i].filename;

						p_2 = document.createElement('p');
						p_2.setAttribute('class', 'filesize');
						p_2.textContent = _list[i].filesize;

						input_1 = document.createElement('input');
						input_1.setAttribute('class', 'filecheck');
						input_1.setAttribute('type', 'checkbox');

						div_1.appendChild(p_1);
						div_1.appendChild(p_2);
						div_1.appendChild(input_1);

						var div_2 = document.createElement('div');
						div_2.setAttribute('class', 'div_2');

						var p_3 = document.createElement('p');
						p_3.setAttribute('class', 'filememo');
						//p_3.setAttribute('type', 'text');
						//p_3.setAttribute('readonly', 'readonly');
						p_3.textContent = _list[i].filememo;

						div_2.appendChild(p_3);

						this_div.appendChild(div_1);
						this_div.appendChild(div_2);
						listLi.appendChild(this_div);
						listUL.appendChild(listLi);

						downloadAll.push(_list[i].filekey);
					}
				}

				listDiv.appendChild(listUL);

				var div_3 = document.createElement('div');
				div_3.setAttribute('class', 'div_3');

				var input_2 = document.createElement('input');
				input_2.setAttribute('id', 'bookcontens_select_all');
				input_2.setAttribute('readonly', 'readonly');
				input_2.setAttribute('value', '전체선택');
				var input_3 = document.createElement('input');
				input_3.setAttribute('id', 'bookcontens_download');
				input_3.setAttribute('readonly', 'readonly');
				input_3.setAttribute('value', '다운로드');

				div_3.appendChild(input_2);
				div_3.appendChild(input_3);
				listDiv.appendChild(div_3);

				$('.filename').on('click', open_file);
				/*
				function open_file() {
					window.open('/ftp/titanbooks/_content/' + $(this).attr('data'));
				}
				*/
			}

			$('.filecheck').on('click', function () {
				if (this.checked) {
					downloadList('add', $(this.parentNode.parentNode.parentNode).index());
				} else {
					downloadList('del', $(this.parentNode.parentNode.parentNode).index());
				}
			});

			$('#bookcontens_select_all').on('click', function () {
				selectAll();
			});

			$('#bookcontens_download').on('click', function () {
				console.log('download_arr', download_arr);
				if (download_arr.length > 0) {
					//bookID : ViewerManager.GetData.EPUB.ID,
					//userID : ViewerManager.userInfo.loginKey,
					var postdata = {
						download_files : download_arr
					};

					/*var myform = document.forms[0];
					myform.insertBefore(createHidden('download_files', download_arr));

					var myWin = window.open(API.bookContentsDownload(),'download_win', 'left=0, top=0, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, width=100, height=100');
					myform.method = 'get';
					myform.target = 'download_win';
					myform.submit();

					function createHidden(n,v) {
						var o = document.createElement('input');
						o.type = 'hidden';
						o.name = n;
						o.value = v;
						return o;
					}*/

					//http://titanbooks.co.kr/Sviewer/test.php
					//API.bookContentsDownload()
					//var download_win = window.open(API.bookContentsDownload(), 'download_win', "left=0, top=0, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, width=100, height=100");
					console.log('download', download_arr);
					var download_win = window.open(API.bookContentsDownload() + "?download_files=" + download_arr, 'download_win', "left=0, top=0, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, width=200, height=200");
					/*$.ajax({
						async : 'false',
						url : API.bookContentsDownload(),
						type : 'GET',
						data : postdata,
						error : function (jqXHR, status, error) {

						},
						success : function (data) {
							//console.log(data);
						}
					});*/
				}
			});

			var selected = false, download_arr = [];
			/*
			function selectAll() {
				var j, _filecheck = $('.filecheck');
				if (selected) {
					$('#bookcontens_select_all').attr('value', '전체선택');
					_filecheck.prop('checked', false);
					download_arr = [];
				} else {
					$('#bookcontens_select_all').attr('value', '전체해제');
					_filecheck.prop('checked', true);
					downloadList('all');
				}
				selected = !selected;
			}

			function downloadList(stat, index) {
				//console.log(stat, index);
				if (stat == 'all') {
					// 전체 추가
					download_arr = downloadAll;
				} else if (stat == 'add') {
					// 개별 추가
					if (ViewerManager.bookcontents.list[index] == undefined) {
						download_arr.push(ViewerManager.bookcontents.list.filekey);
					} else {
						download_arr.push(ViewerManager.bookcontents.list[index].filekey);
					}
				} else {
					// 삭제
					for (var k = 0; k < download_arr.length; k++) {
						if (download_arr[k] == ViewerManager.bookcontents.list[index].filekey) {
							download_arr.splice(k, 1);
							break;
						}
					}
				}
				//console.log('downloadList', download_arr);
			}
			*/
		}
	}

	var exportIndexList = {
		loadMyContents : loadMyContents,
		loadBookIndex : loadBookIndex,
		loadBookContents : loadBookContents
	};
	return exportIndexList;
});
