define(['jquery', 'log', 'browser'], function ($, log, browser) {
	'use strict';

	log("\n @ import link.js ... \n");

	var prevLink, prevIcon, prevLinkBar, showLink, showLinkIcon, showLinkBar;
	var	linkDatas = JSON.parse(CONTROL.save_target("link"));

	var dragCnt = 0,
	draggable = function (element) {
		this.element = element;
		this.parentElement = window;
		this.createDrag();	
	};

	draggable.prototype.createDrag = function () {
		var touch = 'ontouchend' in document;
		var startEvent = (touch) ? 'touchstart' : 'mousedown';
        var moveEvent = (touch) ? 'touchmove' : 'mousemove';
        var endEvent = (touch) ? 'touchend' : 'mouseup';

		var posTarget = document.getElementById('components');
		var posLeft, posTop, posMaxLeft, posMaxTop;

		var draggable = this,
		drag = function (e) {
			var eventMaster;
			e.preventDefault();

			var dragX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientX : e.clientX;
			var dragY = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientY : e.clientY;

			draggable.element.style.position = 'absolute';
			draggable.newY = (dragY) - draggable.offY;
			draggable.newX = (dragX) - draggable.offX;
			// x position min-max
			if (draggable.newX < 0) {draggable.newX = 0;}
			if (draggable.newX > posMaxLeft) {draggable.newX = posMaxLeft;}
			// y position min-max
			if (draggable.newY < 0) {draggable.newY = 0;}
			if (draggable.newY > posMaxTop) {draggable.newY = posMaxTop;}

			draggable.element.style.left = draggable.newX + 'px';
			draggable.element.style.top = draggable.newY + 'px';

			dragCnt++;
		},
		startDrag = function (e) {
			var startX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientX : e.clientX;
			var startY = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientY : e.clientY;

			posLeft = Number(posTarget.style.left.replace('px',''));
			posTop = Number(posTarget.style.top.replace('px',''));
			posMaxLeft = window.innerWidth - (posLeft * 2) - 35;
			posMaxTop = window.innerHeight - (posTop * 2) - 48;

			draggable.offY = (startY) - parseInt(draggable.element.offsetTop);
			draggable.offX = (startX) - parseInt(draggable.element.offsetLeft);
			
			$(draggable.parentElement).bind(endEvent, function () {
				endDrag();
				dragCnt = 0;
			});
			$(draggable.parentElement).bind(moveEvent, drag);
		},
		endDrag = function () {
			$(draggable.parentElement).unbind(moveEvent, drag);
			
			if (dragCnt > 5) {
				if (this != undefined) {
					if ($(draggable.element).attr('orgX') != undefined && $(draggable.element).attr('orgX').length > 0) {
						$(draggable.element).attr('orgX', '');
					}
					if ($(draggable.element).attr('orgY') != undefined && $(draggable.element).attr('orgY').length > 0) {
						$(draggable.element).attr('orgY', '');
					}
					saveLink(draggable.element);
				}
			}
		};

		$(draggable.element).bind(startEvent, startDrag);
		$(draggable.element).bind(endEvent, endDrag);
	}

 	var Link = function (_page, _key, _linkname, _linkurl, _left, _top, _stat) {
		log("@ create Link object...");

		var element = document.createElement('div'),
			linkTitle = document.createElement('input'),
			linkURL = document.createElement('input'),
			linkButton = document.createElement('div'),
			closeButton = document.createElement('div'),
			deleteButton = document.createElement('div'),
			linkBar = document.createElement('div'),
			linkIcon = document.createElement('div'),
			linkBarLabel,
			newLink = this,
			linkPage = (_page) ? _page : ViewerManager.pageMODE == "DOUBLE" ? ViewerManager.PAGE_CURRENT_NUMBER - 1 : ViewerManager.PAGE_CURRENT_NUMBER,
			linkTitleText = (_linkname) ? _linkname : ViewerManager.Local.linkTitle,
			linkContentsText = (_linkurl) ? _linkurl : ViewerManager.Local.linkContents,
			linkTitleSync = function () {
				if (linkTitle.value.indexOf(ViewerManager.Local.linkTitle) === -1) {
					linkBarLabel = linkTitle.value;
				} else {
					linkBarLabel = linkURL.value;
				}
				linkBar.innerHTML = "<p class='linkText'>" + linkBarLabel.getStringLength(20) + "... </p>";
				linkBar.appendChild(linkButton);
			};

		showLink = newLink, showLinkIcon = linkIcon, showLinkBar = linkBar;
		newLink.element = element;
		newLink.element.className = 'link_content';

		if (_key) {
			newLink.element.setAttribute('id', _key);
			$(newLink.element).css('visibility', 'hidden');
			$(linkIcon).css('visibility', 'visible');
		} else {
			// newLink id setting
			newLink.element.setAttribute('id', (new Date()).yyyymmddhh24miss());
		}

		newLink.element.setAttribute('page', linkPage);

		linkTitle.className = 'linkTitle';
		linkTitle.value = linkTitleText;

		linkURL.className = 'linkURL';
		linkURL.value = linkContentsText;

		linkBar.className = 'linkBar';
		linkTitleSync();
	
		linkButton.className = 'linkButton';
		linkButton.setAttribute('title', '이동');
		
		closeButton.className = 'link_closeButton';
		closeButton.setAttribute('title', '링크 닫기');
		deleteButton.className = 'link_deleteButton';
		deleteButton.setAttribute('title', '링크 삭제');
		linkIcon.className = 'linkIcon';
		linkIcon.setAttribute('title', newLink.element.getAttribute("id"));

		var posTarget = document.getElementById('components');
		var posMaxLeft, posMaxTop, posLeft, posTop;

		closeButton.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			linkTitleSync();
			// 뎁스 초기화
			$(newLink.element).css('z-index', $(newLink.element).index());

			$(newLink.element).css('visibility', 'hidden');
			$(linkBar).css('visibility', 'visible');
			$(linkIcon).css('visibility', 'visible');
			$(linkBar).css('visibility', 'hidden');

			// 변경된 좌표를 다시 조정해줘야함
			if ($(newLink.element).attr('orgX') != undefined && $(newLink.element).attr('orgX').length > 0) {
				$(newLink.element).css('left', $(newLink.element).attr('orgX') + 'px');
				$(newLink.element).attr('orgX', '');
			}
			if ($(newLink.element).attr('orgY') != undefined && $(newLink.element).attr('orgY').length > 0) {
				$(newLink.element).css('top', $(newLink.element).attr('orgY') + 'px');
				$(newLink.element).attr('orgY', '');
			}
			// 닫기 누를 때 저장
			linkValidation(this.value);
			saveLink(newLink.element);
			setTimeout(function () {
				window.focus();
			}, 300);
		}, true);

		deleteButton.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			$("#linkDeleteTemplet").css('left', (window.innerWidth / 2 - 150) + 'px');
			$("#linkDeleteTemplet").fadeIn("fast", function () {
				$(this).find("#linkDeletePopupYesBtn").on("click", function () {
					$("#linkDeleteTemplet").fadeOut("fast");
					$(newLink.element).hide("slow", function () {
						deleteLink(newLink.element);
						//newLink.element.remove();
						//document.getElementById('components').removeChild(newLink.element);
					});
				});
				$(this).find("#linkDeletePopupNoBtn").on("click", function () {
					$("#linkDeleteTemplet").fadeOut("fast");
				});
			});	
		}, true);

		linkBar.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			if (dragCnt < 3) {
				CONTROL.closeUtils('link');
				if (prevLink != null && prevLink != $(newLink.element) && prevIcon != null) {
					$(prevLink).css('z-index', $(prevLink).index());
					$(prevLink).css('visibility', 'hidden');
					$(prevIcon).css('visibility', 'visible');
					$(prevLinkBar).css('visibility', 'hidden');
					// 변경된 좌표를 다시 조정해줘야함
					if ($(prevLink).attr('orgX') != undefined && $(prevLink).attr('orgX').length > 0) {
						$(prevLink).css('left', $(prevLink).attr('orgX') + 'px');
						$(prevLink).attr('orgX', '');
					}
					if ($(prevLink).attr('orgY') != undefined && $(prevLink).attr('orgY').length > 0) {
						$(prevLink).css('top', $(prevLink).attr('orgY') + 'px');
						$(prevLink).attr('orgY', '');
					}
				}

				prevLink = $(newLink.element);
				prevIcon = $(linkIcon);

				showLink = newLink;

				// 여기서 좌표계산이 필요함
				posLeft = Number(posTarget.style.left.replace('px',''));
				posTop = Number(posTarget.style.top.replace('px',''));
				posMaxLeft = window.innerWidth - (posLeft * 2) - 307;
				posMaxTop = window.innerHeight - (posTop * 2) - 157;

				var linkLeft = Number($(newLink.element).css('left').replace('px',''));
				var linkTop = Number($(newLink.element).css('top').replace('px',''));

				//if ($(linkBar).css('visibility') == 'visible') {
				$(newLink.element).css('visibility', 'visible');
				$(linkBar).css('visibility', 'hidden');
				$(linkIcon).css('visibility', 'hidden');

				if (browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
					// 창크기에 따른 이동
					posMaxLeft = (window.innerWidth / 2) - (posLeft * 2) - 151;
					posMaxTop = 60;

					$(newLink.element).css('left', posMaxLeft + 'px');
					$(newLink.element).attr('orgX', linkLeft);
					$(newLink.element).css('top', posMaxTop + 'px');
					$(newLink.element).attr('orgY', linkTop);
				} else {
					if (linkLeft > posMaxLeft) {
						$(newLink.element).css('left', posMaxLeft + 'px');
						$(newLink.element).attr('orgX', linkLeft);
					}

					if (linkTop > posMaxTop) {
						$(newLink.element).css('top', posMaxTop + 'px');
						$(newLink.element).attr('orgY', linkTop);
					}
				}
			}
		}, true);

		linkButton.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			if (linkURL.value === "" || linkURL.value === ViewerManager.Local.linkContents) {
				$("#currentModeNotice").text(ViewerManager.Local.linkUrlError).fadeIn(300, function () {
					var noticeTimer = setTimeout(function () {
						$("#currentModeNotice").fadeOut(500);
						clearTimeout(this);	
					}, 1000);
				});
			} else {
				window.open(linkURL.value);
			}
		}, true);

		linkIcon.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			log("@ dragCnt : " + dragCnt);
			if (dragCnt < 3) {
				// 뎁스 올려주기
				var maxIndex = $(newLink.element).parent().children().length;
				$(newLink.element).css('z-index', maxIndex + 1);
				showLink = newLink;

				if ($(linkBar).css('visibility') == 'visible') {
					// 자신은 원래대로 돌아갈 것
					//if (prevLink != null && prevLinkBar != null) {
						// 변경된 좌표를 다시 조정해줘야함
						if ($(newLink.element).attr('orgX') != undefined && $(newLink.element).attr('orgX').length > 0) {
							$(newLink.element).css('left', $(newLink.element).attr('orgX') + 'px');
							$(newLink.element).attr('orgX', '');
						}
						if ($(newLink.element).attr('orgY') != undefined && $(newLink.element).attr('orgY').length > 0) {
							$(newLink.element).css('top', $(newLink.element).attr('orgY') + 'px');
							$(newLink.element).attr('orgY', '');
						}
						prevLink = null;
						prevLinkBar = null;
					//}
					$(linkBar).css('visibility', 'hidden');
				} else {
					// 이전 타겟이 있는 경우에 닫아줌
					if (prevLink != null && prevLinkBar != null) {
						// 변경된 좌표를 다시 조정해줘야함
						if ($(prevLink).attr('orgX') != undefined && $(prevLink).attr('orgX').length > 0) {
							$(prevLink).css('left', $(prevLink).attr('orgX') + 'px');
							$(prevLink).attr('orgX', '');
						}
						if ($(prevLink).attr('orgY') != undefined && $(prevLink).attr('orgY').length > 0) {
							$(prevLink).css('top', $(prevLink).attr('orgY') + 'px');
							$(prevLink).attr('orgY', '');
						}
						$(prevLinkBar).css('visibility', 'hidden');
					};

					// 여기서 좌표계산이 필요함
					posLeft = Number(posTarget.style.left.replace('px',''));
					posTop = Number(posTarget.style.top.replace('px',''));
					posMaxLeft = window.innerWidth - (posLeft * 2) - 270;
					posMaxTop = window.innerHeight - (posTop * 2) - 157;

					var linkLeft = Number($(newLink.element).css('left').replace('px',''));
					var linkTop = Number($(newLink.element).css('top').replace('px',''));

					if (browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
						// 창크기에 따른 이동
						posMaxLeft = (window.innerWidth / 2) - (posLeft * 2) - 135;
						//posMaxTop = 60;
						posMaxTop = window.innerHeight - (posTop * 2);

						$(newLink.element).css('left', posMaxLeft + 'px');
						$(newLink.element).attr('orgX', linkLeft);
						$(newLink.element).css('top', linkTop + 'px');
						$(newLink.element).attr('orgY', linkTop);
					} else {
						if (linkLeft > posMaxLeft) {
							$(newLink.element).css('left', posMaxLeft + 'px');
							$(newLink.element).attr('orgX', linkLeft);
						}

						if (linkTop > posMaxTop) {
							$(newLink.element).css('top', linkTop + 'px');
							$(newLink.element).attr('orgY', linkTop);
						}
					}
					$(linkBar).css('visibility', 'visible');
					prevLink = $(newLink.element);
					prevLinkBar = $(linkBar);
				}
			}
		}, true);	

		linkURL.addEventListener('keyup', function (e) {
			if (e.keyCode === 13) {
				linkValidation(this.value);
				saveLink(newLink.element);
			}	
		});

		linkTitle.addEventListener('focus', function () {
			if (this.value === ViewerManager.Local.linkTitle) {
				this.value = "";	
			}
		});

		linkTitle.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			if (this.value === ViewerManager.Local.linkTitle) {
				this.value = "";	
			}
		}, true);

		if (_top && _left) {
			$(newLink.element).css({
				"left" : _left + 'px',
				"top" : _top + 'px'
			});	
		} else {
			var pageHalfW = Number(ViewerManager.iframeContentsWidth) * ViewerManager.zoomRate / 2;
			var pageHalfH = Number(ViewerManager.iframeContentsHeight) * ViewerManager.zoomRate / 2;
			//console.log(ViewerManager.iframeContentsWidth, ViewerManager.zoomRate, pageHalfW);
			$(newLink.element).css({
				"left" : (pageHalfW - 17) + "px",
				"top" : (pageHalfH - 24) + "px"
			});

			if ($(newLink.element).css('visibility') == 'visible' || $(newLink.element).css('visibility') == '') {
				if (browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
					// 여기서 좌표계산이 필요함
					// 창크기에 따른 이동
					posLeft = Number(posTarget.style.left.replace('px',''));
					//posTop = Number(posTarget.style.top.replace('px',''));
					posTop = 0;
					posMaxLeft = (window.innerWidth / 2) - (posLeft * 2) - 151;
					posMaxTop = 60;

					var linkLeft = Number($(newLink.element).css('left').replace('px',''));
					var linkTop = Number($(newLink.element).css('top').replace('px',''));

					$(newLink.element).css('left', posMaxLeft + 'px');
					$(newLink.element).attr('orgX', linkLeft);
					$(newLink.element).css('top', posMaxTop + 'px');
					$(newLink.element).attr('orgY', linkTop);
				}
			}
		}
		newLink.element.appendChild(linkTitle);
		newLink.element.appendChild(linkURL);
		newLink.element.appendChild(linkBar);
		newLink.element.appendChild(closeButton);
		newLink.element.appendChild(deleteButton);
		newLink.element.appendChild(linkIcon);
		document.getElementById('components').appendChild(newLink.element);
		// 뎁스 초기화
		$(newLink.element).css('z-index', $(newLink.element).index());

		new draggable(element);
		if (_stat != "load"){saveLink(newLink.element);}
		CONTROL.closeUtils('link');
	},

	linkValidation = function (_value) {
		log("@ linkValidation...");

		log("@ _value : " + _value);

		if (_value === ViewerManager.Local.linkContents) {
			log("empty url...");

			$("#currentModeNotice").text(ViewerManager.Local.linkUrlError).fadeIn(300, function () {
				var noticeTimer = setTimeout(function () {
					$("#currentModeNotice").fadeOut(500);
					clearTimeout(this);	
				}, 1000);
			});

		}

	},

	saveLink = function (_element) {
		log("@ saveLink...");

		var insertLinkData = function () {
			try {
				log('@ insert Link Data to localStorage...');

				linkDatas = JSON.parse(CONTROL.save_target("link"));

				var adjustLeft = Number(_element.style.left.replace('px','')),
				adjustTop = Number(_element.style.top.replace('px','')),
				newPageNumber, linkname, linkurl;

				linkname = _element.querySelector('.linkTitle').value;
				linkurl = _element.querySelector('.linkURL').value;
				//console.log('save', _element.querySelector('.linkURL'), linkurl);

				// 좌표계산에 따른 좌우 페이지 번호 지정
				if (ViewerManager.pageMODE == 'DOUBLE') {
					var doublePageHalf = Number(ViewerManager.iframeContentsWidth) * ViewerManager.zoomRate;
					newPageNumber = adjustLeft < (doublePageHalf) ? ViewerManager.PAGE_CURRENT_NUMBER - 1 : ViewerManager.PAGE_CURRENT_NUMBER;
					_element.setAttribute('page', newPageNumber);
				}

				// 비율좌표를 1배율 좌표로 다시 계산
				var orgPos = originalPosition(adjustLeft, adjustTop, newPageNumber);

				linkDatas.link.push({
					bookId : String(ViewerManager.GetData.EPUB.ID),
					pageno : String(_element.getAttribute('page')),
					createdate : String(_element.getAttribute('id')),
					lastdate : String((new Date()).yyyymmddhh24miss()),
					linkname : String(linkname),
					linkurl : String(linkurl),
					locx : String(orgPos.x),
					locy : String(orgPos.y)
				});
				CONTROL.save_target('link', JSON.stringify(linkDatas));

			/*var linkDatas = JSON.parse(window.localStorage.getItem("link")),
				adjustLeft = $(_element).css("left");
				adjustLeft = adjustLeft.replace("px", "");
				adjustLeft = parseInt(adjustLeft) + ViewerManager.adjustDoublePage(ViewerManager.PAGE_CURRENT_NUMBER);
				linkDatas.link.push({cntsId : ViewerManager.userInfo.cntsId, userId : ViewerManager.userInfo.userId, linkId : _element.getAttribute('id'), pageNum : ViewerManager.PAGE_CURRENT_NUMBER, linkTitle : _element.querySelector('.linkTitle').value, url : _element.querySelector('.linkURL').value, top : $(_element).css("top"), left : adjustLeft + "px", regDate : (new Date()).yyyymmddhh24miss()});
				// linkDatas.link.push({cntsId : ViewerManager.userInfo.cntsId, userId : ViewerManager.userInfo.userId, linkId : _element.getAttribute('id'), pageNum : ViewerManager.PAGE_CURRENT_NUMBER, linkTitle : _element.querySelector('.linkTitle').value, url : _element.querySelector('.linkURL').value, top : $(_element).css("top"), left : $(_element).css("left"), regDate : (new Date()).yyyymmddhh24miss()});
				window.localStorage.setItem("link", JSON.stringify(linkDatas));*/



			} catch (e) {
				log('@ insert Link error :' + e);
			}
		};

		// 링크 삭제 data
		deleteLink(_element);
		// a new link data
		insertLinkData();
		
	},

	loadLocalStorageLink = function (PAGE_CURRENT_NUMBER) {
		try {    
			linkDatas = JSON.parse(CONTROL.save_target("link"));

			log("@ linkDatas.link.length : " + linkDatas.link.length);

			if (linkDatas.link.length > 0) {
				for (var i = 0; i < linkDatas.link.length; i++) {
					// localStorage searching
					var _pageno = linkDatas.link[i].pageno == undefined ? linkDatas.link[i].pageNo : linkDatas.link[i].pageno;
					var _createdate = linkDatas.link[i].createdate == undefined ? linkDatas.link[i].key : linkDatas.link[i].createdate;
					var _lastdate = linkDatas.link[i].lastdate == undefined ? linkDatas.link[i].lastDate : linkDatas.link[i].lastdate;
					var _locx = linkDatas.link[i].locx == undefined ? linkDatas.link[i].locX : linkDatas.link[i].locx;
					_locx = _locx == 'NaN' ? '0' : _locx;
					var _locy = linkDatas.link[i].locy == undefined ? linkDatas.link[i].locY : linkDatas.link[i].locy;
					_locy = _locy == 'NaN' ? '0' : _locy;

					// 이전 데이터 교체
					if (linkDatas.link[i].pageNo != undefined || linkDatas.link[i].key != undefined || linkDatas.link[i].locX != undefined || linkDatas.link[i].locY != undefined) {
						var newData = {
							bookId : String(linkDatas.link[i].bookId),
							pageno : String(_pageno),
							createdate : String(_createdate),
							lastdate : String(_lastdate),
							linkname : String(linkDatas.link[i].linkname),
							linkurl : String(linkDatas.link[i].linkurl),
							locx : String(_locx),
							locy : String(_locy)
						};
						console.log(i, PAGE_CURRENT_NUMBER, linkDatas.link[i], newData);
						linkDatas.link[i] = newData;
					}

					if (parseInt(PAGE_CURRENT_NUMBER) === parseInt(_pageno)) {
						var adjustLeft, adjustTop, pageNum;
						adjustLeft = Number(_locx);
						adjustTop = Number(_locy);
						pageNum = parseInt(_pageno);

						var zoomPos = zoomPosition(adjustLeft, adjustTop, pageNum);
						if (isNaN(zoomPos.x) || isNaN(zoomPos.y)) {continue;}
						if (ViewerManager.VIEWER_TYPE == 'LOCAL') {
							if (ViewerManager.GetData.EPUB.ID == linkDatas.link[i].bookId) {
								new Link(pageNum, _createdate, linkDatas.link[i].linkname, linkDatas.link[i].linkurl, zoomPos.x, zoomPos.y, "load");
							}
						}
						else
						{
							new Link(pageNum, _createdate, linkDatas.link[i].linkname, linkDatas.link[i].linkurl, zoomPos.x, zoomPos.y, "load");
						}
					}
				}

				CONTROL.save_target('link', JSON.stringify(linkDatas));
			}

			/*// saved local link data in localStorage
			if (linkDatas.link.length > 0) {

				for (var i = 0; i < linkDatas.link.length; i++) {
					// localStorage searching
					if (ViewerManager.userInfo.cntsId === linkDatas.link[i].cntsId && ViewerManager.userInfo.userId === linkDatas.link[i].userId && parseInt(PAGE_CURRENT_NUMBER) === parseInt(linkDatas.link[i].pageNum)) {
						new Link(linkDatas.link[i].linkId, linkDatas.link[i].linkTitle, linkDatas.link[i].url, linkDatas.link[i].pageNum, linkDatas.link[i].top, (parseInt(linkDatas.link[i].left.replace("px", "")) - ViewerManager.adjustDoublePage(PAGE_CURRENT_NUMBER)) + "px");
					}
				}
			}*/
		} catch (err) {
			log("@ Link load error - " + err);
		}
	},

	deleteLink = function (_element) {
		log("@ deleteLink...");

		try {    
			linkDatas = JSON.parse(CONTROL.save_target("link"));
			// saved local link data in localStorage
			if (linkDatas.link.length > 0) {
				for (var i = 0; i < linkDatas.link.length; i++) {
					// localStorage searching
					var _createdate = linkDatas.link[i].createdate == undefined ? linkDatas.link[i].key : linkDatas.link[i].createdate;

					if (_createdate == _element.getAttribute("id")) {
						linkDatas.link.splice(i, 1);
						CONTROL.save_target("link", JSON.stringify(linkDatas));

						break;
					}
				}
			}
		} catch (err) {
			log("@ Link load error - " + err);
		}
	},

	originalPosition = function (_left, _top, _pageNum) {
		// 비율 1 좌표로 계산
		var returnPos = [];
		var left, top;

		left = _left;

		if (_pageNum%2 ==1) {
			// 홀수 페이지의 경우, 좌표에서 프레임 크기를 빼준다
			left = _left - Number(ViewerManager.iframeContentsWidth * ViewerManager.zoomRate);
		}

		left = left / ViewerManager.zoomRate;
		top = _top / ViewerManager.zoomRate;

		returnPos.x = parseInt(left);
		returnPos.y = parseInt(top);

		//console.log("abs", _left, _top, returnPos.x, returnPos.y);
		return returnPos;
	},

	zoomPosition = function (_left, _top, _pageNum) {
		// 현재 비율 좌표로 계산
		var returnPos = [];
		if (ViewerManager.zoomRate == Infinity) {return returnPos;}
		var left, top;

		left = _left;

		if (ViewerManager.pageMODE == 'DOUBLE' && _pageNum%2 ==1) {
			// 2페이지 보기 및 홀수 페이지의 경우, 좌표에 프레임 크기를 더해준다
			left = _left + parseInt(ViewerManager.iframeContentsWidth);
		}

		left = left * ViewerManager.zoomRate;
		top = _top * ViewerManager.zoomRate;

		returnPos.x = parseInt(left);
		returnPos.y = parseInt(top);

		//console.log("zoom", ViewerManager.pageMODE, _left, _top, returnPos.x, returnPos.y);
		return returnPos;
	},

	linkIndex = function () {
		if (showLink == null || showLink == undefined) {return;}
		// 링크의 인덱스 조절을 위해서 작성(20160222)
		// 뎁스 초기화
		$(showLink.element).css('z-index', $(showLink.element).index());

		$(showLink.element).css('visibility', 'hidden');
		$(showLinkIcon).css('visibility', 'visible');
		$(showLinkBar).css('visibility', 'hidden');

		//if (prevLinkBar != null && prevLinkBar != undefined) {$(prevLinkBar).css('visibility', 'hidden')};

		// 변경된 좌표를 다시 조정해줘야함
		if ($(showLink.element).attr('orgX') != undefined && $(showLink.element).attr('orgX').length > 0) {
			$(showLink.element).css('left', $(showLink.element).attr('orgX') + 'px');
			$(showLink.element).attr('orgX', '');
		}
		if ($(showLink.element).attr('orgY') != undefined && $(showLink.element).attr('orgY').length > 0) {
			$(showLink.element).css('top', $(showLink.element).attr('orgY') + 'px');
			$(showLink.element).attr('orgY', '');
		}
	}

	var exportLink = {
		Link : Link,
		loadLocalStorageLink : loadLocalStorageLink,
		linkIndex : linkIndex
	};

	CONTROL.link = exportLink;

	return exportLink;
});