define(['jquery', 'log', 'browser', 'link'], function ($, log, browser) {
	//'use strict';

	log("\n @ import memo.js ... \n");

	CONTROL.save_target("memo");

	var memoDatas, prevMemo, prevIcon, showMemo, showMemoIcon;

	var dragCnt = 0,
	draggable = function (element) {
		this.element = element;
		this.parentElement = window;
		this.createDrag();	
	};

	draggable.prototype.createDrag = function () {
		var touch = 'ontouchend' in document;
		var startEvent = (touch) ? 'touchstart' : 'mousedown';
        var moveEvent = (touch) ? 'touchmove' : 'mousemove';
        var endEvent = (touch) ? 'touchend' : 'mouseup';

		var posTarget = document.getElementById('components');
		var posLeft, posTop, posMaxLeft, posMaxTop;

		var draggable = this,
		drag = function (e) {
			var eventMaster;
			e.preventDefault();

			var dragX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientX : e.clientX;
			var dragY = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientY : e.clientY;

			draggable.element.style.position = 'absolute';
			draggable.newY = (dragY) - draggable.offY;
			draggable.newX = (dragX) - draggable.offX;
			// x position min-max
			if (draggable.newX < 0) {draggable.newX = 0;}
			if (draggable.newX > posMaxLeft) {draggable.newX = posMaxLeft;}
			// y position min-max
			if (draggable.newY < 0) {draggable.newY = 0;}
			if (draggable.newY > posMaxTop) {draggable.newY = posMaxTop;}

			draggable.element.style.left = draggable.newX + 'px';
			draggable.element.style.top = draggable.newY + 'px';

			draggable.element.dragCnt++;
		},
		startDrag = function (e) {
			draggable.dragCnt = 0;
			var startX = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientX : e.clientX;
			var startY = e.originalEvent.touches ? e.originalEvent.changedTouches[0].clientY : e.clientY;

			posLeft = Number(posTarget.style.left.replace('px',''));
			posTop = Number(posTarget.style.top.replace('px',''));
			posMaxLeft = window.innerWidth - (posLeft * 2) - 35;
			posMaxTop = window.innerHeight - (posTop * 2) - 48;

			draggable.offY = (startY) - parseInt(draggable.element.offsetTop);
			draggable.offX = (startX) - parseInt(draggable.element.offsetLeft);
			
			$(draggable.parentElement).bind(endEvent, function (e) {
				endDrag(e);
				dragCnt = 0;
			});
			$(draggable.parentElement).bind(moveEvent, drag);
		},
		endDrag = function () {
			//e.stopPropagation();
			$(draggable.parentElement).unbind(moveEvent, drag);
			
			if (draggable.element.dragCnt > 5) {
				draggable.element.dragCnt = 0;
				if (this != undefined) {
					if ($(draggable.element).attr('orgX') != undefined && $(draggable.element).attr('orgX').length > 0) {
						$(draggable.element).attr('orgX', '');
					}
					if ($(draggable.element).attr('orgY') != undefined && $(draggable.element).attr('orgY').length > 0) {
						$(draggable.element).attr('orgY', '');
					}
					saveMemo(draggable.element);
				}
			}
		};

		$(draggable.element).bind(startEvent, startDrag);
		$(draggable.element).bind(endEvent, endDrag);
	}

	var Memo = function (_page, _key, _title, _memo, _left, _top, _stat) {
		log("@ create Memo object...");
		var element = document.createElement('div'),

			memoTitle = document.createElement('input'),
			content = document.createElement('div'),
			closeButton = document.createElement('div'),
			deleteButton = document.createElement('div'),
			memoSaveButton = document.createElement('div'),
			
			memoIcon = document.createElement('div'),
			newMemo = this,
			memoPage = (_page) ? _page : ViewerManager.pageMODE == "DOUBLE" ? ViewerManager.PAGE_CURRENT_NUMBER - 1 : ViewerManager.PAGE_CURRENT_NUMBER,
			memoTitleText = (_title) ? _title : ViewerManager.Local.memoTitle,
			memoContentsText = (_memo) ? _memo : ViewerManager.Local.memoContents;

		showMemo = newMemo, showMemoIcon = memoIcon;
		element.dragCnt = 0;
		newMemo.element = element;
		newMemo.element.className = 'sticky';
		if (_key) {
			newMemo.element.setAttribute('id', _key);
			$(newMemo.element).css('visibility', 'hidden');
			$(memoIcon).css('visibility', 'visible');

		} else {
			// memo id setting
			newMemo.element.setAttribute('id', (new Date()).yyyymmddhh24miss());
		}
		
		newMemo.element.setAttribute('page', memoPage);
		newMemo.element.setAttribute('data-sticky', true);
		memoTitle.className = 'memoTitle';
		memoTitle.value = memoTitleText;
		memoTitle.type = 'text';

		content.className = 'memo-content';
		content.setAttribute('contenteditable', true);
		content.style.height = '115px';
		content.style.overflowY = 'auto';
		content.innerHTML = memoContentsText;

		closeButton.className = 'memo_closeButton';
		closeButton.setAttribute('title', '메모 닫기');
		deleteButton.className = 'memo_deleteButton';
		deleteButton.setAttribute('title', '메모 삭제');
		memoSaveButton.className = 'memo_saveButton';
		memoSaveButton.setAttribute('title','메모 저장');
		memoIcon.className = 'memoIcon';
		memoIcon.setAttribute('title', newMemo.element.getAttribute("id"));

		var posTarget = document.getElementById('components');
		var posMaxLeft, posMaxTop, posLeft, posTop;

		closeButton.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			// 뎁스 초기화
			$(newMemo.element).css('z-index', $(newMemo.element).index());
			$(newMemo.element).css('visibility', 'hidden');
			$(memoIcon).css('visibility', 'visible');

			// 변경된 좌표를 다시 조정해줘야함
			if ($(newMemo.element).attr('orgX') != undefined && $(newMemo.element).attr('orgX').length > 0) {
				$(newMemo.element).css('left', $(newMemo.element).attr('orgX') + 'px');
				$(newMemo.element).attr('orgX', '');
			}
			if ($(newMemo.element).attr('orgY') != undefined && $(newMemo.element).attr('orgY').length > 0) {
				$(newMemo.element).css('top', $(newMemo.element).attr('orgY') + 'px');
				$(newMemo.element).attr('orgY', '');
			}
			// 닫기 누를 때 저장
			saveMemo(newMemo.element);
			setTimeout(function () {
				window.focus();
			}, 300);
		}, true);

		
		memoSaveButton.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			// 뎁스 초기화
			$(newMemo.element).css('z-index', $(newMemo.element).index());

			$(newMemo.element).css('visibility', 'hidden');
			$(memoIcon).css('visibility', 'visible');

			// 변경된 좌표를 다시 조정해줘야함
			if ($(newMemo.element).attr('orgX') != undefined && $(newMemo.element).attr('orgX').length > 0) {
				$(newMemo.element).css('left', $(newMemo.element).attr('orgX') + 'px');
				$(newMemo.element).attr('orgX', '');
			}
			if ($(newMemo.element).attr('orgY') != undefined && $(newMemo.element).attr('orgY').length > 0) {
				$(newMemo.element).css('top', $(newMemo.element).attr('orgY') + 'px');
				$(newMemo.element).attr('orgY', '');
			}
			// 닫기 누를 때 저장
			saveMemo(newMemo.element);
			setTimeout(function () {
				window.focus();
			}, 300);
		}, true);
		
		
		deleteButton.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			$("#memoDeleteTemplet").css('left', (window.innerWidth / 2 - 150) + 'px');
			$("#memoDeleteTemplet").fadeIn("fast", function () {
				$(this).find("#memoDeletePopupYesBtn").on("click", function () {
					$("#memoDeleteTemplet").fadeOut("fast");
					$(newMemo.element).hide("slow", function () {
						//newMemo.element.remove();
						deleteMemo(this);
						//document.getElementById('components').removeChild(this);
					});
				});
				$(this).find("#memoDeletePopupNoBtn").on("click", function () {
					$("#memoDeleteTemplet").fadeOut("fast");
				});
			});			
		}, true);

		memoIcon.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			log("@@@ dragCnt : " + dragCnt);

			if (element.dragCnt < 3) {
				CONTROL.closeUtils('memo');
				if (prevMemo != null && prevMemo != $(newMemo.element) && prevIcon != null) {
					$(prevMemo).css('z-index', $(prevMemo).index());
					$(prevMemo).css('visibility', 'hidden');
					$(prevIcon).css('visibility', 'visible');
					// 변경된 좌표를 다시 조정해줘야함
					if ($(prevMemo).attr('orgX') != undefined && $(prevMemo).attr('orgX').length > 0) {
						$(prevMemo).css('left', $(prevMemo).attr('orgX') + 'px');
						$(prevMemo).attr('orgX', '');
					}
					if ($(prevMemo).attr('orgY') != undefined && $(prevMemo).attr('orgY').length > 0) {
						$(prevMemo).css('top', $(prevMemo).attr('orgY') + 'px');
						$(prevMemo).attr('orgY', '');
					}
				}
				prevMemo = $(newMemo.element);
				prevIcon = $(memoIcon);

				showMemo = newMemo;

				// 뎁스 올려주기
				var maxIndex = $(newMemo.element).parent().children().length;
				$(newMemo.element).css('z-index', maxIndex + 1);

				$(newMemo.element).css('visibility', 'visible');
				$(memoIcon).css('visibility', 'hidden');
				// 여기서 좌표계산이 필요함
				posLeft = Number(posTarget.style.left.replace('px',''));
				posTop = Number(posTarget.style.top.replace('px',''));
				posMaxLeft = window.innerWidth - (posLeft * 2) - 257;
				posMaxTop = window.innerHeight - (posTop * 2) - 207;

				var memoLeft = Number($(newMemo.element).css('left').replace('px',''));
				var memoTop = Number($(newMemo.element).css('top').replace('px',''));

				if (browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
					// 창크기에 따른 이동
					posMaxLeft = (window.innerWidth / 2) - (posLeft * 2) - 128;
					posMaxTop = 60;

					$(newMemo.element).css('left', posMaxLeft + 'px');
					$(newMemo.element).attr('orgX', memoLeft);
					$(newMemo.element).css('top', posMaxTop + 'px');
					$(newMemo.element).attr('orgY', memoTop);
				} else {
					if (memoLeft > posMaxLeft) {
						$(newMemo.element).css('left', posMaxLeft + 'px');
						$(newMemo.element).attr('orgX', memoLeft);
					}

					if (memoTop > posMaxTop) {
						$(newMemo.element).css('top', posMaxTop + 'px');
						$(newMemo.element).attr('orgY', memoTop);
					}
				}
				// 포커스 이동 테스트
				setTimeout (function (){
					//$(newMemo.element).css('z-index', 1000);
					$(memoTitle).focus();	
				}, 100)
			}
		}, true);

		$(memoTitle).on('focusout', function(event){
			//if ($(this).val() !=  ViewerManager.Local.memoTitle){ 
				saveMemo(newMemo.element);
			//}
		});

		$(content).on('focusout, blur', function(event){
			//if ($(this).html() != ViewerManager.Local.memoContents) {
				saveMemo(newMemo.element);
			//}
		});

		memoTitle.addEventListener('focus', function () {
			if (this.value === ViewerManager.Local.memoTitle) {
				this.value = "";	
			}
		});
			
		memoTitle.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			if (this.value === ViewerManager.Local.memoTitle) {
				this.value = "";	
			}
		}, true);

		content.addEventListener('focus', function () {
			if (this.innerHTML === ViewerManager.Local.memoContents) {
				this.innerHTML = "";	
			}
		});

		content.addEventListener(ViewerManager.eventSelector.upEvent, function () {
			if (this.innerHTML === ViewerManager.Local.memoContents){
				this.innerHTML = "";	
			}
		}, true);

		if (_top && _left) {
			$(newMemo.element).css({
				"left" : _left + 'px',
				"top" : _top + 'px'
			});	
		} else {
			var pageHalfW = Number(ViewerManager.iframeContentsWidth) * ViewerManager.zoomRate / 2;
			var pageHalfH = Number(ViewerManager.iframeContentsHeight) * ViewerManager.zoomRate / 2;
			//console.log(ViewerManager.iframeContentsWidth, ViewerManager.zoomRate, pageHalfW);
			$(newMemo.element).css({
				"left" : (pageHalfW - 17) + "px",
				"top" : (pageHalfH - 24) + "px"
			});

			if ($(newMemo.element).css('visibility') == 'visible' || $(newMemo.element).css('visibility') == '') {
				if (browser.isMobile.androidPhone || browser.isMobile.androidTablet || browser.isMobile.iPhone || browser.isMobile.iPod || browser.isMobile.iPad) {
					// 여기서 좌표계산이 필요함
					// 창크기에 따른 이동
					posLeft = Number(posTarget.style.left.replace('px',''));
					//posTop = Number(posTarget.style.top.replace('px',''));
					posTop = 0;
					posMaxLeft = (window.innerWidth / 2) - (posLeft * 2) - 128;
					posMaxTop = 60;

					var memoLeft = Number($(newMemo.element).css('left').replace('px',''));
					var memoTop = Number($(newMemo.element).css('top').replace('px',''));

					$(newMemo.element).css('left', posMaxLeft + 'px');
					$(newMemo.element).attr('orgX', memoLeft);
					$(newMemo.element).css('top', posMaxTop + 'px');
					$(newMemo.element).attr('orgY', memoTop);
				}
			}
		}
		newMemo.element.appendChild(memoTitle);
		newMemo.element.appendChild(content);
		newMemo.element.appendChild(closeButton);
		newMemo.element.appendChild(deleteButton);
		newMemo.element.appendChild(memoIcon);
		newMemo.element.appendChild(memoSaveButton);
		var madeMemo = document.getElementById('components').appendChild(newMemo.element);
		// 뎁스 초기화
		$(madeMemo).css('z-index', $(madeMemo).index());

		new draggable(element);
		if (_stat != "load"){saveMemo(newMemo.element);}
		CONTROL.closeUtils('memo');
	},

	setMemoOpenStatus = function(elem, status){
		$(elem).attr("data-open", status);
	},

	saveMemo = function (_element, stat) {
		log("@ saveMemo...");

		var insertMemoData = function (_element) {
			try {
				log('@ ::: insert Memo to localStorage ... :::');

				memoDatas = JSON.parse(CONTROL.save_target("memo"));

				var adjustLeft = Number(_element.style.left.replace('px','')),
				adjustTop = Number(_element.style.top.replace('px','')),
				newPageNumber, title, memo;

				title = _element.querySelector('.memoTitle').value;
				memo = _element.querySelector('.memo-content').innerHTML;
				//console.log('save', _element.querySelector('.memo-content'), memo);

				// 좌표계산에 따른 좌우 페이지 번호 지정
				if (ViewerManager.pageMODE == 'DOUBLE') {
					var doublePageHalf = Number(ViewerManager.iframeContentsWidth) * ViewerManager.zoomRate;
					newPageNumber = adjustLeft < (doublePageHalf) ? ViewerManager.PAGE_CURRENT_NUMBER - 1 : ViewerManager.PAGE_CURRENT_NUMBER;
					_element.setAttribute('page', newPageNumber);
				}

				// 비율좌표를 1배율 좌표로 다시 계산
				var orgPos = originalPosition(adjustLeft, adjustTop, newPageNumber);

				memoDatas.memo.push({
					bookId : String(ViewerManager.GetData.EPUB.ID),
					pageno : String(_element.getAttribute('page')),
					createdate : String(_element.getAttribute('id')),
					lastdate : String((new Date()).yyyymmddhh24miss()),
					title : String(title),
					memo : String(memo),
					locx : String(orgPos.x),
					locy : String(orgPos.y)
				});
				CONTROL.save_target('memo', JSON.stringify(memoDatas));
			} catch (e) {
				log('@ insert Memo error :' + e);
			}
		};
		
		// 메모 삭제 data
		deleteMemo(_element);
		// a new memo data
		insertMemoData(_element);
	},

	loadLocalStorageMemo = function (PAGE_CURRENT_NUMBER) {
		try {
			memoDatas = JSON.parse(CONTROL.save_target("memo"));

			log("@ memoDatas.memo.length : " + memoDatas.memo.length);
			// saved local Memo data in localStorage
			if (memoDatas.memo.length > 0) {
				for (var i = 0; i < memoDatas.memo.length; i++) {
					// localStorage searching
					var _pageno = memoDatas.memo[i].pageno == undefined ? memoDatas.memo[i].pageNo : memoDatas.memo[i].pageno;
					var _createdate = memoDatas.memo[i].createdate == undefined ? memoDatas.memo[i].key : memoDatas.memo[i].createdate;
					var _lastdate = memoDatas.memo[i].lastdate == undefined ? memoDatas.memo[i].lastDate : memoDatas.memo[i].lastdate;
					var _locx = memoDatas.memo[i].locx == undefined ? memoDatas.memo[i].locX : memoDatas.memo[i].locx;
					_locx = _locx == 'NaN' ? '0' : _locx;
					var _locy = memoDatas.memo[i].locy == undefined ? memoDatas.memo[i].locY : memoDatas.memo[i].locy;
					_locy = _locy == 'NaN' ? '0' : _locy;

					// 이전 데이터 교체
					if (memoDatas.memo[i].pageNo != undefined || memoDatas.memo[i].key != undefined || memoDatas.memo[i].locX != undefined || memoDatas.memo[i].locY != undefined) {
						var newData = {
							bookId : String(memoDatas.memo[i].bookId),
							pageno : String(_pageno),
							createdate : String(_createdate),
							lastdate : String(_lastdate),
							title : String(memoDatas.memo[i].title),
							memo : String(memoDatas.memo[i].memo),
							locx : String(_locx),
							locy : String(_locy)
						};
						console.log(i, PAGE_CURRENT_NUMBER, memoDatas.memo[i], newData);
						memoDatas.memo[i] = newData;
					}

					if (parseInt(PAGE_CURRENT_NUMBER) === parseInt(_pageno)) {
						var adjustLeft, adjustTop, pageNum;
						adjustLeft = Number(_locx);
						adjustTop = Number(_locy);
						pageNum = parseInt(_pageno);

						var zoomPos = zoomPosition(adjustLeft, adjustTop, pageNum);
						if (isNaN(zoomPos.x) || isNaN(zoomPos.y)) {continue;}
						if (ViewerManager.VIEWER_TYPE == 'LOCAL') {
							if (ViewerManager.GetData.EPUB.ID == memoDatas.memo[i].bookId) {
								new Memo(pageNum, _createdate, memoDatas.memo[i].title, memoDatas.memo[i].memo, zoomPos.x, zoomPos.y, "load");
							}
						}
						else
						{
							new Memo(pageNum, _createdate, memoDatas.memo[i].title, memoDatas.memo[i].memo, zoomPos.x, zoomPos.y, "load");
						}
					}
				}

				CONTROL.save_target('memo', JSON.stringify(memoDatas));
			} 
		} catch (err) {
			log("@ Memo load error - " + err);
		}
	},

	deleteMemo = function (_element) {
		log("@ deleteMemo...");
		try {
			memoDatas = JSON.parse(CONTROL.save_target("memo"));
			// saved local Memo data in localStorage
			if (memoDatas.memo.length > 0) {
				for (var i = 0; i < memoDatas.memo.length; i++) {
					// localStorage searching
					var _createdate = memoDatas.memo[i].createdate == undefined ? memoDatas.memo[i].key : memoDatas.memo[i].createdate;
					if (_createdate == _element.getAttribute("id")) {
						memoDatas.memo.splice(i, 1);
						CONTROL.save_target("memo", JSON.stringify(memoDatas));

						break;
					}
				}
			}
		} catch (err) {
			log("@ Memo load error - " + err);
		}
	},

	originalPosition = function (_left, _top, _pageNum) {
		// 비율 1 좌표로 계산
		var returnPos = [];
		var left, top;

		left = _left;

		if (_pageNum%2 ==1) {
			// 홀수 페이지의 경우, 좌표에서 프레임 크기를 빼준다
			left = _left - Number(ViewerManager.iframeContentsWidth * ViewerManager.zoomRate);
		}

		left = left / ViewerManager.zoomRate;
		top = _top / ViewerManager.zoomRate;

		returnPos.x = parseInt(left);
		returnPos.y = parseInt(top);

		//console.log("abs", _left, _top, returnPos.x, returnPos.y);
		return returnPos;
	},

	zoomPosition = function (_left, _top, _pageNum) {
		// 현재 비율 좌표로 계산
		var returnPos = [];
		if (ViewerManager.zoomRate == Infinity) {return returnPos;}
		var left, top;

		left = _left;

		if (ViewerManager.pageMODE == 'DOUBLE' && _pageNum%2 ==1) {
			// 2페이지 보기 및 홀수 페이지의 경우, 좌표에 프레임 크기를 더해준다
			left = _left + parseInt(ViewerManager.iframeContentsWidth);
		}

		left = left * ViewerManager.zoomRate;
		top = _top * ViewerManager.zoomRate;

		returnPos.x = parseInt(left);
		returnPos.y = parseInt(top);

		//console.log("zoom", ViewerManager.pageMODE, _left, _top, returnPos.x, returnPos.y);
		return returnPos;
	},

	memoIndex = function () {
		if (showMemo == null || showMemo == undefined) {return;}
		// 메모의 인덱스 조절을 위해서 작성(20160222)
		// 뎁스 초기화
		$(showMemo.element).css('z-index', $(showMemo.element).index());

		$(showMemo.element).css('visibility', 'hidden');
		$(showMemoIcon).css('visibility', 'visible');

		// 변경된 좌표를 다시 조정해줘야함
		if ($(showMemo.element).attr('orgX') != undefined && $(showMemo.element).attr('orgX').length > 0) {
			$(showMemo.element).css('left', $(showMemo.element).attr('orgX') + 'px');
			$(showMemo.element).attr('orgX', '');
		}
		if ($(showMemo.element).attr('orgY') != undefined && $(showMemo.element).attr('orgY').length > 0) {
			$(showMemo.element).css('top', $(showMemo.element).attr('orgY') + 'px');
			$(showMemo.element).attr('orgY', '');
		}
	},

	_init = function () {
		if (browser.ie9 || browser.ie10) {return;}
		log('@ memo._init');
	},

	_saveOpenMemo = function() {

	},

	_loadStart = function () {
		log('@ memo._loadStart');
		/*
	 	if ($("div[data-open='true']").length > 0 ) {
	 		if (confirm("열려 있는 메모가 있습니다. 모두 저장하시겠습니까 ") == true){
	 			$("div[data-open='true']").each(function(index){
	 				saveMemo(this);
	 				setMemoOpenStatus(this, "fasle");
	 			});
	 		}else {
	 			setMemoOpenStatus(this, "fasle");
	 		}
	 	}
	 	*/
	},

	_loadComplete = function () {
		log('@ memo._loadComplete');
		switch (ViewerManager.pageMODE) {
			case "SINGLE": {
				loadLocalStorageMemo(ViewerManager.PAGE_CURRENT_NUMBER);
				break;
			}
			case "DOUBLE": {
				loadLocalStorageMemo(parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1);
				loadLocalStorageMemo(ViewerManager.PAGE_CURRENT_NUMBER);
				break;
			}
		}
	},

	_save = function () {
		log('@ memo._save');
	},

	_resize = function () {
		log('@ memo._resize');
	},

	_refresh = function () {
		log('memo._refresh');
	},

	_zoom = function () {
		log('memo._zoom');
	}

	var exportMemo = {
		Memo : Memo,
		loadLocalStorageMemo : loadLocalStorageMemo,
		memoIndex : memoIndex,
		_init : _init,
		_loadStart : _loadStart,
		_loadComplete : _loadComplete,
		_save : _save,
		_resize : _resize,
		_refresh : _refresh,
		_zoom : _zoom
	};

	CONTROL.memo = exportMemo;

	return exportMemo;
});