
define(['jquery', 'log', 'browser'], function ($, log, browser) {
	'use strict';

	log("\n @ import search.js ... \n");

	var startPage = 0, lastPage = 0, searchPageCount,
	excuteSearch = function (_searchWord) {
		log("@ searchWord : " + _searchWord);

		_searchWord = _searchWord.trim();
		_searchWord = String(_searchWord).toLowerCase();

		var searchResult = document.createElement('ul'),searchResultLi, searchWord,
			emptySearch = function () {

				searchResultLi = document.createElement('li');
				searchResultLi.innerHTML = ViewerManager.Local.indexListEmptySearch;
				searchResultLi.className = 'searchBgWhite';
				searchResult.appendChild(searchResultLi);

				clearLoadingIcon();
			},

			clearLoadingIcon = function () {
				ViewerManager.isMiniLoadingComplete = true;
				$(".loading_icon_mini").fadeOut("fast");
				clearInterval(ViewerManager.rotateLoadingAnimation);
			},

			createSearchData = function (currentPage, _contentPath) {
				log("@ createSearchData...");
				log(_contentPath);
				$.ajax({
					cache: false,
					url: ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] + "/" + _contentPath,
					type : 'GET', // 원본 type : 'POST' 로 되어 있었음
					dataType: 'html',
					async: true,
					success: function (data) {
						var tempPath = _contentPath.split("/"),
						replaceData = data.replace(/src="/gi, 'src="' + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + '/' + tempPath[0] + '/');
						replaceData = replaceData.replace(/" href="/gi, '" href="' + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + '/' + tempPath[0] + '/');
						replaceData = replaceData.replace(/url\(/gi, 'url(' + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + '/' + tempPath[0] + '/');
						replaceData = replaceData.replace(/poster="./gi, 'poster="' + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + '/' + tempPath[0]);
						replaceData = replaceData.replace(/…/gi, '...');

						//document.querySelector('#tempPageText').innerHTML = (browser.ie9 || browser.ie10 || browser.ie11 ? data.replace('name="viewport"', "") : replaceData.replace('name="viewport"', ""));
						document.querySelector('#tempPageText').innerHTML = replaceData.replace('name="viewport"', "");
						ViewerManager.pageSearchData[currentPage] = getTextNodes(document.querySelector('#tempPageText'));
						log("검색 후 치횐된 내용 : document.querySelector('#tempPageText').innerHTML");
						log(document.querySelector('#tempPageText').innerHTML);
						document.querySelector('#tempPageText').innerHTML = "";
					},
					error: function (err) {
						log("@ createSearchData ajax error : " + err);
					},
					complete: function () {
						log("@ createSearchData ajax complete...");

					}
				});
			},

			checkSearchData = function (currentPage) {
				currentPage = parseInt(currentPage);

				log(currentPage);
				log(ViewerManager.pageHTMLData[currentPage][0]);
				log(ViewerManager.pageHTMLData[currentPage][1]);

				if (ViewerManager.pageHTMLData[currentPage][0] == "Cached") {

					var tempTextFrame = document.querySelector('#tempPageText');
					document.querySelector('#tempPageText').innerHTML = ViewerManager.pageHTMLData[currentPage][1].replace('name="viewport"', "");
					//console.log('tempTextFrame', document.querySelector('#tempPageText').innerHTML);
					ViewerManager.pageSearchData[currentPage] = getTextNodes(document.querySelector('#tempPageText'));
					document.querySelector('#tempPageText').innerHTML = "";
				} else {
					log("oㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡo");
					log("| ViewerManager.pageHTMLData[currentPage][1] : " + ViewerManager.pageHTMLData[currentPage][1]);
					log("| pageHTML :");
					createSearchData(currentPage, ViewerManager.pageHTMLData[currentPage][1]);
				}
			};

		if (_searchWord === "") {
			log("@ empty search word!");
			emptySearch();
		} else {
			log("oㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡo");
			log("| ViewerManager.pageSearchData.length : " + ViewerManager.pageSearchData.length);
			log("oㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡo");

			if (ViewerManager.pageSearchData.length > 0) {
				startPage = ViewerManager.pageSearchData.length;
				lastPage = lastPage + searchPageCount;

				if (lastPage > ViewerManager.PAGE_TOTAL_NUMBER) {
					lastPage = ViewerManager.PAGE_TOTAL_NUMBER;
					$("#searchButton").text(ViewerManager.Local.searchButtonText);
				} else {
					$("#searchButton").text(ViewerManager.Local.continueSearchButtonText);
				}

				for (var i = startPage; i < lastPage + 1; i++) {
					checkSearchData(i);
				}

				log("| @ case1>>");
				log("| startPage : " + startPage);
				log("| lastPage : " + lastPage);
				log("oㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡo");

			} else {
				lastPage = lastPage + searchPageCount;

				if (lastPage > ViewerManager.PAGE_TOTAL_NUMBER) {
					lastPage = ViewerManager.PAGE_TOTAL_NUMBER + 1;
				}

				for (var b = startPage; b < lastPage + 1; b++) {
					checkSearchData(b);
				}

				$("#searchButton").text(ViewerManager.Local.continueSearchButtonText);
				log("| @ case2>>");
				log("| startPage : " + startPage);
				log("| lastPage : " + lastPage);
				log("oㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡo");
			}

			var searchResultFlag = false, thumbNailURL, currentPage, searchCheckFlag = false, pageCtlNum,
		    appendSearchResultLi = function(searchData, i) {
		        var originalSearchData = String(searchData).toLowerCase();

		        while (originalSearchData.indexOf(_searchWord) !== -1) {
		            searchResultFlag = true;
		            searchResultLi = document.createElement('li'),
		                searchWord = originalSearchData;
		            searchWord = searchWord.substring(searchWord.indexOf(_searchWord), searchWord.indexOf(_searchWord) + 50) + '...';
		            searchWord = searchWord.replace(_searchWord, '<mark>' + _searchWord + '</mark>');

		            currentPage = i;
		            if (currentPage > 99) {
		                currentPage = "" + currentPage;
		            } else if (currentPage > 9) {
		                currentPage = "0" + currentPage;
		            } else {
		                currentPage = "00" + currentPage;
		            }

		            if (ViewerManager.thumbnails.length > 0) thumbNailURL = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] + "/" + ViewerManager.thumbnails[i - 1];
		            else thumbNailURL = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + "" + ViewerManager.ePub.ops_name[0] + "/content/images/page" + currentPage + "/thumbnail.jpg";

		            if (ViewerManager.pageMODE === "DOUBLE" && ViewerManager.isOddCheck(parseInt(currentPage))) pageCtlNum = parseInt(currentPage) + 1;
		            else pageCtlNum = parseInt(currentPage);
//console.log(String(searchWord).getStringLength(200));
		            searchResultLi.innerHTML = "<div onclick='ViewerManager.pageLoading(" + pageCtlNum + " , " + ViewerManager.PAGE_TOTAL_NUMBER + ")'><div style='float: left; margin-left :10px; margin-right: 10px;'><img src='" + thumbNailURL + "' width='80' ></div><div style='float: right; padding-right: 5px;'>" + ViewerManager.transRealToVirtualPageIndex(parseInt(i)) + " p</div><div class='div_searchWord'>" + String(searchWord).getStringLength(200).replace(/undefined/gi, "") + "</div></div>";
		            searchResult.appendChild(searchResultLi);
		            searchResultLi.className = 'searchBgWhite';

		            searchResultLi.addEventListener("click", function() {
		                $("#searchListTemplet").fadeOut("fast");
		            }, false);

		            originalSearchData = originalSearchData.replace(_searchWord, "");
		            log(originalSearchData);
		        }
		    },
		    searchInterval = setInterval(function() {
		        if (ViewerManager.pageSearchData.length >= lastPage) {
		            clearInterval(searchInterval);
		            for (var i = 0; i < lastPage; i++) {
		                appendSearchResultLi(ViewerManager.pageSearchData[i], i);
		            }
		            clearLoadingIcon();

		            if (!searchResultFlag) {
		                emptySearch();
		            }
		        }
		    }, 100);
		}

		document.getElementById('searchContents').innerHTML = "";
		document.getElementById('searchContents').appendChild(searchResult);
	},

	getTextNodes = function (_element) {
		var textNodes= '';
		var skip = ['STYLE','SCRIPT','IFRAME','OBJECT','EMBED', 'META', 'IMG', 'TITLE', 'LINK'],
			textNodes = "";
			log("====getTextNodes====================================================================================");
			log(_element);

		var inArray = function (_arr, _val) {
			for (var i = 0, len = _arr.length; i < len; i++) {
				if (_arr[i] === _val) return true;
			}
			return false;
		};

		var cNodes = _element.childNodes;
		log("#tempPageText child nodes");
		log(cNodes);
		for (var i = 0, len = cNodes.length; i < len; i++) {
			if (cNodes[i].nodeType == 1) { // 1 : element ,  2 :attribute , 3 : text ,   8:comment , 9 : docuement
				if (inArray(skip, cNodes[i].nodeName)) {
					continue;
				}
				else {
					textNodes = textNodes + $(cNodes[i]).text();
				}
			}
			if (cNodes[i].nodeType == 3 && /\S/.test(cNodes[i].nodeValue)) {
				textNodes = textNodes + $(cNodes[i]).text();
			}
		}
		//console.log(_element, textNodes);
		return textNodes;
	},

	searchByNaver = function (_searchWord) {
		log("@ searchByNaver : " + _searchWord);
		document.getElementById('searchContents').innerHTML = "";

		var searchByNaverInfo = document.createElement('ul'),
			searchByNaverInfoLi = document.createElement('li');
			searchByNaverInfoLi.innerHTML = ViewerManager.Local.searchByNaverInfo;
			searchByNaverInfoLi.className = 'searchBgWhite';
			searchByNaverInfo.appendChild(searchByNaverInfoLi);

		document.getElementById('searchContents').appendChild(searchByNaverInfo);

	};

	if (browser.chrome) {
		searchPageCount = 20;
	} else {
		searchPageCount = 20;
	}


	var exportSearch = {
		excuteSearch : excuteSearch,
		searchByNaver : searchByNaver
	};
	return exportSearch;
});
