
define(['jquery', 'draw', 'log', 'params'], function ($, draw, log, params) {
	'use strict';

	log("\n @ import thumbnail.js ... \n");

	var thumbnailList = function() {
		log("@ THUMBNAIL List loading...");

		var epubDirPath,
			thumbNailData = [],
			tmpPageBookmark,
			_PAGE_TOTAL_NUMBER,
			_OPS_NAME,
			_CURRENTPAGE,
			tmpThumbNailURL;

		try {
			epubDirPath = ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath;
			_PAGE_TOTAL_NUMBER = ViewerManager.ePub.opf_xml2json_total_len;
			_OPS_NAME = ViewerManager.ePub.ops_name[0];
		} catch (err) {
			log("@ thumbnail path error : " + err);
		}

		log("@ epubDirPath=" + epubDirPath);
		log("@ _PAGE_TOTAL_NUMBER=" + _PAGE_TOTAL_NUMBER);
		log("@ _OPS_NAME=" + _OPS_NAME);

		var bookmarkDatas = JSON.parse(CONTROL.save_target("bookmark"));

		if (bookmarkDatas === null)  CONTROL.save_target("bookmark", JSON.stringify({"bookmark" : []}));

		var thumbnailImage = document.createElement("img"),
			thumbContainerWidth = $("#thumbnail").width(),
			thumbnailMargin = 30, thumbnailCount, thumbnailLine, thumbnailIndex = 0;

			thumbnailImage.src = epubDirPath + _OPS_NAME + "/" + ViewerManager.thumbnails[0];

		thumbnailImage.onload = function () {
			log("@ thumbnailImage.width : ");
			log(thumbnailImage.width);

			var thumbnailImageWidth = thumbnailImage.width;
			if (thumbnailImageWidth > 120) thumbnailImageWidth = thumbnailImage.width * 0.5;

			log("@ thumbContainerWidth : ");
			log(thumbContainerWidth);

			thumbnailCount = thumbContainerWidth / (thumbnailImageWidth + thumbnailMargin);
			thumbnailCount = Math.round(thumbnailCount);

			log("@ thumbnailCount : ");
			log(thumbnailCount);

			thumbnailLine = _PAGE_TOTAL_NUMBER / (thumbnailCount - 1);

			log(thumbnailLine);
			thumbnailLine = Math.ceil(thumbnailLine);

			log("@ thumbnailLine : ");
			log(thumbnailLine);

			for (var i = 0; i < thumbnailLine; i++) {
				var	thumbnailLineDiv = document.createElement("div");
				for (var z = 0; z < thumbnailCount - 1; z++) {
					if (_PAGE_TOTAL_NUMBER > thumbnailIndex) {

						var tempThumbnailDiv = document.createElement("div"),
							tempThumbnailImage = document.createElement("img"),
							tempThumbnailBookmark = document.createElement("img"),
							tempThumbnailNumber = document.createElement("div");

							tempThumbnailDiv.className = "thumbnailDiv";
							tempThumbnailImage.src = epubDirPath + _OPS_NAME + "/" + ViewerManager.thumbnails[thumbnailIndex];
							tempThumbnailImage.width = thumbnailImageWidth;
							tempThumbnailDiv.appendChild(tempThumbnailImage);
							tempThumbnailDiv.alt = "섬네일 " + (ViewerManager.transRealToVirtualPageIndex(thumbnailIndex + 1)) + "페이지";
							tempThumbnailDiv.title = "섬네일 " + (ViewerManager.transRealToVirtualPageIndex(thumbnailIndex + 1)) + "페이지";

							tmpPageBookmark = "images/bookmark/img_bookmark.png";

							for (var l = 0; l < bookmarkDatas.bookmark.length; l++) {
								var pageNo = bookmarkDatas.bookmark[l].pageNo == undefined ? parseInt(bookmarkDatas.bookmark[l].pageNum) : parseInt(bookmarkDatas.bookmark[l].pageNo);
								pageNo = bookmarkDatas.bookmark[l].pageno == undefined ? parseInt(pageNo) : parseInt(bookmarkDatas.bookmark[l].pageno);
								if (ViewerManager.GetData.EPUB.ID == bookmarkDatas.bookmark[l].bookId && (thumbnailIndex + 1) === pageNo) {
									tmpPageBookmark = "images/bookmark/img_bookmark_over.png";
								}
							}

							tempThumbnailBookmark.src = tmpPageBookmark;
							tempThumbnailBookmark.className = "thumbnailBookmark";
							tempThumbnailDiv.appendChild(tempThumbnailBookmark);

							tempThumbnailNumber.innerHTML = ViewerManager.transRealToVirtualPageIndex(thumbnailIndex + 1);
							// 여기에서 진도율 체크
							if (ViewerManager.GetData.PROGRESS.progressRate == "true") {
								if (ViewerManager.GetData.PROGRESS.progressRateType == "Order") {
									// 순차 진도율
									if (ViewerManager.GetData.PROGRESS.progressRateArray[thumbnailIndex] == "Y") {
										tempThumbnailNumber.className = "thumbnailNumber viewed";
									} else {
										tempThumbnailNumber.className = "thumbnailNumber";
									}
								} else if (ViewerManager.GetData.PROGRESS.progressRateType == "OutOfOrder") {
									// 비순차 진도율
									if (ViewerManager.GetData.PROGRESS.progressRateArray[thumbnailIndex] == "Y") {
										tempThumbnailNumber.className = "thumbnailNumber viewed";
									} else {
										tempThumbnailNumber.className = "thumbnailNumber";
									}
								}
							}
							tempThumbnailNumber.className = "thumbnailNumber";
							tempThumbnailDiv.appendChild(tempThumbnailNumber);

						thumbnailLineDiv.appendChild(tempThumbnailDiv);

						if (thumbnailIndex === parseInt(ViewerManager.PAGE_CURRENT_NUMBER) - 1) {
							tempThumbnailNumber.setAttribute("style", "background:#027afe");
						}

						tempThumbnailDiv.addEventListener("click", function (e) {
							// ViewerManager.progressType  == 0, 순차 진도 모드 (순차 진도 모드에서는 페이지 이동 물가)
							if (ViewerManager.progressType === "0" && ViewerManager.progressComplete === "N") {
								$("#currentModeNotice").text(ViewerManager.Local.indexListLinkAlert).fadeIn(300, function () {
									var noticeTimer = setTimeout(function () {
										$("#currentModeNotice").fadeOut(500);
										clearTimeout(noticeTimer);
									}, 1000);
								});
							} else {
								if ($('#drawing_container').css("display") === "block") {
									draw.saveCanvasData(ViewerManager.PAGE_CURRENT_NUMBER);
									draw.offDrawMode();
									draw.hideDrawMenu();
								}

								var this_pagenumber = ViewerManager.transVirtualToRealPageIndex(parseInt( $(e.currentTarget).children('div').text()));
								log("selected Thumbnail index  ==> " + parseInt($(e.currentTarget).children('div').text()) + " : " + this_pagenumber);

								ViewerManager.PAGE_CURRENT_NUMBER = this_pagenumber;
								ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER;

								if (ViewerManager.pageMODE === "DOUBLE" && ViewerManager.isOddCheck(ViewerManager.PAGE_CURRENT_NUMBER)) {
									ViewerManager.PAGE_CURRENT_NUMBER = parseInt(ViewerManager.PAGE_CURRENT_NUMBER) + 1;
									ViewerManager.sliderValue = ViewerManager.PAGE_CURRENT_NUMBER + 1;
								}

								ViewerManager.pageLoading(ViewerManager.PAGE_CURRENT_NUMBER, ViewerManager.PAGE_TOTAL_NUMBER);

								$("#thumb_container").fadeOut("fast", function () {
									$('#thumbnail').empty();
								});
							}
						}, false);

						thumbnailIndex++;
					}
				}
				thumbnailLineDiv.className = "thumbnailLineDiv";
				document.querySelector("#thumbnail").appendChild(thumbnailLineDiv);
			}

			$(".thumbnailNumber").css("width", thumbnailImageWidth);
			var thumbnailTotalWidth = (thumbnailImageWidth + thumbnailMargin) * (thumbnailCount - 1);
			$("#thumbnail").css("left", ((thumbContainerWidth - thumbnailTotalWidth) - 15) / 2 + "px");
		};
	};


	var exportThumbnail = {
		thumbnailList : thumbnailList
	};

	return exportThumbnail;
});
