
define(['jquery', 'log', 'browser'], function ($, log, browser) {
	'use strict';

	log("\n @ import zoom.js ... \n");

	if (browser.ie8)
	{
		return;
	}

	ViewerManager.zoomScore = 1;
	var prevOffset_left, prevOffset_top, push_left, push_top, moved_left =0;
	var pushed, lastClientX, lastClientY, touches,
		zoomStart = function (event) {
		
			event.preventDefault();
			event.stopPropagation();

			/*touches = event.touches == undefined ? event.originalEvent.touches : event.touches;

			lastClientX = touches == undefined ? event.clientX : touches[0].clientX;
			lastClientY = touches == undefined ? event.clientY : touches[0].clientY;*/

			lastClientX = event.originalEvent.touches ? event.originalEvent.changedTouches[0].clientX : event.clientX;
			lastClientY = event.originalEvent.touches ? event.originalEvent.changedTouches[0].clientY : event.clientY;

			push_left = $('#content').offset().left == 'auto' ? prevOffset_left : $('#content').offset().left;
			push_top = $('#content').offset().top;

			pushed = true;
		},
		zoomIng = function (event) {
			if (pushed) {
				/*touches = event.touches == undefined ? event.originalEvent.touches : event.touches;
				var moveX = touches == undefined ? event.clientX : touches[0].clientX;
				var moveY = touches == undefined ? event.clientY : touches[0].clientY;*/

				var moveX = event.originalEvent.touches ? event.originalEvent.changedTouches[0].clientX : event.clientX;
				var moveY = event.originalEvent.touches ? event.originalEvent.changedTouches[0].clientY : event.clientY;

				var move_left = push_left - (lastClientX - moveX);
				var move_top = push_top - (lastClientY - moveY);

				if (move_left > 0) { move_left = 0; }
				if (move_left < prevOffset_left * 2) { move_left = prevOffset_left * 2; }
				if (move_top >0) { move_top = 0; }
				if (move_top < prevOffset_top * 2) { move_top = prevOffset_top * 2; }

				$('#content').offset({left:move_left, top:move_top});
			}
		},
		zoomEnd = function (event) {
			pushed = false;
		},
		initZoom = function () {
			/*window.addEventListener("mousedown", zoomStart, false);
			window.addEventListener("mouseup", zoomEnd, false);
			window.addEventListener("mousemove", zoomIng, false);*/
			$("#expandMode").show();
			$(".btnMove").attr("src","images/titan_bottomMenu/movePageIcon02.png");
			if (browser.ie9 || browser.ie10 || browser.isMobile.iPhone || browser.isMobile.iPad || browser.isMobile.iPod || browser.isMobile.androidPhone || browser.isMobile.androidTablet)
			{

				if ($('#zoomArea').attr('data') == undefined) {
					$("#container").append("<div id='zoomArea' data='make' style='width:" + ViewerManager.bookContainerWidth + "px; height:" + ViewerManager.bookContainerHeight + "px; position:absolute; z-index:10; background:#000; opacity:0;'></div>");
				}
				else {
					$("#zoomArea").css('display', 'block');
				}
			}

			if (browser.isMobile.iPhone || browser.isMobile.iPad || browser.isMobile.iPod || browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
				$('#zoomArea').bind("touchstart", zoomStart).bind("touchend", zoomEnd).bind("touchmove", zoomIng);
			} else {
				$(window).bind("mousedown", zoomStart).bind("mouseup", zoomEnd).bind("mousemove", zoomIng);
			}

			getPageThumbnail("miniMap", document.getElementById("miniMap"), ViewerManager.PAGE_CURRENT_NUMBER, (browser.chrome ? ViewerManager.zoomRate * 0.1 : 0.1));

			
		},
		clearZoom = function () {
			$("#expandMode").hide();
			ViewerManager.zoomScore = 1;
			$("#content").css({
				"transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-o-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-ms-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-webkit-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-moz-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")"
			});

			$('#content').offset({left:0, top:0});

			$("#pages, #drawing_container").css({
				/*"-ms-transform": "none",
				"-webkit-transform": "none",
				"transform": "none",*/
				"transform-origin": "0% 0%",
				"-webkit-transform-origin": "0% 0%",
				"-moz-transform-origin": "0% 0%",
				"-o-transform-origin": "0% 0%",
				"-ms-transform-origin": "0% 0%"
			});
			$("#content").css("overflow", "hidden");
			$("#drawing_container").css({
				"pointer-events": "none",
				"cursor": "default"
			});
			$("#components").css("pointer-events", "auto");
			$("#zoomArea").css('display', 'none');

			$(".zoomIn").css("display", "block");
			$(".zoomIn").parent().css("width", "52px");
			$(".zoomOut").css("display", "none");
			$(".zoomOut").parent().css("width", "0px");

			if (browser.isMobile.iPhone || browser.isMobile.iPad || browser.isMobile.iPod || browser.isMobile.androidPhone || browser.isMobile.androidTablet) {
				$('#zoomArea').unbind("touchstart", zoomStart).unbind("touchend", zoomEnd).unbind("touchmove", zoomIng);
			} else {
				$(window).unbind("mousedown", zoomStart).unbind("mouseup", zoomEnd).unbind("mousemove", zoomIng);
			}

			/*window.removeEventListener("mousedown", zoomStart, false);
			window.removeEventListener("mouseup", zoomEnd, false);
			window.removeEventListener("mousemove", zoomIng, false);*/

			$("#miniMap_container").fadeOut("fast", function () {
				document.getElementById("miniMap").innerHTML = "";
			});
		},
		getPageThumbnail = function (thumbnailType, parentElement, PAGE_CURRENT_NUMBER, scale) {
			log("@ create getPageThumbnail...");

			if (!document.querySelector("#miniMap")) return;

			var setContentDocumentStyle = function (targetName) {
				$(targetName).contents().find('body').css({
					"position": "absolute",
					"background": ((PAGE_CURRENT_NUMBER - 1) === 0 && targetName === "#leftThumbnail" && ViewerManager.pageMODE === "DOUBLE" || (PAGE_CURRENT_NUMBER - 1) === ViewerManager.PAGE_TOTAL_NUMBER && targetName === "#rigthThumbnail" ? "url('images/coverBg.png')" : "#FFFFFF"),
					"padding": "0px",
					"margin": "0px"
				});
			},
			thumbnailElement = document.createElement("div");
			thumbnailElement.innerHTML = "<iframe id='leftThumbnail' frameborder='0' scrolling='no' style='overflow: hidden;'></iframe><iframe id='rigthThumbnail' frameborder='0' scrolling='no' style='overflow: hidden;'></iframe>";

			switch (thumbnailType) {
				case "miniMap":
					parentElement.appendChild(thumbnailElement);
					break;
				case "webPrint":
					try {
						parentElement.document.body.appendChild(thumbnailElement);
						var thumbnailCanvas = document.createElement("div");
						thumbnailCanvas.innerHTML = "<canvas id='thumbnailCanvas'></canvas>";
						parentElement.document.body.appendChild(thumbnailCanvas);
					} catch (e) {
						log("@ getPageThumbnail error : " + e);
					}
				break;
			}
			thumbnailElement.setAttribute("id", "miniMap_container");

			var leftThumbnail = thumbnailElement.querySelector("#leftThumbnail"),
				adjustPageNum = (ViewerManager.pageMODE === "SINGLE" ? 0 : 1),
				rigthThumbnail;

			leftThumbnail.contentDocument.open('text/html', 'replace');
			leftThumbnail.contentDocument.write(ViewerManager.pageHTMLData[parseInt(PAGE_CURRENT_NUMBER) - adjustPageNum][1]);
			leftThumbnail.contentDocument.close();
			setContentDocumentStyle("#leftThumbnail");

			if (ViewerManager.pageMODE === "DOUBLE") {
				rigthThumbnail = thumbnailElement.querySelector("#rigthThumbnail");

				rigthThumbnail.contentDocument.open('text/html', 'replace');
				rigthThumbnail.contentDocument.write(ViewerManager.pageHTMLData[parseInt(PAGE_CURRENT_NUMBER)][1]);
				rigthThumbnail.contentDocument.close();
				setContentDocumentStyle("#rigthThumbnail");

				rigthThumbnail.onload = function () {
					rigthThumbnail.setAttribute("style", "width:" + rigthThumbnail.contentDocument.body.scrollWidth + "px; height:" + rigthThumbnail.contentDocument.body.scrollHeight + "px;");
				};
			}

			if (thumbnailType === "miniMap") {
				var renderMiniMap = function () {
					if (ViewerManager.pageMODE === "SINGLE") {
						var left_margin = (document.body.scrollWidth, leftThumbnail.contentDocument.body.scrollWidth) / 2;

						thumbnailElement.setAttribute("style", "width:" + (document.body.scrollWidth * 2) + "px; height:" + leftThumbnail.contentDocument.body.scrollHeight + "px; left: 50px; top: 80px; -ms-transform:scale(" + scale + "); -webkit-transform:scale(" + scale + "); transform:scale(" + scale + "); transform-origin:0% 0%; -webkit-transform-origin:0% 0%; -ms-transform-origin:0% 0%; margin: 0px; padding: 0px; overflow: hidden;");
						leftThumbnail.setAttribute("style", "width:" + leftThumbnail.contentDocument.body.scrollWidth + "px; height:" + leftThumbnail.contentDocument.body.scrollHeight + "px; margin-left : " + left_margin + "px;");

						$("#miniMap_container").css("visibility", "visible");

						$("#miniMap").append("<div id='miniMapMenu1'><img src='images/titan_bottomMenu/selectTextIcon01.png'></div><div id='miniMapMenu2'><img src='images/titan_bottomMenu/movePageIcon01.png'></div>");
						$("#miniMapMenu1").css({
							"width" : (leftThumbnail.contentDocument.body.scrollWidth * scale) + "px",
							"top": "-" + ((leftThumbnail.contentDocument.body.scrollHeight * scale) + 25) + "px"
						});
						$("#miniMapMenu2").css({
							"width" : (leftThumbnail.contentDocument.body.scrollWidth * scale) + "px",
							"left" : (leftThumbnail.contentDocument.body.scrollWidth * scale) + "px",
							"top": "-" + ((leftThumbnail.contentDocument.body.scrollHeight * scale) + 25) + "px"
						});
					} else {
						var zoom_rate = 0.05;

						thumbnailElement.setAttribute("style", "width:" + (window.innerWidth * ViewerManager.zoomScore) + "px; height:" + (window.innerHeight * ViewerManager.zoomScore) + "px; left: 50px; top: 80px; -ms-transform:scale(" + zoom_rate + "); -webkit-transform:scale(" + zoom_rate + "); transform:scale(" + zoom_rate + "); transform-origin:0% 0%; -webkit-transform-origin:0% 0%; -ms-transform-origin:0% 0%; margin: 0px; padding: 0px; overflow: hidden;");
						leftThumbnail.setAttribute("style", "width:" + leftThumbnail.contentDocument.body.scrollWidth + "px; height:" + leftThumbnail.contentDocument.body.scrollHeight + "px;");

						var right_w, right_h;

						$("#miniMap_container").css("visibility", "visible");

						if (parseInt(PAGE_CURRENT_NUMBER) === parseInt(ViewerManager.PAGE_TOTAL_NUMBER) + 1) {
							right_w = rigthThumbnail.contentDocument.body.scrollWidth;
							right_h = rigthThumbnail.contentDocument.body.scrollHeight;
							rigthThumbnail.setAttribute("style", "width:" + right_w  + "px; height:" + right_h + "px;");
						}
						else
						{
							right_w = leftThumbnail.contentDocument.body.scrollWidth;
							right_h = leftThumbnail.contentDocument.body.scrollHeight;
							rigthThumbnail.setAttribute("style", "width:" + right_w  + "px; height:" + right_h + "px; position:absolute;");
						}

						var left_margin = ((document.body.scrollWidth * 2) - (leftThumbnail.contentDocument.body.scrollWidth + right_w)) / 2;

						$('#leftThumbnail').css({'margin-left': left_margin + 'px'});
						$('#rigthThumbnail').css({'margin-left': left_margin + 'px'});

						/*$("#miniMap").append("<div id='miniMapMenu1'><img src='images/titan_bottomMenu/selectTextIcon01.png'></div><div id='miniMapMenu2'><img src='images/titan_bottomMenu/movePageIcon01.png'></div>");
						$("#miniMapMenu1").css({
							"width" : (leftThumbnail.contentDocument.body.scrollWidth * scale) + (((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager.zoomRate) / 2) * scale) / 2 + "px",
							"top": "-" + ((leftThumbnail.contentDocument.body.scrollHeight * scale) + 30) + "px"
						});
						$("#miniMapMenu2").css({
							"width" : (leftThumbnail.contentDocument.body.scrollWidth * scale) + (((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager.zoomRate) / 2) * scale) / 2 + "px",
							"left" : (leftThumbnail.contentDocument.body.scrollWidth * scale) + (((ViewerManager.bookContainerWidth - (ViewerManager.bookContainerWidth / ViewerManager._zoom_horizontal) * ViewerManager.zoomRate) / 2) * scale) / 2 + "px",
							"top": "-" + ((leftThumbnail.contentDocument.body.scrollHeight * scale) + 30) + "px"
						});*/
					}

					$("#miniMapMenu2").find("img").attr("src", "images/titan_bottomMenu/movePageIcon02.png");

					$("#miniMapMenu1").on("click", function () {
						$("#miniMapMenu1").find("img").attr("src", "images/titan_bottomMenu/selectTextIcon02.png");
						$("#miniMapMenu2").find("img").attr("src", "images/titan_bottomMenu/movePageIcon01.png");
						$("#drawing_container").css("pointer-events", "none");
					});

					$("#miniMapMenu2").on("click", function () {
						$("#miniMapMenu1").find("img").attr("src", "images/titan_bottomMenu/selectTextIcon01.png");
						$("#miniMapMenu2").find("img").attr("src", "images/titan_bottomMenu/movePageIcon02.png");
						$("#drawing_container").css("pointer-events", "auto");
					});
				};

				if (leftThumbnail.contentDocument.body === null) {
					var frameTimer = setInterval(function () {
						if (leftThumbnail.contentDocument.body !== null) {
							renderMiniMap();
							clearTimeout(frameTimer);
						}
					}, 100);

				} else {
					renderMiniMap();
				}

			} else {
				var webPrintTimer = setTimeout(function () {
					thumbnailElement.setAttribute("style", "width:" + (rigthThumbnail.contentDocument.body.scrollWidth + leftThumbnail.contentDocument.body.scrollWidth) + "px; left: 0px; top: 0px; -ms-transform:scale(" + scale + "); -webkit-transform:scale(" + scale + "); transform:scale(" + scale + "); transform-origin:0% 0%; -webkit-transform-origin:0% 0%; -ms-transform-origin:0% 0%; margin: 0px; padding: 0px; overflow: hidden; position:absolute;");
					leftThumbnail.setAttribute("style", "width:" + leftThumbnail.contentDocument.body.scrollWidth + "px; height:" + rigthThumbnail.contentDocument.body.scrollHeight + "px;");
					rigthThumbnail.setAttribute("style", "width:" + rigthThumbnail.contentDocument.body.scrollWidth + "px; height:" + leftThumbnail.contentDocument.body.scrollHeight + "px;");

					clearTimeout(webPrintTimer);
				}, 100);
			}
		},
		setPreviewArea = function (zoomScore) {
			if (!document.querySelector("#miniMap")) return;

			var delPreviewAre = function () {
				if (document.querySelector(".miniMapPreview") !== null) {
					$(".miniMapPreview").remove();
				}
			},
			miniMapPreview = document.createElement("div");
			miniMapPreview.className = "miniMapPreview";
			zoomScore = zoomScore - 0.1;
			miniMapPreview.setAttribute("style", "width:" + ((leftThumbnail.contentDocument.body.scrollWidth * 2) / zoomScore) + "px; height:" + ((leftThumbnail.contentDocument.body.scrollHeight * 1) / zoomScore) + "px; margin: 0px; top: 0px");

			delPreviewAre();
			document.getElementById('miniMap_container').appendChild(miniMapPreview);
		},
		repositionPreviewArea = function (scrollLeft, scrollTop) {
			// 위치 이동부분
			var rate = ViewerManager.pageMODE === "SINGLE" ? 2 : 2;
			$(".miniMapPreview").css({
				"left" : (scrollLeft * 2 / ViewerManager.zoomScore) + "px",
				"top" : (scrollTop * 2 / ViewerManager.zoomScore) + "px"
			});
		},
		noticeZoomRate = function () {
			//$("#header_title").text(ViewerManager.Local.noticeZoomRate + (ViewerManager.zoomScore.toFixed(1) * 10) + "0 %");
			//$("#header_title").text((ViewerManager.zoomScore.toFixed(1) * 10) + "0 %");
		},
		zoomViewportCenterAlign = function () {
			log("@ zoomViewportCenterAlign!");

			$("#content").css({
				"transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-o-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-ms-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-webkit-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")",
				"-moz-transform": "scale(" + ViewerManager.zoomScore + "," + ViewerManager.zoomScore + ")"
			});

			if (ViewerManager.zoomScore != 1) {
				prevOffset_left = ($("#content").width() - $("#content").width() * ViewerManager.zoomScore) / 2;
				prevOffset_top = ($("#content").height() - $("#content").height() * ViewerManager.zoomScore) / 2;
			}
			else if (ViewerManager.zoomScore == 1) {
				$('#content').offset({left:0, top:0});

				window.removeEventListener("mousedown", zoomStart, false);
				window.removeEventListener("mouseup", zoomEnd, false);
				window.removeEventListener("mousemove", zoomIng, false);
			}
		};


	var exportZoom = {
		initZoom : initZoom,
		clearZoom : clearZoom,
		setPreviewArea : setPreviewArea,
		noticeZoomRate : noticeZoomRate,
		zoomViewportCenterAlign : zoomViewportCenterAlign,
		getPageThumbnail : getPageThumbnail
	};
	return exportZoom;
});
