define(["jquery", "log"], function(e, a) {
    "use strict";

    var l = function(sns, txt, url) {
    	var o;
    	var domain = document.domain;
    	var _txt = encodeURIComponent(txt);
        var _url = encodeURIComponent(url);
        var _br  = encodeURIComponent("\r\n");
        var isAndroid = navigator.userAgent.match(/android/i);
        var isApple = navigator.userAgent.match(/(iphone)|(ipod)|(ipad)/i);
        
        switch(sns) {
            case "facebook": //페이스북(PC/모바일)
                o = {
                    method: "popup",
                    url: "http://www.facebook.com/sharer/sharer.php?u=" + _url
                };
                break;
            case "twitter": //트위터(PC/모바일)
                o = {
                    method: "popup",
                    url: "http://twitter.com/intent/tweet?text=" + _txt + '&url=' + _url
                };
                break;
            case "google+": //구글플러스(PC/모바일)
            	o = {
            		method: "popup",
            		url: "https://plus.google.com/share?url=" + _url + "&t=" + _txt
            	};
            	break;
            case "kakaotalk": //카카오톡(모바일전용)
            	/* 로컬 테스트용
            	 * domain = domain.replace("localhost", "ebms.k2web.co.kr").replace("192.168.250.29", "ebms.k2web.co.kr");
            	 */
            	if(isAndroid || isApple) {
            		Kakao.Link.sendDefault({
            			objectType: "feed",
            			content: {
            				title: txt,
            				description: "Viewer로 링크됩니다.",
            				imageUrl: "http://" + domain + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/" + ViewerManager.thumbnails[0],
            				link : {
            					webUrl: url,
            					mobileWebUrl: url
            				}//,
            				//imageWidth: 100,
            				//imageHeight: 133
            			},
            			installTalk : true
            		});
            	} else {
            		o = {
            			method: "web2app"
            		};
            	}
            	break;
            case "kakaostory": //카카오스토리(PC/모바일)
            	/* 로컬 테스트용
            	 * url = url.replace("localhost", "ebms.k2web.co.kr").replace("192.168.250.29", "ebms.k2web.co.kr");
            	 * domain = domain.replace("localhost", "ebms.k2web.co.kr").replace("192.168.250.29", "ebms.k2web.co.kr");
            	 */
                if(isAndroid || isApple) {
            		Kakao.Story.open({
            			text: txt,
            			url: url,
            			urlInfo: {
            				title: txt,
            				desc: "Viewer로 링크됩니다.",
            				images: ["http://" + domain + ViewerManager.Path.cntsDirPath + ViewerManager.Path.cntsFilePath + ViewerManager.ePub.ops_name[0] + "/" + ViewerManager.thumbnails[0]]
            			}
            		});
            	} else {
            		Kakao.Story.share({
            			text: txt,
            			url: url
            		});
            	}
            	break;
            case "band": //네이버밴드(PC/모바일)
            	if(isAndroid || isApple) {
            		o = {
                        method: "web2app",
                        param: "create/post?text=" + _txt + _br + _url,
                        a_store: "itms-apps://itunes.apple.com/app/id542613198?mt=8",
                        g_store: "market://details?id=com.nhn.android.band",
                        a_proto: "bandapp://",
                        g_proto: "scheme=bandapp;package=com.nhn.android.band"
                    };
            	} else {
            		o = {
            			method: "popup",
            			url: "http://www.band.us/plugin/share?body=" + _txt + "&route=" + _url
            		};
            	}
                break;
            case "simpleLink":
            	var simpleLinkUrl = document.querySelector("#simpleLinkUrl");
            	(simpleLinkUrl.select(), document.execCommand("copy"), alert("복사되었습니다."));
            	break;
            default:
                alert("지원하지 않는 SNS입니다.");
                return false;
        }
     
        if(o) {
	        switch(o.method) {
	            case "popup":
	                window.open(o.url);
	                break;
	            case "web2app":
	                if(isAndroid) { //Android
	                    setTimeout(function(){ location.href = "intent://" + o.param + "#Intent;" + o.g_proto + ";end"}, 100);
	                } else if(isApple) { //Apple
	                    setTimeout(function(){ location.href = o.a_store; }, 200);          
	                    setTimeout(function(){ location.href = o.a_proto + o.param }, 100);
	                } else {
	                    alert("이 기능은 모바일에서만 사용할 수 있습니다.");
	                }
	                break;
	        }
        }
    }

    var A = {
    	shareSns: l
    };
    return A;
});
